using System;
using System.Collections.Generic;
using System.Text;
using RegexManipulator;
using Tao.OpenGl;

namespace GTG
{
	class AugmentedReducedDFA : ReducedDFA
	{
		public AugmentedReducedDFA(NativeDFA dfa)
			: base(dfa)
		{
		}
		public GTG GetGTG()
		{
			GTG gtg = new GTG();
			gtg.CharacterSet = "[" + (char)MinChar + "-" + (char)MaxChar + "]";
			for (int i = 0; i < this.AdjacencyList.Length; i++)
				gtg.States.Add(new State(new Point2F(0, 0)));
			gtg.States[0].IsStart = true;
			for (int i = 0; i < gtg.States.Count; i++)
			{
				State state = gtg.States[i];
				state.IsAccept = IsAcceptanceState[i];
				for (int j = 0; j < AdjacencyList[i].List.Count; j++)
				{
					TransitionEdge transitionEdge = (TransitionEdge)AdjacencyList[i].List[j];
					if (transitionEdge.State == -1)
						continue;
					else if (i == transitionEdge.State)
						state.SelfEdge = Edge.CreateLabelledEdge(
							gtg.CharacterSet,
							transitionEdge.ToString(),
							state,
							state);
					else
					{
						Edge edge = Edge.CreateLabelledEdge(
							gtg.CharacterSet,
							transitionEdge.ToString(),
							state,
							gtg.States[transitionEdge.State]
							);
						state.OutEdges.Add(edge);
						gtg.States[transitionEdge.State].InEdges.Add(edge);
					}
				}
			}
			return gtg;
		}
	}
}
