using System;
using System.Drawing;

namespace Tao.OpenGl
{
	/// <summary>
	/// Summary description for Point2F.
	/// </summary>
	[Serializable]
	public class Point2F
	{
		public float x;
		public float y;

		public Point2F()
		{
			x = y = 0.0f;
		}
		public Point2F(float xx, float yy)
		{
			x = xx;
			y = yy;
		}
		public void Set(float xx, float yy)
		{
			x = xx;
			y = yy;
		}

		public static Vector2F operator -(Point2F pt1, Point2F pt2)
		{
			return new Vector2F(pt1.x - pt2.x, pt1.y - pt2.y);
		}
		public void Offset(float dx, float dy)
		{
			x += dx;
			y += dy;
		}
		static public implicit operator PointF(Point2F p)
		{
			return new PointF(p.x, p.y);
		}
		public bool HasSameCoordinates(Point2F p)
		{
			return x == p.x && y == p.y;
		}
		/*
		public void Draw()
		{
			Gl.glBegin(Gl.GL_POINTS);
			Gl.glVertex2f(x, y);
			Gl.glEnd();
		}*/

		public override string ToString()
		{
			return string.Format("({0},{1})",x,y);
		}
        public Point2F Clone()
        {
            return new Point2F(x, y);
        }
        /*
		public void glTellTexCoord2f()
		{
			Gl.glTexCoord2f(x, y);
		}*/

	}

/*	class PointF
	{
		private float x;
		private float y;

		public PointF(float x, float y) 
		{
			this.x = x;
			this.y = y;
		}

		public virtual bool Equals(object obj) 
		{
			PointF pt;

			if (obj as PointF == null)
				return 0;
			pt = (PointF) obj;
			if (pt.X == this.X && pt.Y == this.Y)
				return pt.GetType().Equals(this.GetType());
			return 0;
		}
		
		internal void Offset(float dx, float dy) 
		{
			x = x + dx;
			y = y + dy;
		}
		
		public static PointF op_Addition(PointF pt, Size sz) 
		{
			return new PointF(pt.X + (float) sz.Width, pt.Y + (float) sz.Height);
		}

		public static bool op_Equality(PointF left, PointF right) 
		{
			if (left.X == right.X)
				return left.Y == right.Y;
			return 0;
		}


		static PointF empty;
	}
*/
}
