using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using RegexManipulator;

namespace GTG
{
	public partial class RegexLogicManipulator : Form
	{
		public RegexLogicManipulator()
		{
			InitializeComponent();
		}

		private void toolBtnConvert_Click(object sender, EventArgs e)
		{
			try
			{
				string charSet = txtCharSet.Text;
				string regex1 = txtRegex1.Text;
				string regex2 = txtRegex2.Text;

				txtDFA.Clear();

				txtDFA.Text += "The first DFA:\r\n";
				NativeDFA dfa1 = new NativeDFA(regex1, charSet, chkMinimize.Checked);
				txtDFA.Text += dfa1.ToString();

				txtDFA.Text += "\r\n";

				txtDFA.Text += "The second DFA:\r\n";
				NativeDFA dfa2 = new NativeDFA(regex2, charSet, chkMinimize.Checked);
				txtDFA.Text += dfa2.ToString();

				txtDFA.Text += "\r\n";

				txtDFA.Text += "The ANDed DFA:\r\n";
				NativeDFA dfa = NativeDFA.And(dfa1, dfa2);
				txtDFA.Text += dfa.ToString();

				AugmentedReducedDFA rdfa = new AugmentedReducedDFA(dfa);
				GTG gtg = rdfa.GetGTG();

				SimplifiedGTG sgtg = gtg.ToSimplifiedGTG();
				string regex;
				if (!sgtg.Process(out regex))
					throw new Exception("Unknown error.");
				else
					txtResult.Text = regex;
				
			}
			catch (Exception ex)
			{
				txtDFA.Clear();
				txtDFA.Text = ex.Message;
			}
		}

		private void toolbtnGTG_Click(object sender, EventArgs e)
		{
			string charSet = txtCharSet.Text;
			string regex1 = txtRegex1.Text;
			string regex2 = txtRegex2.Text;

			txtDFA.Clear();

			txtDFA.Text += "The first DFA:\r\n";
			NativeDFA dfa1 = new NativeDFA(regex1, charSet, chkMinimize.Checked);
			txtDFA.Text += dfa1.ToString();

			txtDFA.Text += "\r\n";

			txtDFA.Text += "The second DFA:\r\n";
			NativeDFA dfa2 = new NativeDFA(regex2, charSet, chkMinimize.Checked);
			txtDFA.Text += dfa2.ToString();

			txtDFA.Text += "\r\n";

			txtDFA.Text += "The ANDed DFA:\r\n";
			NativeDFA dfa = NativeDFA.And(dfa1, dfa2);
			txtDFA.Text += dfa.ToString();

			txtDFA.Text += "The Reduced DFA:\r\n";
			AugmentedReducedDFA rdfa = new AugmentedReducedDFA(dfa);
			txtDFA.Text += rdfa.ToString();

			GTG gtg = rdfa.GetGTG();
			((MainForm)this.MdiParent).ShowGTG(gtg);
		}

		private void btnClear_Click(object sender, EventArgs e)
		{
			txtResult.Clear();
			txtDFA.Clear();
		}

		private void btnNot_Click(object sender, EventArgs e)
		{
			try
			{
				string charSet = txtCharSet.Text;
				string regex = txtResult.Text;

				txtDFA.Clear();

				txtDFA.Text += "The Native DFA:\r\n";
				NativeDFA dfa = new NativeDFA(regex, charSet, chkMinimize.Checked);
				txtDFA.Text += dfa.ToString();

				txtDFA.Text += "\r\nThe Complemented DFA:\r\n";
				dfa.Complement();
				txtDFA.Text += dfa.ToString();

				txtDFA.Text += "\r\nThe Augmented DFA:\r\n";
				AugmentedReducedDFA rdfa = new AugmentedReducedDFA(dfa);
				txtDFA.Text += rdfa.ToString2();

				GTG gtg = rdfa.GetGTG();
				SimplifiedGTG sgtg = gtg.ToSimplifiedGTG();
				if (!sgtg.Process(out regex))
					throw new Exception("Unknown error.");
				else
					txtResult.Text = regex;

				((MainForm)this.MdiParent).ShowGTG(gtg);

			}
			catch (Exception ex)
			{
				txtDFA.Clear();
				txtDFA.Text = ex.Message;
			}
		}
	}
}