using System;
using System.Collections.Generic;
using System.Text;
using Fireball.Win32;

namespace Fireball.Drawing.GDI
{
    public class GDIBitmap:GDIObject
    {
        private IntPtr _hBmp;
        private int _width;
        private int _height;

        public GDIBitmap(IntPtr hBmp)
        {
            _hBmp = hBmp;
        }
        public GDIBitmap(string filename)
        {
            FreeImage img = new FreeImage(filename);
            IntPtr deskDC = NativeUser32Api.GetDC(new IntPtr(0));
            IntPtr destDC = NativeGdi32Api.CreateCompatibleDC(deskDC);
            IntPtr oldBmp = NativeGdi32Api.SelectObject(destDC, _hBmp);
            _hBmp = NativeGdi32Api.CreateCompatibleBitmap(destDC, img.Width, img.Height);
            img.PaintToDevice(destDC, 0, 0, img.Width, img.Height, 0, 0, 0, img.Height, 0);
            NativeGdi32Api.SelectObject(destDC, oldBmp);

            _width = img.Width;
            _height = img.Height;

            NativeGdi32Api.DeleteDC(deskDC);
            NativeGdi32Api.DeleteDC(destDC);
            img.DisposeAndSetHandle(0);

        }

        public IntPtr Handle
        {
            get
            {
                return _hBmp;
            }
        }
        public int Width
        {
            get
            {
                return _width;
            }
        }
        public int Height
        {
            get
            {
                return _height;
            }
        }

        protected override void Destroy()
        {
            if (_hBmp != (IntPtr)0)
            {
                NativeGdi32Api.DeleteObject(_hBmp);
            }

            base.Destroy();
            _hBmp = (IntPtr)0;
        }
        protected override void Create()
        {
            base.Create();
        }
    }


}
