﻿//Fireball.Windows.Forms.Toolbox is an Implementation of a toolbox 
//control like the whidbeytoolbox
//
//Copyright (C) 2004/2005 Sebastian Faltoni
//
//This library is free software; you can redistribute it and/or
//modify it under the terms of the GNU Lesser General Public
//License as published by the Free Software Foundation; either
//version 2.1 of the License, or (at your option) any later version.
//
//This library is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//Lesser General Public License for more details.
//
//You should have received a copy of the GNU Lesser General Public
//License along with this library; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  US

using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Drawing2D;

namespace Fireball.Windows.Forms.Toolbox
{
	internal class ItemsPanel : Control
	{
		ToolboxItemCollection m_Coll = null;

		public ItemsPanel(ref ToolboxItemCollection coll)
        {
            this.SetStyle(ControlStyles.AllPaintingInWmPaint
                | ControlStyles.UserPaint
                | ControlStyles.OptimizedDoubleBuffer
                | ControlStyles.ResizeRedraw
                | ControlStyles.ContainerControl
                , true);

			m_Coll = coll; 
        }

		protected override void OnPaint(PaintEventArgs e)
		{
			foreach (ToolboxItem item in m_Coll)
			{
				Size itemSize = new Size(this.Width, 20);

				Rectangle rectItem = new Rectangle(new Point(0, itemSize.Height)
					, itemSize);

				item.SetBounds(rectItem);

				item.Draw(e.Graphics);

			}
		}

	}
}
