﻿//Fireball.Windows.Forms.Toolbox is an Implementation of a toolbox 
//control like the whidbeytoolbox
//
//Copyright (C) 2004/2005 Sebastian Faltoni
//
//This library is free software; you can redistribute it and/or
//modify it under the terms of the GNU Lesser General Public
//License as published by the Free Software Foundation; either
//version 2.1 of the License, or (at your option) any later version.
//
//This library is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//Lesser General Public License for more details.
//
//You should have received a copy of the GNU Lesser General Public
//License along with this library; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  US

using System;
using System.Collections.Generic;
using System.Text;
using Fireball.Collections.Generic;
using sys = System;

namespace Fireball.Windows.Forms.Toolbox
{
	public class ToolboxCategoryCollection : ILightCollection<ToolboxCategory> 
	{
		public ToolboxCategoryCollection()
		{
			m_Coll = new LightCollection<ToolboxCategory>();
		}

		LightCollection<ToolboxCategory> m_Coll = null;

		#region ILightCollection<ToolboxCategory> Members

		public int IndexOf(ToolboxCategory item)
		{
			return m_Coll.IndexOf(item);
		}

		public void Insert(int index, ToolboxCategory item)
		{
			m_Coll.Insert(index, item);
		}

		public void RemoveAt(int index)
		{
			m_Coll.RemoveAt(index);
		}

		public ToolboxCategory this[int index]
		{
			get
			{
				return m_Coll[index];
			}
			set
			{
				m_Coll[index] = value;
			}
		}

		#endregion

		#region ILightCollection<ToolboxCategory> Members

		public int Add(ToolboxCategory item)
		{
			return m_Coll.Add(item);
		}

		public void Clear()
		{
			m_Coll.Clear();
		}

		public bool Contains(ToolboxCategory item)
		{
			return m_Coll.Contains(item);
		}

		public void CopyTo(ToolboxCategory[] array, int arrayIndex)
		{
			throw new Exception("The method or operation is not implemented.");
		}

		public int Count
		{
			get {
				return m_Coll.Count;	
			}
		}

		public bool IsReadOnly
		{
			get {
				return false;
			}
		}

		public bool Remove(ToolboxCategory item)
		{
			return m_Coll.Remove(item);
		}

		#endregion

		#region ILightCollection.IEnumerator Members

		public IEnumerator<ToolboxCategory> GetEnumerator()
		{
			return m_Coll.GetEnumerator();
		}

		#endregion

		#region ILightCollection<ToolboxCategory> Members

		public void AddRange(ToolboxCategory[] items)
		{
			m_Coll.AddRange(items);
		}

		public ToolboxCategory Find(Predicate<ToolboxCategory> match)
		{
			return m_Coll.Find(match);
		}

		public int IndexOf(ToolboxCategory item, int index)
		{
			return m_Coll.IndexOf(item, index);
		}

		public int IndexOf(ToolboxCategory item, int index, int count)
		{
			return m_Coll.IndexOf(item, index,count);
		}

		public ToolboxCategory[] GetItems()
		{
			return m_Coll.GetItems();
		}

		public ToolboxCategory[] GetItems(int startIndex)
		{
			return m_Coll.GetItems(startIndex);
		}

		public ToolboxCategory[] GetItems(int startIndex, int finalIndex)
		{
			return m_Coll.GetItems(startIndex,finalIndex);
		}

		#endregion

		#region ILightCollection<ToolboxCategory> Members

		public void CopyTo(Array array, int index)
		{
			m_Coll.CopyTo(array, index);
		}

		#endregion

        #region ILightCollection<ToolboxCategory> Members

        public void Move(ToolboxCategory item, int newIndex)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public void Move(int index, int newIndex)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public void Reverse(int index, int length)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public void Reverse()
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public void Swap(ToolboxCategory item1, ToolboxCategory item2)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public void Swap(int index1, int index2)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        #endregion

        #region ILightCollection<ToolboxCategory> Members

        public bool TryGetItem(int index, out ToolboxCategory item)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        #endregion
}
}
