using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace IDE.Forms.CCW
{
    public partial class GoToLineWindow : Form
    {
        public int LineNumber;
        private int validLinesMaximum;

        public GoToLineWindow(int numberOfLines)
        {
            InitializeComponent();

            validLinesMaximum = numberOfLines;
            lblLineNumber.Text += "( 1 - " + numberOfLines + " )";
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            try
            {
                LineNumber = int.Parse(txtLineNumber.Text);
            }
            catch
            {
                MessageBox.Show("Please enter a valid number between 1 and " + validLinesMaximum + ".", "Invalid Line Number", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtLineNumber.Focus();
                txtLineNumber.SelectAll();
                return;
            }

            if (LineNumber > validLinesMaximum || LineNumber < 1)
            {
                MessageBox.Show("Please enter a valid number between 1 and " + validLinesMaximum + ".", "Invalid Line Number", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtLineNumber.Focus();
                txtLineNumber.SelectAll();
                return;
            }
            this.Close();
        }
    }
}