using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace IDE.Forms.CCW
{
    public partial class NewItem : Form
    {
        public string FileName;
        private string fileExtension;

        public NewItem(string caption, string defaultFileExtension)
        {
            InitializeComponent();
            fileExtension = defaultFileExtension;
            if (defaultFileExtension != "")
                this.txtItemName.Text = "." + defaultFileExtension;
            this.Text += caption;
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            #region File Name Validation
            if (txtItemName.Text.Contains("/"))
            {
                MessageBox.Show(
                    "A valid file name can't contain a [/].",
                    "Invalid File Name",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error
                                );         
                return;
            }
            if (txtItemName.Text.Contains("\\"))
            {
                MessageBox.Show(
                    "A valid file name can't contain a [\\].",
                    "Invalid File Name",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error
                                );         
                return;
            }
            if (txtItemName.Text.Contains(":"))
            {
                MessageBox.Show(
                    "A valid file name can't contain a [:].",
                    "Invalid File Name",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error
                                );         
                return;
            }
            if (txtItemName.Text.Contains("?"))
            {
                MessageBox.Show(
                    "A valid file name can't contain a [?].",
                    "Invalid File Name",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error
                                );         
                return;
            }
            if (txtItemName.Text.Contains("<"))
            {
                MessageBox.Show(
                    "A valid file name can't contain a [<].",
                    "Invalid File Name",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error
                                );         
                return;
            }
            if (txtItemName.Text.Contains(">"))
            {
                MessageBox.Show(
                    "A valid file name can't contain a [>].",
                    "Invalid File Name",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error
                                );         
                return;
            }
            if (txtItemName.Text.Contains("|"))
            {
                MessageBox.Show(
                    "A valid file name can't contain a [|].",
                    "Invalid File Name",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error
                                );         
                return;
            }
            if (txtItemName.Text.Contains("*"))
            {
                MessageBox.Show(
                    "A valid file name can't contain a [*].",
                    "Invalid File Name",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error
                                );
                return;
            }
            if (txtItemName.Text.Contains("\""))
            {
                MessageBox.Show(
                    "A valid file name can't contain a [\"].",
                    "Invalid File Name",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error
                                );
                return;
            }
            #endregion

            if (fileExtension == "")
                goto END;

            if (txtItemName.Text.Substring(txtItemName.Text.Length - fileExtension.Length - 1) != "." + fileExtension)
            {
                DialogResult result = MessageBox.Show(
                                                        "The extension " + fileExtension + " will be appended to the file name.",
                                                        "Extension Missing",
                                                        MessageBoxButtons.YesNoCancel,
                                                        MessageBoxIcon.Warning
                                                      );
                if (result == DialogResult.Yes)
                    txtItemName.Text += "." + fileExtension;
                else if (result == DialogResult.Cancel)
                    return;
            }

         END:
            this.btnOK.DialogResult = DialogResult.OK;
            this.DialogResult = DialogResult.OK;
            this.FileName = txtItemName.Text;
            this.Close();
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.btnCancel.DialogResult = DialogResult.Cancel;
            this.DialogResult = DialogResult.Cancel;
            this.Close();
        }

        private void NewItem_Load(object sender, EventArgs e)
        {
            txtItemName.Focus();
            txtItemName.Select(0, 0);
        }
    }
}