﻿%option CharacterSet = [\x0-\x7Fأ-يأبتثجحخدذرزسشصضطظعغفقكلمنهويئءؤلاىآةوزظطكمنتالبييسشضصثثقففغغعههخحخحجد1233456767890ًٌَُّلإإ‘لأأٍِْلآ’]
%option Language = C#
%option ClassName = ArabicExpressionScanner
%option FunctionName = GetToken
%option ReturnType = _TokenType
%option FileName = D:\C++ projects\Compilers\ArabicExpression\Scanner
%option CompressionTechnique = Redundancy
%option EOFAction = _TokenType.EndOfFile
%option InvalidTokenAction = _TokenType.InvalidToken

Letter		[أيأبتثجحخدذرزسشصضطظعغفقكلمنهويئءؤلاىآةوزظطكمنتالبييسشضصثثقففغغعههخحخحجدًٌَُّلإإ‘لأأٍِْلآ]
//Next, we provide the macros...
WhiteSpace	(" "|[\t\r\n])+
Digit		[0-9]
Number		({Digit}+(","{Digit}+)?)|({Digit}*","{Digit}+)
Identifier	({Letter}|[_])({Digit}|{Letter})*
Pi			ط
Sin			جا
Cos			جتا				
Tan			ظا				
Cot			ظتا
Sec			قا
Csc			قتا
Sinh		[Ss][Ii][Nn][Hh]			
Cosh		[Cc][Oo][Ss][Hh]			
Tanh		[Tt][Aa][Nn][Hh]			
Coth		[Cc][Oo][Tt][Hh]			
Sech		[Ss][Ee][Cc][Hh]			
Csch		[Cc][Ss][Cc][Hh]				
Arcsin		[Aa][Rr][Cc][Ss][Ii][Nn]	
Arccos		[Aa][Rr][Cc][Cc][Oo][Ss]	
Arctan		[Aa][Rr][Cc][Tt][Aa][Nn]	
Arccot		[Aa][Rr][Cc][Cc][Oo][Tt]	
Arcsec		[Aa][Rr][Cc][Ss][Ee][Cc]	
Arccsc		[Aa][Rr][Cc][Cc][Ss][Cc]	
Arcsinh		[Aa][Rr][Cc][Ss][Ii][Nn][Hh]
Arccosh		[Aa][Rr][Cc][Cc][Oo][Ss][Hh]
Arctanh		[Aa][Rr][Cc][Tt][Aa][Nn][Hh]
Arccoth		[Aa][Rr][Cc][Cc][Oo][Tt][Hh]
Arcsech		[Aa][Rr][Cc][Ss][Ee][Cc][Hh]
Arccsch		[Aa][Rr][Cc][Cc][Ss][Cc][Hh]
Log			لو
Ln			[Ll][Nn]
%%
//Class Def
static void Main()
{
	string					fileName;
	StreamReader			sReader;
	ArabicExpressionScanner scanner;
	
	Console.Write("Enter file path: ");
	fileName = Console.ReadLine();
	sReader = new StreamReader(fileName, true);
	//Console.WriteLine(sReader.ReadLine());
	scanner = new ArabicExpressionScanner( sReader );
	scanner.GetToken();
	Console.WriteLine();
}
%%
 /*******************Machine Definition********************/
{WhiteSpace}	Console.Write(Lexeme);
{Number}		{
					Console.Write(Lexeme);
				}
"+"				{Console.Write(Lexeme);}
"-"				{Console.Write(Lexeme);}
"*"				{Console.Write(Lexeme);}
"\\"			{Console.Write('/');}
"%"				{Console.Write(Lexeme);}
"^"				{Console.Write(Lexeme);}
{Pi}			{Console.Write("Pi");}
{Sin}			{Console.Write("sin");}
{Cos}			{Console.Write("cos");}
{Tan}			{Console.Write("tan");}
{Cot}			{Console.Write("cot");}
{Sec}			{Console.Write("sec");}
{Csc}			{Console.Write("csc");}
{Sinh}			{Console.Write("sinh");}
{Cosh}			{Console.Write("cosh");}
{Tanh}			{Console.Write("tanh");}
{Coth}			{Console.Write("coth");}
{Sech}			{Console.Write("sech");}
{Csch}			{Console.Write("csch");}
{Arcsin}		{Console.Write("arcsin");}
{Arccos}		{Console.Write("arccos");}
{Arctan}		{Console.Write("arctan");}
{Arccot}		{Console.Write("arccot");}
{Arcsec}		{Console.Write("arcsec");}
{Arccsc}		{Console.Write("arccsc");}
{Arcsinh}		{Console.Write("arcsinh");}
{Arccosh}		{Console.Write("arccosh");}
{Arctanh}		{Console.Write("arctanh");}
{Arccoth}		{Console.Write("arccoth");}
{Arcsech}		{Console.Write("arcsech");}
{Arccsch}		{Console.Write("arccsch");}
{Log}			{Console.Write("log");}
ه				{Console.Write("e");}
{Ln}			{Console.Write("ln");}
{Identifier}	{
					Console.Write("Identifier");
				}
")"				{Console.Write(")");}
"("				{Console.Write("(");}
"]"				{Console.Write("]");}
"["				{Console.Write("[");}
,				{Console.Write(Lexeme);}
.				{Console.Write("InvalidToken");}
%%
//Inside namespace
enum _TokenType
{
	Number = 1,
	Identifier,
	Plus,
	Minus,
	Multiply,
	Divide,
	Moduolo,
	Power,
	Sin,
	Cos,
	Tan,
	Cot,
	Sec,
	Csc,
	Sinh,
	Cosh,
	Tanh,
	Coth,
	Sech,
	Csch,
	Arcsin,
	Arccos,
	Arctan,
	Arccot,
	Arcsec,
	Arccsc,
	Arcsinh,
	Arccosh,
	Arctanh,
	Arccoth,
	Arcsech,
	Arccsch,
	E,
	Ln,
	Log,
	Pi,
	Openpara,
	Closepara,
	OpenBracket, //[
	CloseBracket, //]
	Comma,
	EndOfFile,
	InvalidToken,
}
%%

%%