/*%option CharacterSet = [\d0-\d128 -1233456767890ő]*/
//using System.IO;
#include <iostream>
using namespace std;
#ifdef _UNICODE
#define tin wcin
#define tout wcout
#else
#define tin cin
#define tout cout
#endif

#ifndef _LEX_H_
#define _LEX_H_

#include "globals.h"
namespace Testing
{
class LineNumberer
{
	public:
		class CodeStream
		{
		private:
			tifstream& stream;
			stack<int> lines;
			stack<int> cols;
			stack<int> positions;
			int lineno;
			int column;
			int position;
		public:
			CodeStream(tifstream& _stream):
				stream(_stream),
				lineno(1),
				column(1),
				position(0)
				{}

			int LineNo()const;
			int Column()const;

			TCHAR Peek();
			void Advance();
			TCHAR ReadChar();
			void Backup();
			void Restore();
			void ReplaceLastBackup();
		};

private:
	static const int startStateIndex;
	static const UTCHAR startSymbol;
	static const UTCHAR finalSymbol;
	static const int transitionTable[][128];
	static const BOOL accepting[];
	static int indexOf(UTCHAR c)
	{
		if( c >= startSymbol && c <= finalSymbol )
			return c - startSymbol ;
		else return ErrorState ;
	}

	CodeStream fin;
	TCHAR currentChar;
	int lastAccepting;//last accepting state
	int backupLength;//no of the characters read since the last accepting state
	int currentState;//the current state!
	tstring lexeme;//the lexeme of the current token
	BOOL endOfFile;//determines if the end of file has been reached

public:

	LineNumberer(tifstream& stream)
		:fin(stream),
		lastAccepting(ErrorState),
		currentState(startStateIndex),
		backupLength(0),
		endOfFile(FALSE)
	{}

	//get the code stream
	CodeStream& CodeStream()
	{	return fin;		}

	//return the current lexeme
	tstring Lexeme()
	{	return lexeme;	}

	//get the current token
	int Scan();
//Nothing more in class definition.
//StreamWriter	outputFile;
/*private*/ /* void WriteLine(string line)
{
	Console.WriteLine(line);
}*/
/*static void Main()
{
	string inputFileName;
	LineNumberer scanner;
	//string outputFileName;
	Console.WriteLine("Enter source file name: ");
	inputFileName = Console.ReadLine();
	scanner = new LineNumberer(new StreamReader(inputFileName));
	while( scanner.Scan() != -1 );
}*/

};
}

#endif
