#ifndef _MYCHECKEDITERATOR_H
#define _MYCHECKEDITERATOR_H
//#include <algorithm>
//#include <vector>
/*
template<class _Category,
	class _Ty,
	class _Diff = ptrdiff_t,
	class _Pointer = _Ty *,
	class _Reference = _Ty&>
		struct iterator
	{	// base type for all iterator classes
	typedef _Category iterator_category;
	typedef _Ty value_type;
	typedef _Diff difference_type;
	typedef _Diff distance_type;	// retained
	typedef _Pointer pointer;
	typedef _Reference reference;
	};
	*/
//#include <iterator>
namespace std
{
/*template <class ContainerType>
class CheckedIterator : 
	public iterator<ContainerType::iterator::iterator_category,
					ContainerType::iterator::value_type,
					ContainerType::iterator::difference_type,
					ContainerType::iterator::distance_type,
					ContainerType::iterator::pointer,
					ContainerType::iterator::reference>
{
};*/
template <class ContainerType>
class CheckedIterator
{
	friend CheckedIterator<ContainerType> MakeCheckedIterator(ContainerType&);
	friend CheckedIterator<ContainerType> MakeAfterEndCheckedIterator(ContainerType&);
	friend bool operator ==(const CheckedIterator<ContainerType>&,
						const CheckedIterator<ContainerType>&);
	friend bool operator !=(const CheckedIterator<ContainerType>&,
						const CheckedIterator<ContainerType>&);
public:
	typedef typename ContainerType::iterator::iterator_category iterator_category;
	typedef typename ContainerType::iterator::value_type value_type;
	typedef typename ContainerType::iterator::difference_type difference_type;
	typedef typename ContainerType::iterator::distance_type distance_type;
	typedef typename ContainerType::iterator::pointer pointer;
	typedef typename ContainerType::iterator::reference reference;
private:
	typename ContainerType::iterator _currentIterator;
	int _itemsLeft;
	CheckedIterator(iterator iter, int itemsLeft) : _currentIterator(iter),
													_itemsLeft(itemsLeft)
	{}
public:
	CheckedIterator(const CheckedIterator& src) : _currentIterator(src._currentIterator),
												  _itemsLeft(src._itemsLeft)
	{}
	const CheckedIterator& operator++() //prefix
	{
		if(_itemsLeft <= 0)
			throw;
		_currentIterator++;
		_itemsLeft--;
		return *this;
	}
	CheckedIterator operator++(int) //postfix
	{
		if(_itemsLeft <= 0)
			throw;
		CheckedIterator<ContainerType> retval(*this);
		_currentIterator++;
		_itemsLeft--;
		return retval;
	}
	value_type& operator *()
	{
		return *_currentIterator;
	}
	pointer operator ->()
	{
		return &(*_currentIterator);
	}
};
template <class ContainerType>
CheckedIterator<ContainerType> MakeCheckedIterator(ContainerType &container)
{
	return CheckedIterator<ContainerType>(container);
}
template <class ContainerType>
CheckedIterator<ContainerType> MakeAfterEndCheckedIterator(ContainerType& container)
{
	CheckedIterator<ContainerType> retval(container.end(), 0);
	return retval;
}
template <class ContainerType>
bool operator ==(const std::CheckedIterator<ContainerType>& i1,
				 const std::CheckedIterator<ContainerType>& i2)
{
	return i1._currentIterator == i2._currentIterator;
}
template <class ContainerType>
bool operator !=(const std::CheckedIterator<ContainerType>& i1,
				 const std::CheckedIterator<ContainerType>& i2)
{
	return !(i1 == i2);
}
};

#endif