#include "stdafx.h"
#include ".\dfa.h"
#include "FAFactory.h"
using namespace Automata;

DFA::DFA(void) : father(NULL), numberOfStates(0), startStateIndex(0), transitionTable(NULL)
{
	
}

DFA::DFA(const FAFactory *creator, const RegularExpression &regex) : father(creator)
{

}
	
int DFA::NextState(int state, TCHAR inputSymbol) const
{
	return transitionTable[state][father->IndexOf(inputSymbol)];
}
BOOL DFA::IsFinal(int state) const
{
	return isFinalState[state];
}
void DFA::SetFinal(int state)
{
	isFinalState.Set(state, TRUE);
}
void DFA::ClearFinal(int state)
{
	isFinalState.Set(state, FALSE);
}
int& DFA::StartState() 
{
	return startStateIndex;
}
DFA::~DFA(void)
{
	if(father != NULL)
	{
		for(int i=0;i<numberOfStates;i++)
			if(transitionTable[i]!=NULL)
			{
				delete[] transitionTable[i];
				transitionTable[i] = NULL;
			}
        delete[] transitionTable;
	}
}