#pragma once
#include "stdafx.h"
namespace Automata
{
	class NFA;
	class DFA;
	class FAFactory
	{
	public:
		UTCHAR startSymbol;
		UTCHAR finalSymbol;
		FAFactory()
		{
			startSymbol = finalSymbol = NULL;
		}
		FAFactory(UTCHAR startChar, UTCHAR finalChar)
		{
			startSymbol = startChar;
			finalSymbol = finalChar;
		}	
		void Reset(UTCHAR startChar, UTCHAR finalChar)
		{
			startSymbol = startChar;
			finalSymbol = finalChar;
		}
		int IndexOf(UTCHAR c) const
		{
			if(c>=startSymbol && c<=finalSymbol)
				return c-startSymbol;
			else return EmptySet;
		}
		TCHAR CharacterOf(int symbolIndex) const
		{
			return startSymbol+symbolIndex;
		}
		int NumberOfSymbols() const
		{
			return finalSymbol-startSymbol+1;
		}
		~FAFactory(void)
		{}
		UTCHAR StartSymbol()const
		{
			return startSymbol;
		}
		UTCHAR FinalSymbol()const
		{
			return finalSymbol;
		}
	};
}