
#include "D:\C++ projects\Compilers\Lexcellent Final\GenerateCodeHere\LineNumberer.h"

using namespace Testing;
#define LEX_CLASS LineNumberer

const int LineNumberer::startStateIndex = 0;
const UTCHAR LineNumberer::startSymbol = 0;
const UTCHAR LineNumberer::finalSymbol = 127;

static int vec0[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
//NULL

const int * LineNumberer::transitionTable[] = 
{
vec0,
NULL
};

const BOOL LineNumberer::accepting[2] = 
{
FALSE
,TRUE
};

int LineNumberer::Scan()
{
	//restore everything
	lexeme.clear();
	currentState = startStateIndex;
	lastAccepting = ErrorState;
	backupLength = 0;
	fin.Backup();
	fin.SaveCurrentPosition();
	
	for(;;)
	{
		//read one more character
		currentChar = fin.Peek();

		if(endOfFile || currentChar == TEOF && lexeme.empty())
		{//end of file with no token in hands
			return -1;
		}
		else
		{
			if(currentChar == TEOF && !lexeme.empty())
			{
				currentState = ErrorState;
				endOfFile = TRUE;
			}
			else
			{
				fin.Advance();
				lexeme.push_back(currentChar);
				backupLength++;

				//get the next state
				if(transitionTable[currentState] == NULL)
					currentState = ErrorState;
				else if(transitionTable[currentState][0] == 0)
					currentState = 
					transitionTable[currentState][indexOf(currentChar)+1];
				else 
				{
					int pair;
					int tmp = currentState;
					for(pair=0; pair<transitionTable[currentState][0]; pair++ )
						if( transitionTable[currentState][pair * 2 + 1] == currentChar )
						{
							currentState = transitionTable[currentState][pair * 2 + 2];
							break;
						}
					if(pair == transitionTable[tmp][0])
						currentState = ErrorState;
				}
			}

			//is there an error?
			if(currentState != ErrorState)
			{//no error:

				//if it is an accepting state,save it
				if(accepting[currentState])
				{
					fin.ReplaceLastBackup();
					backupLength = 0;
					lastAccepting = currentState;
				}
			}
			else
			{//error state:

				if(lastAccepting == ErrorState)
				{
					fin.RemoveLastBackup();
					return -2;
				}
				else
				{//accepting
					//restore the input to the last accepting state
					fin.Restore();
					lexeme = lexeme.substr(0,lexeme.length() - backupLength);

switch(lastAccepting){
case 1:
	{
		Console.Write(CodeStream.CurrentLineNo.ToString()+": "+Lexeme);

	}
	break;
}
					//restore everything
					lexeme.clear();
					currentState = startStateIndex;
					lastAccepting = ErrorState;
					backupLength = 0;
					fin.Backup();
					fin.SaveCurrentPosition();
				}
			}//end of error state
		}
	}
	return 0;
}


//members of the code stream class
int LEX_CLASS::CodeStream::CurrentLineNo()const
{
	return curlineno;
}

int LEX_CLASS::CodeStream::CurrentColumn()const
{
	return curcolumn;
}

int LEX_CLASS::CodeStream::NextLineNo()const
{
	return nextlineno;
}

int LEX_CLASS::CodeStream::NextColumn()const
{
	return nextcolumn;
}

//read a char and without advancing the file pointer 
TCHAR LEX_CLASS::CodeStream::Peek()
{
	return stream.peek();
}

//read a char and advance the file pointer 
TCHAR LEX_CLASS::CodeStream::ReadChar()
{
	TCHAR ch = (TCHAR)stream.get();
	if(ch == '
')
	{
		nextlineno++;
		nextcolumn = 1;
	}
	else
		nextcolumn++;
	position++;
	return ch;
}

//move the file stream one step ahead
void LEX_CLASS::CodeStream::Advance()
{
	//read a char but don't return it!!
	ReadChar();
}

//save current state
void LEX_CLASS::CodeStream::Backup()
{
	lines.push(nextlineno);
	cols.push(nextcolumn);
	positions.push(position);
}

//restore most recently saved state
void LEX_CLASS::CodeStream::Restore()
{
	//restore saved state
	nextlineno = lines.top();
	lines.pop();
	nextcolumn = cols.top();
	cols.pop();
	stream.seekg(positions.top() - position,ios_base::cur);
	position = positions.top();
	positions.pop();
}

//replace the most recently saved state with the current state
void LEX_CLASS::CodeStream::ReplaceLastBackup()
{
	//remove last saved state
	lines.pop();
	cols.pop();
	positions.pop();

	//save current state
	lines.push(nextlineno);
	cols.push(nextcolumn);
	positions.push(position);
}

void LEX_CLASS::CodeStream::RemoveLastBackup()
{
	//remove last saved state
	lines.pop();
	cols.pop();
	positions.pop();
}

void LEX_CLASS::CodeStream::SaveCurrentPosition()
{
	curcolumn = nextcolumn;
	curlineno = nextlineno;
}
