

#ifndef _LEX_H_
#define _LEX_H_

#include "Lexcellent.h"
namespace Testing
{
class LineNumberer : IScanner, ICloneable
{
	public:
		class CodeStream
		{
		private:
			tifstream& stream;
			stack<int> lines;
			stack<int> cols;
			stack<int> positions;

			int curlineno;
			int curcolumn;
			int nextlineno;
			int nextcolumn;

			int position;
		public:
			CodeStream(tifstream& _stream):
				stream(_stream),
				curlineno(1),
				curcolumn(1),
				nextlineno(1),
				nextcolumn(1),
				position(0)
				{}

			int CurrentLineNo()const;
			int CurrentColumn()const;
			int NextLineNo()const;
			int NextColumn()const;

			TCHAR Peek();
			void Advance();
			TCHAR ReadChar();
			void Backup();
			void Restore();
			void ReplaceLastBackup();
			void RemoveLastBackup();
			void SaveCurrentPosition();
		};

private:
	static const int startStateIndex;
	static const UTCHAR startSymbol;
	static const UTCHAR finalSymbol;
	static const int* transitionTable[];
	
	static const BOOL accepting[];
	static int indexOf(UTCHAR c)
	{
		if( c >= startSymbol && c <= finalSymbol )
			return c - startSymbol ;
		else return ErrorState ;
	}

	CodeStream fin;
	TCHAR currentChar;
	int lastAccepting;//last accepting state
	int backupLength;//no of the characters read since the last accepting state
	int currentState;//the current state!
	tstring lexeme;//the lexeme of the current token
	BOOL endOfFile;//determines if the end of file has been reached

public:

	LineNumberer(tifstream& stream)
		:fin(stream),
		lastAccepting(ErrorState),
		currentState(startStateIndex),
		backupLength(0),
		endOfFile(FALSE)
	{}

	//get the code stream
	CodeStream& CodeStream()
	{	return fin;		}

	//return the current lexeme
	tstring Lexeme()
	{	return lexeme;	}

	//get the current token
	int Scan();
static void Main()
{
	LineNumberer ln = new LineNumberer(new StreamReader(@"j:\project\form.txt"));
	ln.Scan();
}

};
}

#endif
