#include "stdafx.h"
#include "Hashtable.h"
#include <stdlib.h>
#include <time.h>
#include <iostream>
#if TCHAR == wchar_t
	#define tcout wcout
	#define tcin wcin
#else
	#define tcout cout
	#define tcin cin
#endif
using namespace std;
UINT IntHash(int k)
{
	return k;
}
const int empty = -1;
typedef DoubleHashingObject<int, UINT (*)(int)>  HashFunction;
typedef OpenAddressHashtable<int, HashFunction> Hashtable;
void ReportStatus(const Hashtable &ht, const TCHAR *name);
void main()
{
	const UINT m1 = 31;
	const UINT m2 = 11;
	
	HashFunction f(m1, m2, IntHash);
	Hashtable dictionary(f.GetSuggestedHashtableSize(), f, empty);
	srand(clock());
	UINT i=0;
	int item = -1;
	while(i<m1)
	{
		item = rand();
		if(item != -1)
		{
			i++;
			dictionary.Add(item);
			ReportStatus(dictionary, _T("dictionary"));
		}
	}
}

void ReportStatus(const Hashtable& ht, const TCHAR *name)
{
	tcout<<endl<<endl
		<<_T("-------------------------")<<endl
		<<_T("Hashtable ")<<name<<" status:"<<endl
		<<_T("-------------------------")<<endl
		<<_T("Size():                  ")<<ht.Size()<<endl
		<<_T("Count():                 ")<<ht.Count()<<endl
		<<_T("IsFull():                ")<<(ht.IsFull()?"TRUE":"FALSE")<<endl
		<<_T("-------------------------")<<endl
		<<endl<<endl;
}
void ReportStatus(const Hashtable& ht, const TCHAR *name)
{
	tcout<<endl<<endl
		<<_T("-------------------------")<<endl
		<<_T("Hashtable ")<<name<<" status:"<<endl
		<<_T("-------------------------")<<endl
		<<_T("Size():                  ")<<ht.Size()<<endl
		<<_T("Count():                 ")<<ht.Count()<<endl
		<<_T("IsFull():                ")<<(ht.IsFull()?"TRUE":"FALSE")<<endl
		<<_T("Items: ")<<endl;
	const int *table = ht.GetInternalTable();
	UINT size = ht.Size();
	const HashFunction &hf = ht.GetHashFunction();
	for(int i=0;i<size;i++)
	{
		_tprintf(_T("table[%d]: "), i);
		if(table[i] == empty)
			tcout<<_T("Empty")<<endl;
		else tcout<<table[i]<<_T("; Original hash position: ")<<hf(table[i])<<endl;
	}
	tcout<<_T("-------------------------")<<endl
		<<endl<<endl;
}
