#include "stdafx.h"
#include "FAFactory.h"
#include "NFA.h"
#include "LexerInputReader.h"
#include "DFA.h"

#include <fstream>
#include <iostream>
#include <string>
#include <locale>
#include "TextFileIO.h"
using namespace std;
using namespace Automata;

#ifdef _UNICODE
	#define tout	wcout
	#define tin		wcin
#else	//ASCII
	#define tout	cout
	#define tin		cin
#endif

/*****Globals*****/
tstring		inputFileName;
tstring		outputFileName;


basic_ofstream<TCHAR, char_traits<TCHAR> > outputStream;

/*****Functions*****/
//It takes errorsTable and prints the errors.
void PrintStringTable(const vector<tstring> &stringTable);

//It prints the (key, value) pairs of table.
void PrintDictionary(const Dictionary &table);

//It takes an array of strings representing the command line
//arguments, and updates file names and other global variables
//correspondingly. It notifies the user of any errors it faces.
//argv: an array of strings (command line arguments).
//argc: number of entries in the array
//It returns TRUE if the command line arguments are in correct 
//format.
BOOL ParseCommandLineArguments(int argc, _TCHAR *argv[]);

//It tries to open the specified input file. If failed, it returns
//FALSE.
BOOL PrepareInput();
//
void Help();


int _tmain(int argc, _TCHAR* argv[])
{
	BOOL		success;
	Dictionary	optionsTable;
	tstring		str1, str2;
	int			i1, i2;
	Utf8Codecvt *utf8codec = new Utf8Codecvt;
	//locale		loc( locale(""), utf8codec );
	LexerInputReader::InitializeStaticData();
//	inputStream.imbue( loc );
//	inputStream.open( "LexerTest.l", ios_base::binary | ios_base::in );
	//inputStream.get(); inputStream.get();	inputStream.get();
	InputStream inputStream(L"LexerTest.l" );
	//inputStream.seekg(3);
	LexerInputReader lexer( inputStream, optionsTable );
	
	tout<<_T("***Testing ExtractIdentifier***")<<endl
		<<_T("Enter Line:")<<endl;
	getline(tin, str1);
	while( ! str1.empty() )
	{
		//erase str2
		str2.clear();
		i1 = lexer.ExtractIdentifier( str1, str2 );
		tout<<_T("Identifier:")<<str2<<_T("\tNext Position: ")<<i1<<endl
			<<_T("Enter Line:")<<endl;
		getline(tin, str1);
	//Testing ExtractIdentifier
	}
//	getline(inputStream, str1);
//	tout<<str1<<endl;
	tout<<_T("Command: ");
	getline(tin, str1);
	//str1.resize(2);
	//str1[0] = tin.get();
	
	while( ! str1.empty() )
	{
		TCHAR c;
		switch(str1[0])
		{
		case _T('s'):
		case _T('S'):
		/*	if(! inputStream )
			{
				tout<<_T("Problem with input stream:"); 
				if( inputStream.bad() )
					tout<<_T("bad.")<<endl;
				else if( inputStream.fail() )
					tout<<_T("fail.")<<endl;
				else if( inputStream.eof() )
					tout<<_T("eof.")<<endl;
				else tout<<_T("Unknown.")<<endl;
				//break;
				inputStream.clear();
			}
			else //if good
			{
				tout<<_T("State is good.")<<endl;
			}
			break;*/
			tout<<_T("No more supported.")<<endl;
			break;
		case _T('t'):
		case _T('T'):
			tout<<_T("Current Read Position( tellg() ): ")
				<< inputStream.tellg() <<endl;
			break;
		case _T('P'):
		case _T('p'):
			//inputStream.get(c);
			//inputStream.clear();
			//inputStream.putback(c);
			//inputStream.unget();
			c = inputStream.peek();
			tout<<c<<endl;
			break;
		case _T('B'):
		case _T('b'):
			{
//			inputStream.seekg(-1, ios_base::cur);
		//	inputStream.seekg( x - 2);
//			inputStream.rdbuf()->
			//inputStream.seekg(0);
			//inputStream.seekg(x - (basic_ifstream<TCHAR, char_traits<TCHAR> >::pos_type)1);
			inputStream.seekg(-1, SEEK_CUR);
		//	inputStream.unget();
		//	inputStream.sync();
			}
			break;
		case _T('F'):
		case _T('f'):
			inputStream.seekg(1, SEEK_CUR);
			break;
		case _T('G'):
		case _T('g'):
			tout<<(TCHAR)inputStream.get()<<endl;
			break;
		}
		/*if(! inputStream )
		{
			tout<<_T("Problem with input stream:"); 
			if( inputStream.bad() )
				tout<<_T("bad.")<<endl;
			else if( inputStream.fail() )
				tout<<_T("fail.")<<endl;
			else if( inputStream.eof() )
				tout<<_T("eof.")<<endl;
			else tout<<_T("Unknown.")<<endl;
			//break;
			inputStream.clear();
		}*/

		tout<<_T("Command: ");
		getline(tin, str1);
	}
	//tout<< inputStream.get() << inputStream.get() <<endl;
	//inputStream.seekg(-1, ios_base::cur);
	//tout<< inputStream.peek()<< inputStream.peek() <<inputStream.get()<<endl;
	return 0;
}

BOOL ParseCommandLineArguments(int argc, _TCHAR *argv[])
{
	if(argc  < 2)
	{
		tout<<_T("The syntax of the command is incorrect.\n");
		tout<<_T("Syntax: ")<<_T("lexer inputFileName [outputFileName].")
			<<endl;
		return FALSE;
	}
	if(argc > 3)
	{
		tout<<_T("The syntax of the command is incorrect.\n");
		tout<<_T("Syntax: ")<<_T("lexer inputFileName [outputFileName].")
			<<endl;
		return FALSE;
	}
	inputFileName = argv[1];
	if( argc == 3 ) outputFileName = argv[2];
	else //inputFileName.
	{
		outputFileName = argv[1];
		int dotPosition = outputFileName.find_last_of( _T('.') );
		outputFileName.erase( dotPosition );
	}
	return TRUE;
}
//////
/*BOOL PrepareInput()
{
	char	*fname;
	int		strLen;

	//Get ascii names
	strLen = inputFileName.size();
	fname = new char[ strLen + 1];
#ifdef _UNICODE
	wcstombs( fname, inputFileName.c_str(),  strLen );
	fname[strLen] = '\0';
#else
	strcpy(fname, inputFileName.c_str() );
#endif

	
	if(! inputStream.OpenA( fname ) ) return FALSE;
	
	//Open now the output file
	delete[] fname;
//	strLen = outputFileName
//	fname = new char [
	return TRUE;
}*/
//////
void PrintStringTable(const vector<tstring> &stringTable)
{
	vector<tstring>::size_type i = 0, count = stringTable.size();
	for(; i<count; i++)
		tout<<stringTable[i]<<endl;
}
//////
void PrintDictionary(const Dictionary &table)
{
	const TCHAR *formatString = _T("%-24s\t%-64s%s");
	Dictionary::const_iterator	iter,end;

	tout<<_T("Number of entries: ")<<table.size()<<endl;
	if(table.size() < 1)
		return;

	_tprintf( formatString, _T("Key"), _T("Value"), ENDLINE);
	iter = table.begin();
	end = table.end();
	for(; iter != end; iter++)
		_tprintf(formatString, iter->first, iter->second, ENDLINE);
}