﻿%{
//Header Top Section
%}
%option CharacterSet = [\x0-\x7Fأ-يأبتثجحخدذرزسشصضطظعغفقكلمنهويئءؤلاىآةوزظطكمنتالبييسشضصثثقففغغعههخحخحجد1233456767890ًٌَُّلإإ‘لأأٍِْلآ’]
%option Language = C#
%option ClassName = Lex
%option FunctionName = GetNextToken
%option Namespace = myNameSpace
%option ReturnType = int
%option FileName = lex
%option CompressionTechnique = Redundancy
%option EOFAction = -1
%option InvalidTokenAction = -2

dec			[0-9]
oct			[0-7]
hex			[0-9a-fA-F]
bin			[01]
capital		[A-Z]
small		[a-z]
letter		({small}|{capital}|[أ-ي])

%%
//class definitions
void output(string x)
{
	Console.Write(x+" ");
}
public static void Main(string[] args)
{
	Lex lex = new Lex(new StreamReader(@"j:\project\output.cpp"));
	lex.GetNextToken();
}
%%
{bin}+[bB]?	output("BIN_INTEGER");
{oct}+[oO]?	output("OCT_INTEGER");
{dec}+[dD]?	output("DEC_INTEGER");

{hex}+[hH]?	output("HEX_INTEGER");
while		output("WHILE");
if			output("IF");
do			output("DO");
int			output("INT");
float		output("FLOAT");
char		output("CHAR");
signed		output("SIGNED");
unsigned	output("UNSIGNED");
test_code 
({letter}|"_")({letter}|{dec}|"_")*				output("IDENTIFIER");
({dec}+|({dec}*"."{dec}+))([eE][+-]?{dec}+)?	output("FLOAT_CONST");
"["^?([^\]\r\n\\]|\\.)*"]"						output("CHARACTER_CLASS");
"/*"([^*]|"*"+[^/*])*"*"+"/"					output("C_COMMENT");
.|\n											output(Lexeme);
%%
//Cpp Top Section
/*#include <iostream>
#include <cmath>
using namespace std;
void output(const char* x);*/
%%
//Cpp Bottom Section
/*void output(const char* x)
{
	cout<<x<<endl;
}*/