#include "stdafx.h"
#include <algorithm>
#include <vector>
#include <iostream>
#include "LinkedList.h"
using namespace std;
#if TCHAR == wchar_t
	#define tcout wcout
	#define tcin wcin
#else
	#define tcout cout
	#define tcin cin
#endif
typedef LinkedList<int> List;
template <class Type>
class ListAdder
{
private:
	LinkedList<Type> &_list;
public:
	ListAdder(LinkedList<Type> &list) : _list(list)
	{}
	void SetList(LinkedList<Type>& list)
	{
		_list = list;
	}
	void operator ()(Type &item)
	{
		_list.AddToBack(item);
	}
};
template <class Type>
class SummerFn
{
private:
	Type _sum;
public:
	SummerFn(Type initialValue) : _sum(initialValue)
	{}
	void operator()(const Type& item)
	{
		_sum += item;
	}
	Type& Sum()
	{
		return _sum;
	}
};
template <class Type>
void ReportStatus(const LinkedList<Type>& list, const TCHAR *name)
{
	tcout<<endl<<endl
	<<_T("-------------------------")<<endl
	<<_T("List ")<<name<<" status:"<<endl
	<<_T("-------------------------")<<endl
	<<_T("Count():          ")<<list.Count()<<endl
	<<_T("IsEmpty():        ")<<list.IsEmpty()<<endl
	<<_T("-------------------------")<<endl
	<<endl<<endl;
}
template <class Type>
void PrintItems(const LinkedList<Type>& list, const TCHAR *name)
{
	tcout<<endl<<endl
	<<_T("-------------------------")<<endl
	<<_T("List ")<<name<<" Items:"<<endl
	<<_T("-------------------------")<<endl;

	LinkedList<Type>::const_iterator end = list.End();
	LinkedList<Type>::const_iterator iter = list.Begin();
	int i=0;
	while(iter != end)
		tcout<<_T("Item[")<<i++<<_T("]: ")<<*iter++<<endl;
	tcout<<_T("Total number of items: ")<<i<<endl
	<<_T("-------------------------")<<endl
	<<endl<<endl;
}
const int MAX = 10;
int main()
{
	int array[MAX] = {0, 5, 2, 7, 12,
					13, 1, 9, 22, 8};
	List list;
	tcout<<_T("After creation: ")<<endl;
	ReportStatus(list, _T("list"));
	PrintItems(list, _T("list"));
	ListAdder<int> addFn(list);
	for_each(array, array+MAX, addFn);
	tcout<<_T("After adding 10 items: ")<<endl;
	ReportStatus(list, _T("list"));
	PrintItems(list, _T("list"));
	List::iterator end = list.End();
	List::iterator begin = list.Begin();
	SummerFn<int> sumFn(0);
	sumFn = for_each(begin, end, sumFn);
	tcout<<_T("After foreaching list to find the sum of the elements: ")<<endl
		<<_T("Sum: ")<<sumFn.Sum()<<endl;
	//Deleting an element from the front
	list.RemoveFromFront();
	tcout<<_T("After removing an element from the front:")<<endl;
	ReportStatus(list, _T("list"));
	PrintItems(list, _T("list"));
	//Deleting another element from the front
	list.RemoveFromFront();
	tcout<<_T("After removing an element from the front:")<<endl;
	ReportStatus(list, _T("list"));
	PrintItems(list, _T("list"));

	list.AddToFront(1000);
	list.RemoveFromBack();
	list.AddToBack(2000);
	tcout<<_T("After adding 1000 to front, then removing an element from the back and")<<endl
		<<_T("then adding an 2000 to back:")<<endl;
	ReportStatus(list, _T("list"));
	PrintItems(list, _T("list"));

	list.Clear();
	tcout<<_T("After clearing the list:")<<endl;
	ReportStatus(list, _T("list"));
	PrintItems(list, _T("list"));
	return 0;
}

