#include "stdafx.h"
#include "Set.h"
#include "FAFactory.h"
#include ".\nondeterministicstate.h"

using namespace Automata;

NondeterministicState::NondeterministicState(void) 
			: /*emptyTransition({ErrorState, ErrorState}),*/type(EmptyTransitions)
{
	//emptyTransition({ErrorState,ErrorState}), 
	//emptyTransition = {ErrorState,ErrorState};
	emptyTransition[0] = ErrorState;
	emptyTransition[1] = ErrorState;
}

NondeterministicState::NondeterministicState(int emptyState0, int emptyState1)
			: /*emptyTransition({emptyState0, emptyState1}),*/type(EmptyTransitions)
{
	emptyTransition[0] = emptyState0;
	emptyTransition[1] = emptyState1;
}

NondeterministicState::NondeterministicState(TCHAR symbol, int state) 
			: type(SymbolTransition)
{
	transition.Set(symbol, state);
}
NondeterministicState::NondeterministicState(Set *charClass, int state) 
			: type(CharacterClassTransition)
{
	transition.Set(charClass, state);
}
int NondeterministicState::GetEmptyTransition1() const
{
	return emptyTransition[0];
}
int NondeterministicState::GetEmptyTransition2() const
{
	return emptyTransition[1];
}
void NondeterministicState::SetEmptyTransitions(int state0, int state1)
{
	type = EmptyTransitions;
	emptyTransition[0] = state0;
	emptyTransition[1] = state1;
}
void NondeterministicState::GetTransition(Transition *transition) const
{
	if(type == SymbolTransition)	*transition = this->transition;
	else	transition->Set((TCHAR)NULL,  ErrorState);
}
void NondeterministicState::GetTransition(TCHAR *symbol, int *state) const
{
	if(type == SymbolTransition)
	{	*symbol = transition.Symbol;
		*state = transition.State;
	}
	else
	{
		*symbol = NULL;
		*state = ErrorState;
	}
}
void NondeterministicState::GetTransition(Set **characterClass, int *state) const
{
	*characterClass = transition.CharacterClass;
	*state = transition.State;
}
/*void NondeterministicState::SetTransition(const Transition *transition)
{
	How shall we know the type? SymbolTransition or CharacterClassTransition?
	this->transition = *transition;
}*/
void NondeterministicState::SetTransition(TCHAR symbol, int state)
{
	type = SymbolTransition;
	transition.Set(symbol, state);
}
void NondeterministicState::SetTransition(Set *characterClass, int state)
{
	type = CharacterClassTransition;
	transition.Set(characterClass, state);
}
NondeterministicState::StateType NondeterministicState::GetType() const
{
	return type;
}
int NondeterministicState::NextState(TCHAR symbol) const
{
	if(type==EmptyTransitions)
		return ErrorState;
	if(type == SymbolTransition)
	{	
		if(transition.Symbol == symbol)
			return transition.State;
	}
	return ErrorState;
}
int NondeterministicState::NextState(int symbolIndex) const
{
	if(transition.CharacterClass->Contains(symbolIndex))
		return transition.State;
	return ErrorState;
}


NondeterministicState::~NondeterministicState(void)
{
	if( type == CharacterClassTransition &&
		transition.CharacterClass != NULL)
		delete transition.CharacterClass;
	transition.CharacterClass = NULL;
}
TCHAR NondeterministicState::GetTransitionSymbol() const
{
	return transition.Symbol;
}
int NondeterministicState::NextState(const FAFactory *father, TCHAR symbol) const
{
	switch( type )
	{
	case CharacterClassTransition:
		{
			int symbolIndex = father->IndexOf(symbol);
			if( transition.CharacterClass->Contains(symbolIndex) )
				return transition.State;
			else return ErrorState;
		}
		break;
	case SymbolTransition:
		if( transition.Symbol == symbol )
			return transition.State;
		else return ErrorState;
		break;
	default:
		return ErrorState;
	}
}