%option CharacterSet = [0-9.eE\-+xXA-Fa-f\t \r\n]
%option Namespace = Automata
%option ClassName = NumberExtractor
%option FunctionName = Scan
%option ReturnType = NumberType
%option FileName = :{}()-=-!@#$%^&*()~<>,;'lala
%option Language = c#
%option PairsThreshold = 2
%option CompressionTechnique = Best
%option EOFAction = return Automata::End;
%option InvalidTokenAction = return Automata::Invalid;
%{
#include <tchar.h>
#include "LexGlobals.h"
#include <cstdio>
#include <cstdlib>
using namespace std;
namespace Automata
{
	enum NumberType
	{
		//Int value. Note: DoubleValue and IntValue will both
		//contain the parsed value.
		DecimalInteger,
		
		//IntValue will contain the parsed value. It might be
		//preceeded by 0x or 0X.
		HexadecimalInteger,
		
		//It must be preceeded by 0. IntValue will contain
		//the parsed value.
		//OctalInteger,
		
		//Double value
		Double,
		
		//Invalid character
		Invalid,
		
		//End of string reached
		End
	};
}
%}
	//Macro Definitions
dec	[0-9]
%%
//Nothing more in class definition.
public:
	int		IntValue;
	double	DoubleValue;
%%
	//Integers
[0-9]+	{
			IntValue = _tstoi(Lexeme().c_str());
			DoubleValue = _tstof(Lexeme().c_str());
			return DecimalInteger;
		}
(0[xX])?[0-9A-Fa-f]+ 	{
			_stscanf(Lexeme().c_str(), _T("%x"), &IntValue);
			return HexadecimalInteger;
		}
({dec}+|({dec}*"."{dec}+))([eEDd][+-]?{dec}+)? {
			DoubleValue = _tstof(Lexeme().c_str());
			return Double;
		}
[ \t\r\n]+ //Do nothing
%%
//top cpp
%%
//bottom cpp