#include "stdafx.h"
#include "RangedSet.h"
using namespace Automata;
RangedSet::RangedSet(Set *set, int min) : _set( set ), _min( min )
{}
//////
int	RangedSet::RangeMaximum() const
{
	return _min + _set->NumberOfElementsRequested() - 1;
}
//////
BOOL RangedSet::Contains(int x) const
{
	x -= _min;
	if( x < 0 ) return FALSE;
	return _set->Contains( x );
}
//////
BOOL RangedSet::Add(int x)
{
	if( ! WithinRange( x ) )
		return FALSE;
	_set->Add( x - _min );
	return TRUE;
}
//////
void RangedSet::AddAllElements()
{
	_set->AddAllElements();
}
//////
BOOL RangedSet::AddRange(int a, int b)
{
	if( !WithinRange(a) || !WithinRange(b) )
		return FALSE;
	a -= _min;
	b -= _min;
	_set->AddRange(a, b);
	return TRUE;
}
//////
BOOL RangedSet::Remove(int x)
{
	if( ! WithinRange(x) ) return FALSE;
	_set->Remove(x);
	return TRUE;
}
//////
BOOL RangedSet::RemoveRange(int a, int b)
{
	if( !WithinRange(a) || !WithinRange(b) )
		return FALSE;
	a -= _min;
	b -= _min;
	_set->RemoveRange(a, b);
	return TRUE;
}
//////
void RangedSet::Clear()
{
	_set->Clear();
}
//////
BOOL RangedSet::WithinRange(int x) const
{
	return x >= _min && x <= RangeMaximum();
}
//////
BOOL RangedSet::MinimumElement(int &min) const
{
	min = _set->Minimum();
	if( min == -1 ) return FALSE;
	min = min + _min;
	return TRUE;
}
//////
BOOL RangedSet::MaximumElement(int &max) const
{
	max = _set->Maximum();
	if( max == -1 ) return FALSE;
	max = max + _min;
	return TRUE;
}
//////
RangedSet::~RangedSet(void)
{
}
