#pragma once

class SimpleRegexConventions
{
public:
	static const int NumberOfMetaCharacters = 7;
	static const int NumberOfCommonProfiles = 1;
	enum CommonMetaCharacterProfile
	{
		SqlProfile
	};
	enum MetaCharacter
	{
		AnyWord,			//%	L(%) = {Empty, all possible words}
		AnySingleCharacter,	//_ L(a_d) = {aad, abd, ....}
		LeftBracket,		//[
		RightBracket,		//]
		NotOneOfThose,		//^ [^abc]
        RangeBetween,		//-	[A-Z]
		Escape				//\	Escape sequence character.
	};
private:
	static TCHAR Profile[NumberOfCommonProfiles][NumberOfMetaCharacters];
	TCHAR metaChar[NumberOfMetaCharacters];

public:
	SimpleRegexConventions(void);
	void UseCommonProfile( CommonMetaCharacterProfile profile );
	BOOL IsValidExpression( const TCHAR *regex );
	void SetMetaCharacter( MetaCharacter whichChar, TCHAR value )
	{
		metaChar[whichChar] = value; 
	}
	void SetMetaCharacter(const TCHAR *tcharArray);
	TCHAR GetMetaCharacter( MetaCharacter whichChar ) const
	{ 
		return metaChar[whichChar]; 
	}
	void GetMetaCharacter( TCHAR **tcharArray) const;
	~SimpleRegexConventions(void);
};