#include "stdafx.h"

namespace Automata
{

/***************************************************************************/
//The string tables of the uncompressed DFA

	tstring DFAUncompressedCpp1 = _T(
"()\n\
{\n\
	//restore everything\n\
	lexeme.clear();\n\
	currentState = startStateIndex;\n\
	lastAccepting = ErrorState;\n\
	backupLength = 0;\n\
	fin.Backup();\n\
	fin.SaveCurrentPosition();\n\
	\n\
	for(;;)\n\
	{\n\
		//read one more character\n\
		currentChar = fin.Peek();\n\
\n\
		if(endOfFile || currentChar == TEOF && lexeme.empty())\n\
		{//end of file with no token in hands\n\
			return ");

	tstring DFAUncompressedCpp2 = _T(
";\n\
		}\n\
		else\n\
		{\n\
			if(currentChar == TEOF && !lexeme.empty())\n\
			{\n\
				currentState = ErrorState;\n\
				endOfFile = TRUE;\n\
			}\n\
			else\n\
			{\n\
				fin.Advance();\n\
				lexeme.push_back(currentChar);\n\
				backupLength++;\n\
\n\
				//get the next state\n\
				currentState = \n\
					transitionTable[currentState][indexOf(currentChar)];\n\
			}\n\
\n\
			//is there an error?\n\
			if(currentState != ErrorState)\n\
			{//no error:\n\
\n\
				//if it is an accepting state,save it\n\
				if(accepting[currentState])\n\
				{\n\
					fin.ReplaceLastBackup();\n\
					backupLength = 0;\n\
					lastAccepting = currentState;\n\
				}\n\
			}\n\
			else\n\
			{//error state:\n\
\n\
				if(lastAccepting == ErrorState)\n\
				{\n\
					fin.RemoveLastBackup();\n\
					return ");

	tstring DFAUncompressedCpp3 = _T(
";\n\
				}\n\
				else\n\
				{//accepting\n\
					//restore the input to the last accepting state\n\
					fin.Restore();\n\
					lexeme = lexeme.substr(0,lexeme.length() - backupLength);\n\
\n\
");

	tstring DFAUncompressedCpp4 = _T(
"					//restore everything\n\
					lexeme.clear();\n\
					currentState = startStateIndex;\n\
					lastAccepting = ErrorState;\n\
					backupLength = 0;\n\
					fin.Backup();\n\
					fin.SaveCurrentPosition();\n\
				}\n\
			}//end of error state\n\
		}\n\
	}\n\
	return 0;\n\
}\n\
\n\
\n\
//members of the code stream class\n\
int LEX_CLASS::CodeStream::CurrentLineNo()const\n\
{\n\
	return curlineno;\n\
}\n\
\n\
int LEX_CLASS::CodeStream::CurrentColumn()const\n\
{\n\
	return curcolumn;\n\
}\n\
\n\
int LEX_CLASS::CodeStream::NextLineNo()const\n\
{\n\
	return nextlineno;\n\
}\n\
\n\
int LEX_CLASS::CodeStream::NextColumn()const\n\
{\n\
	return nextcolumn;\n\
}\n");

	tstring DFAUncompressedCpp4_1 = _T(
"\n\
//read a char and without advancing the file pointer \n\
TCHAR LEX_CLASS::CodeStream::Peek()\n\
{\n\
	return stream.peek();\n\
}\n\
\n\
//read a char and advance the file pointer \n\
TCHAR LEX_CLASS::CodeStream::ReadChar()\n\
{\n\
	TCHAR ch = (TCHAR)stream.get();\n\
	if(ch == '\n')\n\
	{\n\
		nextlineno++;\n\
		nextcolumn = 1;\n\
	}\n\
	else\n\
		nextcolumn++;\n\
	position++;\n\
	return ch;\n\
}\n\
\n\
//move the file stream one step ahead\n\
void LEX_CLASS::CodeStream::Advance()\n\
{\n\
	//read a char but don't return it!!\n\
	ReadChar();\n\
}\n\
\n");

	tstring DFAUncompressedCpp4_2 = _T(
"//save current state\n\
void LEX_CLASS::CodeStream::Backup()\n\
{\n\
	lines.push(nextlineno);\n\
	cols.push(nextcolumn);\n\
	positions.push(position);\n\
}\n\
\n\
//restore most recently saved state\n\
void LEX_CLASS::CodeStream::Restore()\n\
{\n\
	//restore saved state\n\
	nextlineno = lines.top();\n\
	lines.pop();\n\
	nextcolumn = cols.top();\n\
	cols.pop();\n\
	stream.seekg(positions.top() - position,ios_base::cur);\n\
	position = positions.top();\n\
	positions.pop();\n\
}\n\
\n\
//replace the most recently saved state with the current state\n\
void LEX_CLASS::CodeStream::ReplaceLastBackup()\n\
{\n\
	//remove last saved state\n\
	lines.pop();\n\
	cols.pop();\n\
	positions.pop();\n\
\n\
	//save current state\n\
	lines.push(nextlineno);\n\
	cols.push(nextcolumn);\n\
	positions.push(position);\n\
}\n\
\n\
void LEX_CLASS::CodeStream::RemoveLastBackup()\n\
{\n\
	//remove last saved state\n\
	lines.pop();\n\
	cols.pop();\n\
	positions.pop();\n\
}\n\
\n\
void LEX_CLASS::CodeStream::SaveCurrentPosition()\n\
{\n\
	curcolumn = nextcolumn;\n\
	curlineno = nextlineno;\n\
}");

////////////////////////////////////////////////////////////////////////

	tstring DFAUncompressedCs1 = _T(
"	const int ErrorState = -1;\n\
	const int startStateIndex = 0;\n\
\n\
	int indexOf(char c)\n\
	{\n\
		if( c >= startSymbol && c <= finalSymbol )\n\
			return c - startSymbol ;\n\
		else return ErrorState ;\n\
	}\n\
\n\
	CodeStream fin;\n\
	char currentChar;\n\
	int lastAccepting;//last accepting state\n\
	int backupLength;//no of the characters read since the last accepting state\n\
	int currentState;//the current state!\n\
	string lexeme;//the lexeme of the current token\n\
	bool endOfFile = false;//determines if the end of file has been reached\n\
\n\
	public ");

	tstring DFAUncompressedCs2 = _T(
"(StreamReader stream)\n\
	{\n\
		fin = new CodeStream(stream);\n\
		lastAccepting = ErrorState;\n\
		backupLength = 0;\n\
		currentState = startStateIndex;\n\
		lexeme = \"\";\n\
	}\n\
\n\
	//get the code stream\n\
	public CodeStream CodeStream\n\
	{\n\
		get\n\
		{\n\
			return fin;\n\
		}\n\
	}\n\
\n\
	//return the current lexeme\n\
	public string Lexeme\n\
	{\n\
		get\n\
		{\n\
			return lexeme.ToString();\n\
		}\n\
	}\n\
\n\
	//get the current token\n\
	public ");

	tstring DFAUncompressedCs3 = _T(
"()\n\
	{	//restore everything\n\
		lexeme = \"\";\n\
		currentState = startStateIndex;\n\
		lastAccepting = ErrorState;\n\
		backupLength = 0;\n\
		fin.Backup();\n\
		fin.SaveCurrentPosition();\n\
\n\
		for(;;)\n\
		{\n\
			//read one more character\n\
			currentChar = fin.Peek();\n\
\n\
			if(endOfFile || currentChar == CodeStream.TEOF && lexeme == \"\")\n\
			{//end of file with no token in hands\n\
				return ");

	tstring DFAUncompressedCs4 = _T(
";\n\
			}\n\
			else\n\
			{\n\
				if(currentChar == CodeStream.TEOF && lexeme != \"\")\n\
				{\n\
					currentState = ErrorState;\n\
					endOfFile = true;\n\
				}\n\
				else\n\
				{\n\
					fin.Advance();\n\
					lexeme += new string(currentChar,1);\n\
					backupLength++;\n\
\n\
					//get the next state\n\
					currentState = \n\
						transitionTable[currentState,indexOf(currentChar)];\n\
				}\n\
\n\
				//is there an error?\n\
				if(currentState != ErrorState)\n\
				{//no error:\n\
\n\
					//if it is an accepting state,save it\n\
					if(accepting[currentState])\n\
					{\n\
						fin.ReplaceLastBackup();\n\
						backupLength = 0;\n\
						lastAccepting = currentState;\n\
					}\n\
				}\n\
				else\n\
				{//error state:\n\
\n\
					if(lastAccepting == ErrorState)\n\
					{//Invalid Token\n\
						fin.RemoveLastBackup();\n\
						return ");

	tstring DFAUncompressedCs5 = _T(
";\n\
					}\n\
					else\n\
					{//accepting\n\
						//restore the input to the last accepting state\n\
						fin.Restore();\n\
						lexeme = lexeme.Substring(0,lexeme.Length - backupLength);\n\
\n\
");


	tstring DFAUncompressedCs6 = _T(
"\n\
							//re-initialize the get-next-token funtion\n\
							lexeme = \"\";\n\
							currentState = startStateIndex;\n\
							lastAccepting = ErrorState;\n\
							backupLength = 0;\n\
							fin.Backup();\n\
							fin.SaveCurrentPosition();\n\
							\n\
						}//end of acceptance state\n\
					}//end of error state\n\
				}//end of the else part(it means, not yet end of file)\n\
\n\
			}//end of the unconditional for loop\n\
		}//end of the get-next-token function\n\
	}//end of the lexical analyzer class\n\
\n\
	public class CodeStream\n\
	{\n\
		StreamReader stream;\n\
		Stack lines;\n\
		Stack cols;\n\
		Stack positions;\n\
\n\
		int curlineno;\n\
		int curcolumn;\n\
		int nextlineno;\n\
		int nextcolumn;\n\
\n");

	tstring DFAUncompressedCs6_1 = _T("\
		int position;\n\
		\n\
		public const char TEOF = unchecked((char)-1);\n\
\n\
		public CodeStream(StreamReader stream)\n\
		{\n\
			this.stream = stream;\n\
			lines = new Stack();\n\
			cols = new Stack();\n\
			positions = new Stack();\n\
			nextlineno = curlineno = 1;\n\
			nextcolumn = curcolumn  = 1;\n\
			position = 2;\n\
		}\n\
\n\
		public int CurrentLineNo\n\
		{\n\
			get\n\
			{\n\
				return curlineno;\n\
			}\n\
		}\n\
\n\
		public int CurrentColumn\n\
		{\n\
			get\n\
			{\n\
				return curcolumn;\n\
			}\n\
		}\n\
\n\
		public int NextLineNo\n\
		{\n\
			get\n\
			{\n\
				return nextlineno;\n\
			}\n\
		}\n\
\n\
		public int NextColumn\n\
		{\n\
			get\n\
			{\n\
				return nextcolumn;\n\
			}\n\
		}\n\
\n");

	tstring DFAUncompressedCs6_2 = _T("\
		public void SaveCurrentPosition()\n\
		{\n\
			curcolumn = nextcolumn;\n\
			curlineno = nextlineno;\n\
		}\n\
\n\
		//Peek the next character from the stream\n\
		public char Peek()\n\
		{\n\
			return unchecked((char)stream.Peek());\n\
		}\n\
\n\
		//read a char and advance the file pointer \n\
		public char ReadChar()\n\
		{\n\
			char ch = unchecked((char)stream.Read());\n\
			if(ch == '\\n')\n\
			{\n\
				nextlineno++;\n\
				nextcolumn = 1;\n\
			}\n\
			else\n\
				nextcolumn++;\n\
			position+=2;\n\
			return ch;\n\
		}\n\
\n\
		//move the file stream one step ahead\n\
		public void Advance()\n\
		{\n\
			ReadChar();\n\
		}\n\
\n\
		//save current state\n\
		public void Backup()\n\
		{\n\
			lines.Push(nextlineno);\n\
			cols.Push(nextcolumn);\n\
			positions.Push(position);\n\
		}\n\
\n");

	tstring DFAUncompressedCs6_3 = _T("\
		//restore most recently saved state\n\
		public void Restore()\n\
		{\n\
			//restore saved state\n\
			nextlineno = (int)lines.Peek();\n\
			lines.Pop();\n\
			nextcolumn = (int)cols.Peek();\n\
			cols.Pop();\n\
			stream.DiscardBufferedData();\n\
			stream.BaseStream.Seek\n\
				(((int)positions.Peek()) - stream.BaseStream.Position ,SeekOrigin.Current);\n\
			position = (int)positions.Peek();\n\
			positions.Pop();\n\
		}\n\
\n\
		//replace the most recently saved state with the current state\n\
		public void ReplaceLastBackup()\n\
		{\n\
			//remove last saved state\n\
			lines.Pop();\n\
			cols.Pop();\n\
			positions.Pop();\n\
\n\
			//save current state\n\
			lines.Push(nextlineno);\n\
			cols.Push(nextcolumn);\n\
			positions.Push(position);\n\
		}\n\
\n\
		//clear the last saved state, used when an invlaid token is met\n\
		public void RemoveLastBackup()\n\
		{\n\
			//remove last saved state\n\
			lines.Pop();\n\
			cols.Pop();\n\
			positions.Pop();\n\
		}\n\
	}\n");

/////////////////////////////////////////////////////////////////////////

	tstring DFAUncompressedH1 = _T(
"#ifndef _LEX_H_\n\
#define _LEX_H_\n\
\n\
#include \"Lexcellent.h\"\n\
");

	tstring DFAUncompressedH2 = _T(
"{\n\
	public:\n\
		class CodeStream\n\
		{\n\
		private:\n\
			tifstream& stream;\n\
			stack<int> lines;\n\
			stack<int> cols;\n\
			stack<int> positions;\n\
\n\
			int curlineno;\n\
			int curcolumn;\n\
			int nextlineno;\n\
			int nextcolumn;\n\
\n\
			int position;\n\
		public:\n\
			CodeStream(tifstream& _stream):\n\
				stream(_stream),\n\
				curlineno(1),\n\
				curcolumn(1),\n\
				nextlineno(1),\n\
				nextcolumn(1),\n\
				position(0)\n\
				{}\n\
\n\
			int CurrentLineNo()const;\n\
			int CurrentColumn()const;\n\
			int NextLineNo()const;\n\
			int NextColumn()const;\n\
\n\
			TCHAR Peek();\n\
			void Advance();\n\
			TCHAR ReadChar();\n\
			void Backup();\n\
			void Restore();\n\
			void ReplaceLastBackup();\n\
			void RemoveLastBackup();\n\
			void SaveCurrentPosition();\n\
		};\n\
\n\
private:\n\
	static const int startStateIndex;\n\
	static const UTCHAR startSymbol;\n\
	static const UTCHAR finalSymbol;\n\
	static const int transitionTable[][");

	tstring DFAUncompressedH3 = _T(
"];\n\
	static const BOOL accepting[];\n\
	static int indexOf(UTCHAR c)\n\
	{\n\
		if( c >= startSymbol && c <= finalSymbol )\n\
			return c - startSymbol ;\n\
		else return ErrorState ;\n\
	}\n\
\n\
	CodeStream fin;\n\
	TCHAR currentChar;\n\
	int lastAccepting;//last accepting state\n\
	int backupLength;//no of the characters read since the last accepting state\n\
	int currentState;//the current state!\n\
	tstring lexeme;//the lexeme of the current token\n\
	BOOL endOfFile;//determines if the end of file has been reached\n\
\n\
public:\n\
\n\
	");

	tstring DFAUncompressedH4 = _T(
"(tifstream& stream)\n\
		:fin(stream),\n\
		lastAccepting(ErrorState),\n\
		currentState(startStateIndex),\n\
		backupLength(0),\n\
		endOfFile(FALSE)\n\
	{}\n\
\n\
	//get the code stream\n\
	CodeStream& CodeStream()\n\
	{	return fin;		}\n\
\n\
	//return the current lexeme\n\
	tstring Lexeme()\n\
	{	return lexeme;	}\n\
\n\
	//get the current token\n\
	");

/////////////////////////////////////////////////////////////////////////

	tstring DFAUncompressedJava1 = _T(
"	final int ErrorState = -1;\n\
	final int startStateIndex = 0;\n\
	\n\
	int indexOf(char c)\n\
	{\n\
		if( c >= startSymbol && c <= finalSymbol )\n\
			return c - startSymbol ;\n\
		else return ErrorState ;\n\
	}\n\
\n\
	CodeStream fin;\n\
	char currentChar;\n\
	int lastAccepting;//last accepting state\n\
	int backupLength;//no of the characters read since the last accepting state\n\
	int currentState;//the current state!\n\
	StringBuffer lexeme;//the lexeme of the current token\n\
	boolean endOfFile = false;//determines if the end of file has been reached\n\
	\n\
	public ");

	tstring DFAUncompressedJava2 = _T(
"(RandomAccessFile stream)throws IOException\n\
	{\n\
		fin = new CodeStream(stream);\n\
		lastAccepting = ErrorState;\n\
		backupLength = 0;\n\
		currentState = startStateIndex;\n\
		lexeme = new StringBuffer();\n\
	}\n\
\n\
	//get the code stream\n\
	public CodeStream CodeStream()\n\
	{\n\
		return fin;\n\
	}\n\
\n\
	//return the current lexeme\n\
	public String Lexeme()\n\
	{\n\
		return lexeme.toString();\n\
	}\n\
\n\
	//get the current token\n\
	public ");

	tstring DFAUncompressedJava3 = _T(
"()throws IOException\n\
	{	//restore everything\n\
		lexeme = new StringBuffer();\n\
		currentState = startStateIndex;\n\
		lastAccepting = ErrorState;\n\
		backupLength = 0;\n\
		fin.Backup();\n\
		\n\
		//holds the state just before error state\n\
		int prevState = 0;\n\
\n\
		for(;;)\n\
		{\n\
			//read one more character\n\
			currentChar = fin.Peek();\n\
\n\
			if(endOfFile || currentChar == CodeStream.TEOF && lexeme.length() == 0)\n\
			{//end of file with no token in hands\n\
	\n\
				///Insert code for EOF\n\
				");

	tstring DFAUncompressedJava4 = _T(
"				break;\n\
			}\n\
			else\n\
			{\n\
				if(currentChar == CodeStream.TEOF && !lexeme.equals(\"\"))\n\
				{\n\
					currentState = ErrorState;\n\
					endOfFile = true;\n\
				}\n\
				else\n\
				{\n\
					fin.Advance();\n\
					lexeme.append(currentChar);\n\
					backupLength++;\n\
\n\
					//get the next state\n\
					prevState = currentState;\n\
					currentState = \n\
						transitionTable[currentState][indexOf(currentChar)];\n\
				}\n\
\n\
				//is there an error?\n\
				if(currentState != ErrorState)\n\
				{//no error:\n\
\n\
					//if it is an accepting state,save it\n\
					if(accepting[currentState])\n\
					{\n\
						fin.ReplaceLastBackup();\n\
						backupLength = 0;\n\
						lastAccepting = currentState;\n\
					}\n\
				}\n\
				else\n\
				{//error state:\n\
\n\
					if(lastAccepting == ErrorState)\n\
					{\n\
						///Insert Code For Invalid Token\n\
						");

	tstring DFAUncompressedJava5 = _T(
"						break;\n\
					}\n\
					else\n\
					{//accepting\n\
						//restore the input to the last accepting state\n\
						fin.Restore();\n\
						lexeme = new StringBuffer\n\
							(lexeme.substring(0,lexeme.length() - backupLength));\n\
\n\
						///Insert Appropriate Action Code\n\
						");

	tstring DFAUncompressedJava6 = _T(
"						break;\n\
					}\n\
				}//end of error state\n\
			}\n\
		}\n\
		return 0;\n\
	}\n\
	\n\
	class CodeStream \n\
	{\n\
		RandomAccessFile stream;\n\
		Stack lines;\n\
		Stack cols;\n\
		Stack positions;\n\
		int lineno;\n\
		int column;\n\
		int position;\n\
		\n\
		//this is for unicode\n\
		private final int byteScheme = 0;\n\
		private final int unicodeScheme = 1;\n\
		private final int unicodeBigEndianScheme = 2;\n\
		int codingScheme; \n\
		\n\
		public static final char TEOF = (char)-1;\n\
\n\
		public CodeStream(RandomAccessFile stream)throws IOException\n\
		{\n\
			this.stream = stream;\n\
			lines = new Stack();\n\
			cols = new Stack();\n\
			positions = new Stack();\n\
			lineno = 1;\n\
			column  = 1;\n\
			position = 0;\n\
			\n\
			//determine the encoding scheme\n\
			int prefix = (int)stream.readChar();\n\
			if(prefix == 0xFFFE )\n\
			{\n\
				codingScheme = unicodeScheme;\n\
				position += 2;\n\
			}\n");

	tstring DFAUncompressedJava6_1 = _T("\
			else if(prefix == 0xFEFF)\n\
			{\n\
				codingScheme = unicodeBigEndianScheme;\n\
				position += 2;\n\
			}\n\
			else\n\
			{\n\
				codingScheme = byteScheme;\n\
				stream.seek(0);\n\
			}\n\
		}\n\
\n\
		public int LineNo()\n\
		{\n\
			return lineno;\n\
		}\n\
\n\
		public int Column()\n\
		{\n\
			return column;\n\
		}\n\
\n\
		//Peek the next character from the stream\n\
		public char Peek()throws IOException\n\
		{\n\
			//read a character then seeks back .. \n\
			//since the RandomAccessFile doesn't support peeking\n\
			try\n\
			{\n\
				char ch = (char)0;\n\
				if(codingScheme == unicodeBigEndianScheme)\n\
					ch = stream.readChar();\n\
				else if(codingScheme == unicodeScheme)\n\
				{\n\
					ch = (char)stream.readByte();\n\
					short high = (short)stream.readByte();\n\
					high <<= 8;\n\
					ch |= high;	\n\
				}\n\
				else\n\
					ch = (char)stream.readByte();\n\
				stream.seek(position);\n\
				return ch;\n\
			}\n\
			catch(EOFException ex)\n\
			{\n\
				return TEOF;\n\
			}\n\
		}\n\
\n");

	tstring DFAUncompressedJava6_2 = _T("\
		//read a char and advance the file pointer \n\
		public char ReadChar()throws IOException\n\
		{\n\
			try\n\
			{\n\
				char ch;\n\
				if(codingScheme == unicodeBigEndianScheme)\n\
					ch = stream.readChar();\n\
				else if(codingScheme == unicodeScheme)\n\
				{\n\
					ch = (char)stream.readByte();\n\
					short high = (short)stream.readByte();\n\
					high <<= 8;\n\
					ch |= high;	\n\
				}\n\
				else\n\
					ch = (char)stream.readByte();\n\
				\n\
				if(ch == '\n')\n\
				{\n\
					lineno++;\n\
					column = 1;\n\
				}\n\
				else\n\
					column++;\n\
\n\
				if(codingScheme == byteScheme)\n\
					position ++;\n\
				else\n\
					position += 2;\n\
				\n\
				return ch;\n\
			}\n\
			catch(EOFException ex)\n\
			{\n\
				return TEOF;\n\
			}\n\
		}\n\
\n");

	tstring DFAUncompressedJava6_3 = _T("\
		//move the file stream one step ahead\n\
		public void Advance()throws IOException\n\
		{\n\
			ReadChar();\n\
		}\n\
		\n\
		//save current state\n\
		public void Backup()\n\
		{\n\
			lines.push(Integer.valueOf(lineno));\n\
			cols.push(Integer.valueOf(column));\n\
			positions.push(Integer.valueOf(position));\n\
		}\n\
\n\
		//restore most recently saved state\n\
		public void Restore()throws IOException\n\
		{\n\
			//restore saved state\n\
			lineno = ((Integer)lines.pop()).intValue();\n\
			column = ((Integer)cols.pop()).intValue();\n\
			position = ((Integer)positions.pop()).intValue();\n\
			stream.seek(position);\n\
		}\n\
\n\
		//replace the most recently saved state with the current state\n\
		public void ReplaceLastBackup()\n\
		{\n\
			//remove last saved state\n\
			lines.pop();\n\
			cols.pop();\n\
			positions.pop();\n\
\n\
			//save current state\n\
			lines.push(Integer.valueOf(lineno));\n\
			cols.push(Integer.valueOf(column));\n\
			positions.push(Integer.valueOf(position));\n\
		}\n\
	}");

/***************************************************************************/
//The string tables of the Pairs compression

	tstring DFAPairsCpp1 = DFAUncompressedCpp1;

	tstring DFAPairsCpp2 = _T(
";\n\
		}\n\
		else\n\
		{\n\
			if(currentChar == TEOF && !lexeme.empty())\n\
			{\n\
				currentState = ErrorState;\n\
				endOfFile = TRUE;\n\
			}\n\
			else\n\
			{\n\
				fin.Advance();\n\
				lexeme.push_back(currentChar);\n\
				backupLength++;\n\
\n\
				//get the next state\n\
				if(transitionTable[currentState] == NULL)\n\
					currentState = ErrorState;\n\
				else if(transitionTable[currentState][0] == 0)\n\
					currentState = \n\
					transitionTable[currentState][indexOf(currentChar)+1];\n\
				else \n");

	tstring DFAPairsCpp2_1 = _T("\
				{\n\
					int pair;\n\
					int tmp = currentState;\n\
					for(pair=0; pair<transitionTable[currentState][0]; pair++ )\n\
						if( transitionTable[currentState][pair * 2 + 1] == currentChar )\n\
						{\n\
							currentState = transitionTable[currentState][pair * 2 + 2];\n\
							break;\n\
						}\n\
					if(pair == transitionTable[tmp][0])\n\
						currentState = ErrorState;\n\
				}\n\
			}\n\
\n\
			//is there an error?\n\
			if(currentState != ErrorState)\n\
			{//no error:\n\
\n\
				//if it is an accepting state,save it\n\
				if(accepting[currentState])\n\
				{\n\
					fin.ReplaceLastBackup();\n\
					backupLength = 0;\n\
					lastAccepting = currentState;\n\
				}\n\
			}\n\
			else\n\
			{//error state:\n\
\n\
				if(lastAccepting == ErrorState)\n\
				{\n\
					fin.RemoveLastBackup();\n\
					return ");

	tstring DFAPairsCpp3 = DFAUncompressedCpp3;

	tstring DFAPairsCpp4 = DFAUncompressedCpp4;

	tstring DFAPairsCpp4_1 = DFAUncompressedCpp4_1;

	tstring DFAPairsCpp4_2 = DFAUncompressedCpp4_2;

	tstring DFAPairsCs1 = DFAUncompressedCs1;

	tstring DFAPairsCs2 = DFAUncompressedCs2;

	tstring DFAPairsCs3 = DFAUncompressedCs3;

	tstring DFAPairsCs4 = _T(
";\n\
			}\n\
			else\n\
			{\n\
				if(currentChar == CodeStream.TEOF && lexeme != \"\")\n\
				{\n\
					currentState = ErrorState;\n\
					endOfFile = true;\n\
				}\n\
				else\n\
				{\n\
					fin.Advance();\n\
					lexeme += new string(currentChar,1);\n\
					backupLength++;\n\
\n\
					//get the next state\n\
					if(transitionTable[currentState] == null)\n\
						currentState = ErrorState;\n\
					else if(transitionTable[currentState][0] == 0)\n\
						currentState = \n\
						transitionTable[currentState][indexOf(currentChar)+1];\n\
					else \n\
					{\n\
						int pair;\n");

	tstring DFAPairsCs4_1 = _T("\
						int tmp = currentState;\n\
						for(pair=0; pair<transitionTable[currentState][0]; pair++ )\n\
							if( transitionTable[currentState][pair * 2 + 1] == currentChar )\n\
							{\n\
								currentState = transitionTable[currentState][pair * 2 + 2];\n\
								break;\n\
							}\n\
						if(pair == transitionTable[tmp][0])\n\
							currentState = ErrorState;\n\
					}\n\
				}\n\
\n\
				//is there an error?\n\
				if(currentState != ErrorState)\n\
				{//no error:\n\
\n\
					//if it is an accepting state,save it\n\
					if(accepting[currentState])\n\
					{\n\
						fin.ReplaceLastBackup();\n\
						backupLength = 0;\n\
						lastAccepting = currentState;\n\
					}\n\
				}\n\
				else\n\
				{//error state:\n\
\n\
					if(lastAccepting == ErrorState)\n\
					{\n\
						fin.RemoveLastBackup();\n\
						return ");

	tstring DFAPairsCs5 = DFAUncompressedCs5;

	tstring DFAPairsCs6 = DFAUncompressedCs6;

	tstring DFAPairsCs6_1 = DFAUncompressedCs6_1;

	tstring DFAPairsCs6_2 = DFAUncompressedCs6_2;

	tstring DFAPairsCs6_3 = DFAUncompressedCs6_3;

	tstring DFAPairsH1 = DFAUncompressedH1;

	tstring DFAPairsH2 = _T(
"{\n\
	public:\n\
		class CodeStream\n\
		{\n\
		private:\n\
			tifstream& stream;\n\
			stack<int> lines;\n\
			stack<int> cols;\n\
			stack<int> positions;\n\
\n\
			int curlineno;\n\
			int curcolumn;\n\
			int nextlineno;\n\
			int nextcolumn;\n\
\n\
			int position;\n\
		public:\n\
			CodeStream(tifstream& _stream):\n\
				stream(_stream),\n\
				curlineno(1),\n\
				curcolumn(1),\n\
				nextlineno(1),\n\
				nextcolumn(1),\n\
				position(0)\n\
				{}\n\
\n\
			int CurrentLineNo()const;\n\
			int CurrentColumn()const;\n\
			int NextLineNo()const;\n\
			int NextColumn()const;\n\
\n");

	tstring DFAPairsH2_1 = _T("\
			TCHAR Peek();\n\
			void Advance();\n\
			TCHAR ReadChar();\n\
			void Backup();\n\
			void Restore();\n\
			void ReplaceLastBackup();\n\
			void RemoveLastBackup();\n\
			void SaveCurrentPosition();\n\
		};\n\
\n\
private:\n\
	static const int startStateIndex;\n\
	static const UTCHAR startSymbol;\n\
	static const UTCHAR finalSymbol;\n\
	static const int* transitionTable[];\n\
	\n\
	static const BOOL accepting[];\n\
	static int indexOf(UTCHAR c)\n\
	{\n\
		if( c >= startSymbol && c <= finalSymbol )\n\
			return c - startSymbol ;\n\
		else return ErrorState ;\n\
	}\n\
\n\
	CodeStream fin;\n\
	TCHAR currentChar;\n\
	int lastAccepting;//last accepting state\n\
	int backupLength;//no of the characters read since the last accepting state\n\
	int currentState;//the current state!\n\
	tstring lexeme;//the lexeme of the current token\n\
	BOOL endOfFile;//determines if the end of file has been reached\n\
\n\
public:\n\
\n\
	");

	tstring DFAPairsH3 = _T(
"(tifstream& stream)\n\
		:fin(stream),\n\
		lastAccepting(ErrorState),\n\
		currentState(startStateIndex),\n\
		backupLength(0),\n\
		endOfFile(FALSE)\n\
	{}\n\
\n\
	//get the code stream\n\
	CodeStream& CodeStream()\n\
	{	return fin;		}\n\
\n\
	//return the current lexeme\n\
	tstring Lexeme()\n\
	{	return lexeme;	}\n\
\n\
	//get the current token\n\
	");

	tstring DFAPairsJava1 = DFAUncompressedJava1;

	tstring DFAPairsJava2 = DFAUncompressedJava2;

	tstring DFAPairsJava3 = DFAUncompressedJava3;

	tstring DFAPairsJava4 = DFAUncompressedJava4;

	tstring DFAPairsJava5 = DFAUncompressedJava5;

	tstring DFAPairsJava6 = DFAUncompressedJava6;
	
/***************************************************************************/
//The string tables of the Pairs compression

	tstring DFARedundancyRemovedCpp1 = DFAUncompressedCpp1;

	tstring DFARedundancyRemovedCpp2 = _T(
";\n\
		}\n\
		else\n\
		{\n\
			if(currentChar == TEOF && !lexeme.empty())\n\
			{\n\
				currentState = ErrorState;\n\
				endOfFile = TRUE;\n\
			}\n\
			else\n\
			{\n\
				fin.Advance();\n\
				lexeme.push_back(currentChar);\n\
				backupLength++;\n\
\n\
				//get the next state\n\
				currentState = \n\
					transitionTable[rowMap[currentState]][columnMap[indexOf(currentChar)]];\n\
			}\n\
\n\
			//is there an error?\n\
			if(currentState != ErrorState)\n\
			{//no error:\n\
\n\
				//if it is an accepting state,save it\n\
				if(accepting[currentState])\n\
				{\n\
					fin.ReplaceLastBackup();\n\
					backupLength = 0;\n\
					lastAccepting = currentState;\n\
				}\n\
			}\n\
			else\n\
			{//error state:\n\
\n\
				if(lastAccepting == ErrorState)\n\
				{\n\
					fin.RemoveLastBackup();\n\
					return ");

	tstring DFARedundancyRemovedCpp3 = DFAUncompressedCpp3;

	tstring DFARedundancyRemovedCpp4 = DFAUncompressedCpp4;

	tstring DFARedundancyRemovedCpp4_1 = DFAUncompressedCpp4_1;

	tstring DFARedundancyRemovedCpp4_2 = DFAUncompressedCpp4_2;

	tstring DFARedundancyRemovedCs1 = DFAUncompressedCs1;

	tstring DFARedundancyRemovedCs2 = DFAUncompressedCs2;

	tstring DFARedundancyRemovedCs3 = DFAUncompressedCs3;

	tstring DFARedundancyRemovedCs4 = _T(
";\n\
			}\n\
			else\n\
			{\n\
				if(currentChar == CodeStream.TEOF && lexeme != \"\")\n\
				{\n\
					currentState = ErrorState;\n\
					endOfFile = true;\n\
				}\n\
				else\n\
				{\n\
					fin.Advance();\n\
					lexeme += new string(currentChar,1);\n\
					backupLength++;\n\
\n\
					//get the next state\n\
					currentState = \n\
						transitionTable[rowMap[currentState],columnMap[indexOf(currentChar)]];\n\
				}\n\
\n\
				//is there an error?\n\
				if(currentState != ErrorState)\n\
				{//no error:\n\
\n\
					//if it is an accepting state,save it\n\
					if(accepting[currentState])\n\
					{\n\
						fin.ReplaceLastBackup();\n\
						backupLength = 0;\n\
						lastAccepting = currentState;\n\
					}\n\
				}\n\
				else\n\
				{//error state:\n\
\n\
					if(lastAccepting == ErrorState)\n\
					{\n\
						fin.RemoveLastBackup();\n\
						return ");

	tstring DFARedundancyRemovedCs5 = DFAUncompressedCs5;

	tstring DFARedundancyRemovedCs6 = DFAUncompressedCs6;

	tstring DFARedundancyRemovedCs6_1 = DFAUncompressedCs6_1;

	tstring DFARedundancyRemovedCs6_2 = DFAUncompressedCs6_2;

	tstring DFARedundancyRemovedCs6_3 = DFAUncompressedCs6_3;

	tstring DFARedundancyRemovedH1 = DFAUncompressedH1;

	tstring DFARedundancyRemovedH2 = _T(
"{\n\
	public:\n\
		class CodeStream\n\
		{\n\
		private:\n\
			tifstream& stream;\n\
			stack<int> lines;\n\
			stack<int> cols;\n\
			stack<int> positions;\n\
\n\
			int curlineno;\n\
			int curcolumn;\n\
			int nextlineno;\n\
			int nextcolumn;\n\
\n\
			int position;\n\
		public:\n\
			CodeStream(tifstream& _stream):\n\
				stream(_stream),\n\
				curlineno(1),\n\
				curcolumn(1),\n\
				nextlineno(1),\n\
				nextcolumn(1),\n\
				position(0)\n\
				{}\n\
\n\
			int CurrentLineNo()const;\n\
			int CurrentColumn()const;\n\
			int NextLineNo()const;\n\
			int NextColumn()const;\n\
\n\
			TCHAR Peek();\n\
			void Advance();\n\
			TCHAR ReadChar();\n\
			void Backup();\n\
			void Restore();\n\
			void ReplaceLastBackup();\n\
			void RemoveLastBackup();\n\
			void SaveCurrentPosition();\n\
		};\n\
\n\
private:\n\
	static const int startStateIndex;\n\
	static const UTCHAR startSymbol;\n\
	static const UTCHAR finalSymbol;\n\
	static const int rowMap[];\n\
	static const int columnMap[];\n\
	static const int transitionTable[][");

	tstring DFARedundancyRemovedH3 = DFAUncompressedH3;

	tstring DFARedundancyRemovedH4 = DFAUncompressedH4;

	tstring DFARedundancyRemovedJava1 = DFAUncompressedJava1;

	tstring DFARedundancyRemovedJava2 = DFAUncompressedJava2;

	tstring DFARedundancyRemovedJava3 = DFAUncompressedJava3;

	tstring DFARedundancyRemovedJava4 = DFAUncompressedJava4;

	tstring DFARedundancyRemovedJava5 = DFAUncompressedJava5;

	tstring DFARedundancyRemovedJava6 = DFAUncompressedJava6;

}









