#pragma once

template<class T>
int Compare(const T& item1, const T& item2)
{
	if(item1<item2)	return -1; //i1 - i2 < 0
	else if(item2<item1) return 1;// i1 - i2 > 0
	else return 0;
}

template<class T>
int BinarySearch(const T *sortedArray, const T &item, int startIndex, int count)
{
	count--;		//count, from now on, will be the upper bound.
	int i = (startIndex+count) >> 1;
	while( startIndex <= count )
	{
		switch(Compare(item, sortedArray[i]))
		{
		case 0:
			return i;
		case -1:
			count = i - 1;
			break;
		case 1:
			startIndex = i + 1;
			break;
		}
		i = (startIndex+count) >> 1;
	}
	return -1;
}

/***Function Objects***/
//The following class object accepts a functor with signature FunctorType.
//FunctorType should have the signature: bool (*)(ObjectType)
//InverseFunctor(x) = ! Functor(x)
/*template< class FunctorType >
class InverseFunctor
{
private:
	FunctorType _functor;
public:
	InverseFunctor( FunctorType f ) : _functor(f)
	{}
	template< class ObjectType >
	bool operator ()(ObjectType &obj)
	{
		return ! functor(obj);
	}

};*/