#include "stdafx.h"
#include <algorithm>
#include <iostream>
using namespace std;
int sum = 0;
void Add(const int &x)
{
	sum += x;
}
namespace FunctionInstance
{
	void ForEach(int *begin, int *end, void f(const int &))
	{
		while(begin<end)
			f(*begin++);
		//or even (*f)(*begin++);
	}
};
namespace FunctionPointer
{
	void ForEach(int *begin, int *end, void (*f)(const int &))
	{
		while(begin<end)
			(*f)(*begin++);
		//or even f(*begin++);
	}
};
namespace FunctionReference
{
	void ForEach(int *begin, int *end, void (&f)(const int &))
	{
		while(begin<end)
			(*f)(*begin++);
		//or even f(*begin++);
	}
};
namespace TemplateFunctionObject
{
	template < class FunctionObject >
	void ForEach(int *begin, int *end, FunctionObject &f)
	/*Note: If you remove the reference ampersand '&' from FunctionObject &f, you
	 *will copy the object and any change will be lost!!
	 */
	{
		while(begin<end)
			f(*begin++);
	}
};
class Mean
{
private:
	int sum;
	int count;
public:
	Mean(int _sum = 0, int _count = 0): sum(_sum), count(_count)
	{}
	int Sum()
	{return sum;}
	int Count()
	{return count;}
	float GetMean()
	{
		return (count==0)?0:(float)sum/count;
	}
	void operator ()(const int &x)
	{
		sum += x;
		count++;
	}
};
#if TCHAR == wchar_t
	#define tcout wcout
	#define tcin wcin
#else
	#define tcout cout
	#define tcin cin
#endif
void main()
{
	int array[] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9};
	for_each(array, array+10, Add);
	tcout<<"The sum by using a function is: "<<sum<<endl;
	sum = 0;
	FunctionInstance::ForEach(array, array+10, Add);
	tcout<<"The sum by using a function is: "<<sum<<endl;
	sum = 0;
	FunctionPointer::ForEach(array, array+10, Add);
	tcout<<"The sum by using a function is: "<<sum<<endl;
	sum = 0;
	TemplateFunctionObject::ForEach(array, array+10, Add);
	tcout<<"The sum by using a function is: "<<sum<<endl;
	sum = 0;
	TemplateFunctionObject::ForEach(array, array+10, Add);
	tcout<<"The sum by using a function is: "<<sum<<endl;

	Mean m;
	TemplateFunctionObject::ForEach(array, array+10, m);
	tcout<<"m.Sum() = "<<m.Sum()<<endl;
	tcout<<"m.Count() = "<<m.Count()<<endl;
	tcout<<"m.GetMean() = "<<m.GetMean()<<endl;

	int x = 0;
	/*x++ = 12; //Compile-Time Error. Then, x++ doesnot return a variable.*/
	/*tcout<< ++(x++);//Compile-Time Error. Then, x++ doesnot return a variable.*/

}

