﻿%option CharacterSet = [\x0-\x7Fأ-يأبتثجحخدذرزسشصضطظعغفقكلمنهويئءؤلاىآةوزظطكمنتالبييسشضصثثقففغغعههخحخحجد1233456767890ًٌَُّلإإ‘لأأٍِْلآ’]
%option Language = C#
%option ClassName = ArabicExpressionScanner
%option FunctionName = GetToken
%option ReturnType = _TokenType
%option FileName = C:\tempo
%option CompressionTechnique = Redundancy
%option EOFAction = _TokenType.EndOfFile
%option InvalidTokenAction = _TokenType.InvalidToken

Letter		[أيأبتثجحخدذرزسشصضطظعغفقكلمنهويئءؤلاىآةوزظطكمنتالبييسشضصثثقففغغعههخحخحجدًٌَُّلإإ‘لأأٍِْلآ]
//Next, we provide the macros...
WhiteSpace	(" "|[\t\r\n])+
Digit		[0-9]
Number		({Digit}+(","{Digit}+)?)|({Digit}*","{Digit}+)
Identifier	({Letter}|[_])({Digit}|{Letter})*
Sin			جا
Cos			جتا				
Sinh		[Ss][Ii][Nn][Hh]			
%%
//Class Def
static void Main()
{
	string					fileName;
	StreamReader			sReader;
	ArabicExpressionScanner scanner;
	
	Console.Write("Enter file path: ");
	fileName = Console.ReadLine();
	sReader = new StreamReader(fileName, true);
	//Console.WriteLine(sReader.ReadLine());
	scanner = new ArabicExpressionScanner( sReader );
	scanner.GetToken();
	Console.WriteLine();
}
%%
 /*******************Machine Definition********************/
{WhiteSpace}	Console.Write(Lexeme);
 {Number}		{
					Console.Write(Lexeme);
				}
 "+"				{Console.Write(Lexeme);}
 "-"				{Console.Write(Lexeme);}
 "*"				{Console.Write(Lexeme);}
 "\\"				{Console.Write(Lexeme);}
 "%"				{Console.Write(Lexeme);}
 "^"				{Console.Write(Lexeme);}
{Sin}			{Console.Write("sin");}
{Cos}			{Console.Write("cos");}
{Sinh}			{Console.Write("sinh");}
{Identifier}	{Console.Write("ID");}
%%
//Inside namespace
enum _TokenType
{
	Number = 1,
	Identifier,
	Plus,
	Minus,
	Multiply,
	Divide,
	Moduolo,
	Power,
	Sin,
	Cos,
	Tan,
	Cot,
	Sec,
	Csc,
	Sinh,
	Cosh,
	Tanh,
	Coth,
	Sech,
	Csch,
	Arcsin,
	Arccos,
	Arctan,
	Arccot,
	Arcsec,
	Arccsc,
	Arcsinh,
	Arccosh,
	Arctanh,
	Arccoth,
	Arcsech,
	Arccsch,
	E,
	Ln,
	Log,
	Openpara,
	Closepara,
	OpenBracket, //[
	CloseBracket, //]
	Comma,
	EndOfFile,
	InvalidToken,
	//End of tokens
	//Beginning of Nonterminals
	Exp,
	Addop,
    Mulop,
	Sign,
	Term,
	Factor1,
	Factor2,
	Factor3,
	Factor4,
	Factor5,
	Factor3_1,
	Factor4_1,
	UnaryFn,
	Fn,
	Args
}
%%

%%