#pragma once
#ifndef _GenericCFGNode_h
#define _GenericCFGNode_h
#include "Globals.h"
#include "stdafx.h"
#include "BitSet_Min.h"
#include "Scanner.h"
//#include "ICodeGenerator.h" //it includes ParserGen.h
#include "ParserGen.h"
#include <list>
using namespace std;
//using namespace RDParserGenerator;
namespace RDParserGenerator
{
	class ParserGenerator;
	class ICodeGenerator;
class GenericCFGNode
{
public:
	NodeType NType;
	virtual BitSet_Min FirstSet(ParserGenerator* P);
	virtual bool FollowSet(ParserGenerator* P);
	virtual BitSet_Min GetNonTerminals(ParserGenerator* P);
	//void virtual GenerateCode( ICodeGenerator* gen ) = 0;
	void virtual Print(ParserGenerator* P)=0;
    virtual list<int>* GetIndeces(ParserGenerator*P,tstring NTName,int* Fn_count);
	virtual GenericCFGNode*   ReplaceIfPossible(ParserGenerator* P,map<tstring,NonTerminalEntry>::iterator Aj)=0;
	virtual GenericCFGNode*   Copy()=0;
	void virtual Remove()=0;
	void virtual PrintFile(ofstream* of,ParserGenerator* P)=0;
};
class OredNode:public GenericCFGNode
{
public:
	list<GenericCFGNode*> Children;
	OredNode();
	virtual BitSet_Min FirstSet(ParserGenerator* P);
	virtual bool FollowSet(ParserGenerator* P);
	virtual BitSet_Min GetNonTerminals(ParserGenerator* P);

	//void GenerateCode ( ICodeGenerator* gen );
	void virtual Print(ParserGenerator* P);
	virtual GenericCFGNode*   ReplaceIfPossible(ParserGenerator* P,map<tstring,NonTerminalEntry>::iterator Aj);
	virtual GenericCFGNode*   Copy();
	void virtual Remove();
	void virtual PrintFile(ofstream* of,ParserGenerator* P);
};

/*
class ClosureNode:public OredNode
{
public:
	ClosureNode();
	virtual BitSet_Min FirstSet(ParserGenerator* P);
	virtual bool FollowSet(ParserGenerator* P);
	virtual BitSet_Min GetNonTerminals(ParserGenerator* P);
	void GenerateCode ( ICodeGenerator* gen );
	void virtual Print(ParserGenerator* P);

};

class OptionNode:public OredNode
{
public:
	
	OptionNode();
	virtual BitSet_Min FirstSet(ParserGenerator* P);
	virtual bool FollowSet(ParserGenerator* P);
	virtual BitSet_Min GetNonTerminals(ParserGenerator* P);
	void GenerateCode ( ICodeGenerator* gen );
	void virtual Print(ParserGenerator* P);
};*/
/*
class BracketNode:public OredNode
{
public:	
	BracketNode()
	{
		this->NType = _Brackets;
	}
	virtual BitSet_Min FirstSet(ParserGenerator* P)
	{		
		BitSet_Min BS=(*Children.begin())->FirstSet( P);
		return BS;
	}
};*/
class AndedNode:public OredNode
{
public:
	tstring ResolverString;
	AndedNode();
	virtual BitSet_Min FirstSet(ParserGenerator* P);
	virtual bool FollowSet(ParserGenerator* P);
	virtual BitSet_Min GetNonTerminals(ParserGenerator* P);
	//void GenerateCode ( ICodeGenerator* gen );
	void virtual Print(ParserGenerator* P);
	virtual list<int>* GetIndeces(ParserGenerator*P,tstring NTName,int* Fn_count);
	virtual GenericCFGNode*   ReplaceIfPossible(ParserGenerator* P,map<tstring,NonTerminalEntry>::iterator Aj);
	virtual GenericCFGNode*   Copy();
	void virtual Remove();
	void virtual PrintFile(ofstream* of,ParserGenerator* P);
};

class SemActionNode:public GenericCFGNode
{
public:
	unsigned int  NameIndex;
	tstring SemAction;
	SemActionNode();
	virtual BitSet_Min FirstSet(ParserGenerator* P);
	virtual BitSet_Min GetNonTerminals(ParserGenerator* P);

	//void GenerateCode ( ICodeGenerator* gen );
	void virtual Print(ParserGenerator* P);
	virtual list<int>* GetIndeces(ParserGenerator*P,tstring NTName,int* Fn_count);
	virtual GenericCFGNode*   ReplaceIfPossible(ParserGenerator* P,map<tstring,NonTerminalEntry>::iterator Aj);
	virtual GenericCFGNode*   Copy();
	void virtual Remove();
	void virtual PrintFile(ofstream* of,ParserGenerator* P);
};


class TerminalNode:public GenericCFGNode
{
public:
	unsigned int  NameIndex;
	tstring Attributes;
	RDParserGenerator::TokenType TerminalType;
	bool IsWeak;
	TerminalNode();
	virtual BitSet_Min FirstSet(ParserGenerator* P);
	virtual BitSet_Min GetNonTerminals(ParserGenerator* P);
	//void GenerateCode ( ICodeGenerator* gen );
	void virtual Print(ParserGenerator* P);
	virtual GenericCFGNode*   Copy();
	virtual list<int>* GetIndeces(ParserGenerator*P,tstring NTName,int* Fn_count);
	virtual GenericCFGNode*  ReplaceIfPossible(ParserGenerator* P,map<tstring,NonTerminalEntry>::iterator Aj);
	void virtual Remove();
	void virtual PrintFile(ofstream* of,ParserGenerator* P);
};
class NonTerminalNode :public TerminalNode
{
public:
	NonTerminalNode();
	virtual BitSet_Min FirstSet(ParserGenerator* P);
	virtual BitSet_Min GetNonTerminals(ParserGenerator* P);
	//void GenerateCode ( ICodeGenerator* gen );
	void virtual Print(ParserGenerator* P);
	virtual list<int>* GetIndeces(ParserGenerator*P,tstring NTName,int* Fn_count);
	void virtual Remove();
	virtual GenericCFGNode*   ReplaceIfPossible(ParserGenerator* P,map<tstring,NonTerminalEntry>::iterator Aj);
	virtual GenericCFGNode*   Copy();
	void virtual PrintFile(ofstream* of,ParserGenerator* P);
};
/*class AnyNode:public GenericCFGNode//feeha shak
{
public:
	AnyNode();
	virtual BitSet_Min FirstSet(ParserGenerator* P);
	virtual BitSet_Min GetNonTerminals(ParserGenerator* P);
	void GenerateCode ( ICodeGenerator* gen );
	void virtual Print(ParserGenerator* P);
};*/
class SyncNode:public GenericCFGNode
{
public:
	SyncNode();
	virtual BitSet_Min FirstSet(ParserGenerator* P);
	virtual BitSet_Min GetNonTerminals(ParserGenerator* P);
	//void GenerateCode ( ICodeGenerator* gen );
	void virtual Print(ParserGenerator* P);
	virtual GenericCFGNode*  ReplaceIfPossible(ParserGenerator* P,map<tstring,NonTerminalEntry>::iterator Aj);
	virtual GenericCFGNode*   Copy();
	void virtual Remove();
	void virtual PrintFile(ofstream* of,ParserGenerator* P);
};
}
#endif