#pragma once
#include "stdafx.h"
#include "Scanner.h"
#include "Globals.h"
//#include "ProductionRule.h"
//#include "GenericCFGNode.h"

#include <list>
#include <map>

#include "BitSet_Min.h"
#include "stdafx.h"
using namespace std;

namespace RDParserGenerator
{
	class GenericCFGNode;
	class OredNode;
	class ClosureNode;
	class OptionNode;
	//class BracketNode;
	class AndedNode;
	class SemActionNode;
	class TerminalNode;
	class NonTerminalNode;
	class AnyNode;
	class SyncNode;

	class ProductionRule;
	class TerminalEntry
	{
	public:
		unsigned int NameIndex;
		BitSet_Min* FirstSet;
		TokenType Type;
		TerminalEntry();
		TerminalEntry(unsigned int NI,TokenType T);
	};
	class NonTerminalEntry
	{
	public:
		unsigned int NameIndex;
		BitSet_Min* FirstSet;
		BitSet_Min* FollowSet;
		ProductionRule* Rule;
		NonTerminalEntry();
		NonTerminalEntry(unsigned int NI);

	};
	class CodeEntry
	{
	public :
			tstring Code;
			tstring FunctionName;
			CodeEntry();
			CodeEntry(tstring C,tstring fn);
	};
	class ParserGenerator
	{
	private:
		void CalculateFirstSetS();
		void CalculateFollowSetS();
		
	public:
		ParserGenerator(string fileName);
		void PrintFile(string filename);
		void Parse();
		void OptionsSet();
		void TokensSet();
		void TopOfDeclaration();
		void TopOfDefinition();
		void BottomOfDeclaration();
		void BottomOfDefinition();
		void Productions();
		void Expression(GenericCFGNode** node1);
		void Term(GenericCFGNode** node1);
		void Factor(GenericCFGNode** node1);
		void PrintFirstSet();
		void PrintFollowSets();
		void PrintRules(list<ProductionRule*> G);
		void GenerateLL1Table();
		void PrintLL1Table();
		void RemoveLeftRecursion();
		tstring ParserGenerator::GetTerminalName(unsigned int NameIndex);
		ProductionRule* ILRemoval(ProductionRule* Rule,map<tstring,NonTerminalEntry>* Temp_NonTerminals);
		tstring GetNonTerminalName( unsigned int NameIndex );
		~ParserGenerator();
		
		Scanner* scanner;
		tstring StrNameSpace;
		tstring StrClassName;
		TokenType ParserLanguage;
		//Peace of Codes
		tstring StrDecTop;
		tstring StrDecBottom;
		tstring StrDefTop;
		tstring StrDefBottom;
		//Terminals & Noin Terminals
		map<tstring,TerminalEntry> Terminals;
		//map<unsigned int,TerminalEntry*> TerminalsInverse;
		map<tstring,NonTerminalEntry> NonTerminals;
		map<unsigned int,CodeEntry> Codes;
		//map<unsigned int,NonTerminalEntry*> NonTerminalsInverse;
		unsigned int nextTerminalIndex, nextNonTerminalIndex,nextCodeIndex;
		//the Grammer
		list<ProductionRule*> Grammer;	
		list<ProductionRule*> LRR_Grammer;
		//GenericCFGNode*** LL1Table;
		list<int>*** LL1Table;//two dimensional Array of list<int>*
		//CodeGeneration Additions Begin
		map<unsigned int, tstring> TokensNames;
		//CodeGeneration Additions End
		
		bool HasErrors;
		bool ResumeOnError;
		
	protected:
		void match(TokenType expected);
		void onError(tstring errorMsg);
		Token token;
		
	};
}
