#include "stdafx.h"
#include "GenericCFGNode.h"
#include "ParserGen.h"
#include "ProductionRule.h"
using namespace RDParserGenerator;


//GenericCFGNode class
BitSet_Min GenericCFGNode::FirstSet(ParserGenerator* P)
{
	BitSet_Min BS(P->nextTerminalIndex);
	return BS;
}
bool GenericCFGNode::FollowSet(ParserGenerator* P)
{
	//Unreachable return
	return false;
}
BitSet_Min GenericCFGNode::GetNonTerminals(ParserGenerator* P)
{
	BitSet_Min BS(P->nextTerminalIndex);
	return BS;
}

//OredNode class
OredNode::OredNode()
{
	this->NType = _Ored;
}
BitSet_Min OredNode::FirstSet(ParserGenerator* P)
{
	BitSet_Min BS(P->nextTerminalIndex); //the terminal size
	list<GenericCFGNode*>::iterator Ch_iter;
	for(Ch_iter=Children.begin();Ch_iter!=Children.end();Ch_iter++)
	{
		BitSet_Min CH_BS = (*Ch_iter)->FirstSet( P);
		BS.SetUnion(CH_BS);
	}
	return BS;
}
bool OredNode::FollowSet(ParserGenerator* P)
{
	bool Changed= false;
	for(list<GenericCFGNode*>::iterator Iter= Children.begin();Iter!=Children.end();Iter++)
	{
		Changed|=(*Iter)->FollowSet(P);
	}
	//unreachable logically
	return Changed; 
}
BitSet_Min OredNode::GetNonTerminals(ParserGenerator* P)
{
	BitSet_Min BS(P->nextNonTerminalIndex-NonTerminalBase);
	for(list<GenericCFGNode*>::iterator Iter= Children.begin();Iter!=Children.end();Iter++)
	{
		BS.SetUnion((*Iter)->GetNonTerminals(P));
	}
	return BS;
}


//ClosureNode class
/*ClosureNode::ClosureNode()
{
	this->NType = _Closure;
}
BitSet_Min ClosureNode::FirstSet(ParserGenerator* P)
{		
	BitSet_Min BS=(*Children.begin())->FirstSet( P);
	BS.Add(0);//for Epsilon
	return BS;
}
bool ClosureNode::FollowSet(ParserGenerator* P)
{
	//I think this is to be reformulated ya hamdy -- MSaber
	for(list<GenericCFGNode*>::iterator Iter= Children.begin();Iter!=Children.end();Iter++)
	{
		return (*Iter)->FollowSet(P);
	}
	//unreachable logically
	return false; 
}
BitSet_Min ClosureNode::GetNonTerminals(ParserGenerator* P)
{
	BitSet_Min BS(P->nextNonTerminalIndex);
	return (*this->Children.begin())->GetNonTerminals(P);
}
void ClosureNode::GenerateCode ( ICodeGenerator* gen )
{
	gen->ClosureGenerator( this );
}

//OptionNode class
OptionNode::OptionNode()
{
	this->NType = _Optional;
}
BitSet_Min OptionNode::FirstSet(ParserGenerator* P)
{		
	BitSet_Min BS=(*Children.begin())->FirstSet( P);
	BS.Add(0);//for Epsilon
	return BS;
}
bool OptionNode::FollowSet(ParserGenerator* P)
{
	for(list<GenericCFGNode*>::iterator Iter= Children.begin();Iter!=Children.end();Iter++)
	{
		return (*Iter)->FollowSet(P);
	}
	//unreachable logically
	return false; 
}
BitSet_Min OptionNode::GetNonTerminals(ParserGenerator* P)
{
	BitSet_Min BS(P->nextNonTerminalIndex);
	return (*this->Children.begin())->GetNonTerminals(P);
}
void OptionNode::GenerateCode ( ICodeGenerator* gen )
{
	gen->OptionalGenerator( this );
}*/
/*
class BracketNode:public OredNode
{
public:	
	BracketNode()
	{
		this->NType = _Brackets;
	}
	virtual BitSet_Min FirstSet(ParserGenerator* P)
	{		
		BitSet_Min BS=(*Children.begin())->FirstSet( P);
		return BS;
	}
};*/

//AndedNode class
AndedNode::AndedNode()
{
	this->NType=_Anded;
}
BitSet_Min AndedNode::FirstSet(ParserGenerator* P)
{
	BitSet_Min BS(P->nextTerminalIndex); //the terminal size
	list<GenericCFGNode*>::iterator Ch_iter;
	for(Ch_iter=Children.begin();Ch_iter!=Children.end();Ch_iter++)
	{
		BitSet_Min CH_BS = (*Ch_iter)->FirstSet( P);
		BS.SetUnion(CH_BS);
		if(!CH_BS.Contains(0))
		{
			BS.Remove(0);
			break;
		}
	}
	return BS;
}
bool AndedNode::FollowSet(ParserGenerator* P)
{
	bool Changed= false;
		
	for(list<GenericCFGNode*>::iterator Iter= Children.begin();Iter!=Children.end();Iter++)
	{
		Changed|=(*Iter)->FollowSet(P);
		BitSet_Min NTs = (*Iter)->GetNonTerminals(P);
		//bool EpsInAll= true;
		if(!NTs.IsEmpty())
		{
			BitSet_Min FirstSetOfNextTerms(P->nextTerminalIndex);
			list<GenericCFGNode*>::iterator ChIter= Iter;
			ChIter++;
			bool GetOut=false;
			for(;ChIter!=Children.end();ChIter++)
			{
				BitSet_Min fs = (*ChIter)->FirstSet(P);
				if(!fs.Contains(0))
				{
					GetOut=true;
				}
				fs.Remove(0);
				//BitSet_Min fSet = *(*NTiter).second.FollowSet;
				FirstSetOfNextTerms.SetUnion(fs);
				//if(fSet(*NTiter).second.FollowSet->IsSubsetOf())
				if(GetOut)
				{
	//				EpsInAll=false;
					break;
				}
			}
			int start=-1;
			while((start=NTs.NextMemberFrom(start+1))!=-1)
			{
                //BitSet_Min firstset;
				int NIndex = start+NonTerminalBase;
				for(map<tstring,NonTerminalEntry>::iterator NTiter=P->NonTerminals.begin();NTiter!=P->NonTerminals.end();NTiter++)
				{
					if((*NTiter).second.NameIndex==NIndex)
					{
						//Shakek feeha remember for debuging
						//bool GetOut=false;
						BitSet_Min fs = *(*NTiter).second.FollowSet;
                           (*NTiter).second.FollowSet->SetUnion(FirstSetOfNextTerms);
						if(!fs.Equals(*(*NTiter).second.FollowSet))
							Changed = true;
						/*if(EpsInAll)
						{
							//Make an action
						}*/
					}
				}
			}
		}
		//GetNonTerminals(Child)
		//Add to NonTerminals first of elli ba3diha
	}
	//unreachable logically
	return Changed; 
}
BitSet_Min AndedNode::GetNonTerminals(ParserGenerator* P)
{
	BitSet_Min BS(P->nextNonTerminalIndex-NonTerminalBase);
	/*list<GenericCFGNode*>::iterator Iter= Children.end();
	Iter--;
	for(;Iter!=Children.begin();Iter--)*/
	for(list<GenericCFGNode*>::reverse_iterator Iter= Children.rbegin();Iter!=Children.rend();Iter++)
	{
		BS.SetUnion((*Iter)->GetNonTerminals(P));
		BitSet_Min fs = (*Iter)->FirstSet(P); 
		if(!fs.Contains(0))
			break;
	}		
	return BS;
}



//SemActionNode class
SemActionNode::SemActionNode()
{
	this->NType = _SemAction;
	this->SemAction="";
}
BitSet_Min SemActionNode::FirstSet(ParserGenerator* P)
{
	BitSet_Min BS(P->nextTerminalIndex);//ter,minal size
	BS.Add(0);
	return BS;
}
BitSet_Min SemActionNode::GetNonTerminals(ParserGenerator* P)
{
	BitSet_Min BS(P->nextNonTerminalIndex-NonTerminalBase);
	return BS;
}




//TerminalNode class
TerminalNode::TerminalNode()
{
	this->NType = _Terminal;		
}
BitSet_Min TerminalNode::FirstSet(ParserGenerator* P)
{
	//return its set
	BitSet_Min BS(P->nextTerminalIndex);
	BS.Add(NameIndex);
	return BS;
}
BitSet_Min TerminalNode::GetNonTerminals(ParserGenerator* P)
{
	BitSet_Min BS(P->nextNonTerminalIndex-NonTerminalBase);
	return BS;
}



//NonTerminalNode class
NonTerminalNode::NonTerminalNode()
{
	this->NType = _NonTerminal;		
}
BitSet_Min NonTerminalNode::FirstSet(ParserGenerator* P)
{
	//return its set/
	//BitSet_Min BS(P->nextTerminalIndex); //remember for optimization
	for(map<tstring,NonTerminalEntry>::iterator iter=P->NonTerminals.begin();iter!=P->NonTerminals.end();iter++)
	{
		if((*iter).second.NameIndex==NameIndex)
		{
			/*firstset = *(*iter).second.FirstSet;
			break;*/
			return *(*iter).second.FirstSet;
		}
	}
	//return BS;
}
BitSet_Min NonTerminalNode::GetNonTerminals(ParserGenerator* P)
{
	BitSet_Min BS(P->nextNonTerminalIndex-NonTerminalBase);
	BS.Add(this->NameIndex-NonTerminalBase);
	return BS;
}


//AnyNode class
/*AnyNode::AnyNode()
{
	this->NType = _AnyNode;
}
BitSet_Min AnyNode::FirstSet(ParserGenerator* P)
{
	BitSet_Min BS(P->nextTerminalIndex);
	BS.AddAllElements();
	//return its set
	return BS; //Shakek feeeeeha
}
BitSet_Min AnyNode::GetNonTerminals(ParserGenerator* P)
{
	BitSet_Min BS(P->nextNonTerminalIndex-NonTerminalBase);
	return BS;
}

void AnyNode::GenerateCode ( ICodeGenerator* gen )
{

}
*/
//SyncNode class
SyncNode::SyncNode()
{
	this->NType = _SyncNode;
}
BitSet_Min SyncNode::FirstSet(ParserGenerator* P)
{
	//return its set
	BitSet_Min BS(P->nextTerminalIndex);//terminal size
	BS.Add(0);
	return BS;
}
BitSet_Min SyncNode::GetNonTerminals(ParserGenerator* P)
{
	BitSet_Min BS(P->nextNonTerminalIndex-NonTerminalBase);
	return BS;
}


void OredNode::Print(ParserGenerator* P)
{
	cout<<"Ored ( ";
	for(list<GenericCFGNode*>::iterator Iter= Children.begin();Iter!=Children.end();Iter++)
	{
		(*Iter)->Print(P);
		list<GenericCFGNode*>::iterator tempIter =Iter;
		tempIter++;
		if(tempIter!=Children.end())
			cout<<" , ";
	}
	cout<<" ) ";
}
void AndedNode::Print(ParserGenerator* P)
{
	cout<<"Anded ( ";
	for(list<GenericCFGNode*>::iterator Iter= Children.begin();Iter!=Children.end();Iter++)
	{
		(*Iter)->Print(P);
		list<GenericCFGNode*>::iterator tempIter =Iter;
		tempIter++;
		if(tempIter!=Children.end())
			cout<<" , ";
	}
	cout<<" ) ";
}
/*
void ClosureNode::Print(ParserGenerator* P)
{
	cout<<"Closure ( ";
	for(list<GenericCFGNode*>::iterator Iter= Children.begin();Iter!=Children.end();Iter++)
	{
		(*Iter)->Print(P);
		list<GenericCFGNode*>::iterator tempIter =Iter;
		tempIter++;
		if(tempIter!=Children.end())
			cout<<" , ";
	}
	cout<<" ) ";
}
void OptionNode::Print(ParserGenerator* P)
{
	cout<<"Option ( ";
	for(list<GenericCFGNode*>::iterator Iter= Children.begin();Iter!=Children.end();Iter++)
	{
		(*Iter)->Print(P);
		list<GenericCFGNode*>::iterator tempIter =Iter;
		tempIter++;
		if(tempIter!=Children.end())
			cout<<" , ";
	}
	cout<<" ) ";
}*/
void TerminalNode::Print(ParserGenerator* P)
{
	for(map<tstring,TerminalEntry>::iterator iter=P->Terminals.begin();iter!=P->Terminals.end();iter++)
	{
		if((*iter).second.NameIndex==NameIndex)
		{
			/*firstset = *(*iter).second.FirstSet;
			break;*/
			cout<<'\''<<(*iter).first.c_str()<<'\'';
		}
	}
}
void NonTerminalNode::Print(ParserGenerator* P)
{
	for(map<tstring,NonTerminalEntry>::iterator iter=P->NonTerminals.begin();iter!=P->NonTerminals.end();iter++)
	{
		if((*iter).second.NameIndex==NameIndex)
		{
			/*firstset = *(*iter).second.FirstSet;
			break;*/
			cout<<(*iter).first.c_str();
		}
	}

}
void SyncNode::Print(ParserGenerator* P)
{
	cout<<"Sync";
}
void SemActionNode::Print(ParserGenerator* P)
{
	cout<<this->SemAction.c_str();
}
/*void AnyNode::Print(ParserGenerator* P)
{
	cout<<"ANY";
}*/
/*
list<int>* AndedNode::GetIndeces()
{
	list<int> l;
	return l;

}*/
list<int>*GenericCFGNode::GetIndeces(ParserGenerator*P,tstring NTName,int* Fn_count)
{
	list<int>* l;
	return l;
}
list<int>* TerminalNode::GetIndeces(ParserGenerator*P,tstring NTName,int* Fn_count)
{
	list<int>* l= new list<int>;
	l->push_back(NameIndex);
	return l;
}
list<int>* NonTerminalNode::GetIndeces(ParserGenerator*P,tstring NTName,int* Fn_count)
{
	list<int>* l= new list<int>;
	l->push_back(NameIndex);
	return l;
}
list<int>* AndedNode::GetIndeces(ParserGenerator*P,tstring NTName,int* Fn_count)
{
	list<int>* l= new list<int>;
	for(list<GenericCFGNode*>::iterator Iter= Children.begin();Iter!=Children.end();Iter++)
	{
		if((*Iter)->NType==_Terminal)
			l->push_back(((TerminalNode*)*Iter)->NameIndex);
		else if((*Iter)->NType==_NonTerminal)
			l->push_back(((NonTerminalNode*)*Iter)->NameIndex);
		else
			if((*Iter)->NType==_SemAction)
			{
				unsigned int Ind_Debug = ((SemActionNode*)*Iter)->NameIndex;
				//const char* Debug_Code=P->Codes[Ind_Debug].Code.c_str();
				l->push_back(((SemActionNode*)*Iter)->NameIndex);
					//Generate FuctionName
				if(P->Codes.find(((SemActionNode*)*Iter)->NameIndex)==P->Codes.end())
				{
					tstring fn_Name=NTName+'_';
					if(*(Fn_count)==0)
					{
						fn_Name+='0';
					}
					else
					{
						tstring temp="";
						unsigned int x = *(Fn_count);
						while(x!=0)
						{
							int i=x%10+(int)'0';
							char c = (char)i;
							temp=c+temp;
							x=x/10;
						}
						fn_Name+=temp;
					}
	
					//FunctionNameGenerated
					CodeEntry CE(((SemActionNode*)*Iter)->SemAction,fn_Name);
					P->Codes[((SemActionNode*)*Iter)->NameIndex]=CE;
					*Fn_count=*Fn_count+1;
				}
				//cout<<"hello";
			}
			
	}
	return l;
}
list<int>* SemActionNode::GetIndeces(ParserGenerator*P,tstring NTName,int* Fn_count)
{
	list<int>* l= new list<int>;
	l->push_back(NameIndex);
	if(P->Codes.find(NameIndex)==P->Codes.end())
	{
	//Generate FuctionName
	tstring fn_Name=NTName+'_';
	if(*(Fn_count)==0)
	{
		fn_Name+='0';
	}
	else
	{
		tstring temp="";
		int x = *(Fn_count);
		while(x!=0)
		{
			int i=x%10+(int)'0';
			char c = (char)i;
			temp=c+temp;
			x=x/10;
		}
		fn_Name+=temp;
	}

	//FunctionNameGenerated
	CodeEntry CE(this->SemAction,fn_Name);
	P->Codes[NameIndex]=CE;
	*Fn_count=*Fn_count+1;
	}

	return l;
}
GenericCFGNode*  OredNode::ReplaceIfPossible(ParserGenerator* P,map<tstring,NonTerminalEntry>::iterator Aj)
{
	OredNode* ReturnedNode = new OredNode();
	for(list<GenericCFGNode*>::iterator Iter= Children.begin();Iter!=Children.end();Iter++)
	{
		GenericCFGNode* node = (*Iter)->ReplaceIfPossible(P,Aj);
		if(node->NType !=_Ored)
		{	
			ReturnedNode->Children.push_back(node);
		}
		else
		{
			for(list<GenericCFGNode*>::iterator ChIter= ((OredNode*)node)->Children.begin();ChIter!=((OredNode*)node)->Children.end();ChIter++)
			{
				ReturnedNode->Children.push_back((*ChIter)->Copy());
			}
			((OredNode*)node)->Children.clear();
			delete node;
			
		}
	}
	return ReturnedNode;
	
}

GenericCFGNode*  AndedNode::ReplaceIfPossible(ParserGenerator* P,map<tstring,NonTerminalEntry>::iterator Aj)
{
	//GenericCFGNode* ReturnedNode;
	list<GenericCFGNode*>::iterator Iter;
	for(Iter= Children.begin();Iter!=Children.end()&&((*Iter)->NType==_SyncNode||(*Iter)->NType==_SemAction);Iter++);
	if(Iter!=Children.end()&&(*Iter)->NType==_NonTerminal)
	{
		
		if(((NonTerminalNode*)*Iter)->NameIndex==(*Aj).second.NameIndex)
		{
			GenericCFGNode* AjNodeCopy=(*Aj).second.Rule->RHS->Copy();
			list<GenericCFGNode*>::iterator CopyIter = Iter;
			CopyIter++;
			if(AjNodeCopy->NType!=_Ored)
			{	
				for(;Iter!=Children.begin();Iter--)
				{
					if((*Iter)->NType==_NonTerminal && ((NonTerminalNode*)*Iter)->NameIndex==(*Aj).second.NameIndex)
						continue;
					if(AjNodeCopy->NType==_Anded)
					{
						((AndedNode*)AjNodeCopy)->Children.push_front((*Iter)->Copy());
					}
					else
					{
						AndedNode* andnode = new AndedNode();
						andnode->Children.push_front(AjNodeCopy);
						andnode->Children.push_front((*Iter)->Copy());
						AjNodeCopy = andnode;
					}
				}
				
				for(;CopyIter!=Children.end();CopyIter++)
				{
					if(AjNodeCopy->NType==_Anded)
					{
						((AndedNode*)AjNodeCopy)->Children.push_back((*CopyIter)->Copy());
					}
					else
					{
						AndedNode* andnode = new AndedNode();
						andnode->Children.push_back(AjNodeCopy);
						andnode->Children.push_back((*CopyIter)->Copy());
						AjNodeCopy = andnode;
					}	
						
				}	
			}
			else
			{
				list<GenericCFGNode*>::iterator CIter = CopyIter;
				for(list<GenericCFGNode*>::iterator AjIter= ((OredNode*)AjNodeCopy)->Children.begin();AjIter!=((OredNode*)AjNodeCopy)->Children.end();AjIter++)
				{
					
					for(;Iter!=Children.begin();Iter--)
					{
						if((*Iter)->NType==_NonTerminal)
							continue;
						if((*AjIter)->NType==_Anded)
						{
							((AndedNode*)*AjIter)->Children.push_front((*Iter)->Copy());
						}
						else
						{
							AndedNode* andnode = new AndedNode();
							andnode->Children.push_front(*AjIter);
							andnode->Children.push_front((*Iter)->Copy());
							(*AjIter) = andnode;
						}
					}
					
					for(;CopyIter!=Children.end();CopyIter++)
					{
						if((*AjIter)->NType==_Anded)
						{
							((AndedNode*)*AjIter)->Children.push_back((*CopyIter)->Copy());
						}
						else
						{
							AndedNode* andnode = new AndedNode();
							andnode->Children.push_back(*AjIter);
							andnode->Children.push_back((*CopyIter)->Copy());
							(*AjIter) = andnode;
						}	
							
					}
					CopyIter = CIter;


				}

			}
			return AjNodeCopy;
		}
		else 
		{
			return this->Copy();
		}
	}
	//logically unreachable
	return this->Copy();
}
GenericCFGNode* TerminalNode::ReplaceIfPossible(ParserGenerator* P,map<tstring,NonTerminalEntry>::iterator Aj)
{
	return this->Copy();
}
GenericCFGNode*  NonTerminalNode::ReplaceIfPossible(ParserGenerator* P,map<tstring,NonTerminalEntry>::iterator Aj)
{
	if(NameIndex==(*Aj).second.NameIndex)
	{
		return (*Aj).second.Rule->RHS->Copy();
	}
}
GenericCFGNode*  SemActionNode::ReplaceIfPossible(ParserGenerator* P,map<tstring,NonTerminalEntry>::iterator Aj)
{
	return this->Copy();
}
GenericCFGNode*  SyncNode::ReplaceIfPossible(ParserGenerator* P,map<tstring,NonTerminalEntry>::iterator Aj)
{
	return this->Copy();
}
GenericCFGNode* OredNode::Copy()
{
	OredNode * NodeCopy = new OredNode();
	for(list<GenericCFGNode*>::iterator Iter= Children.begin();Iter!=Children.end();Iter++)
	{
		GenericCFGNode* ch = (*Iter)->Copy();
		NodeCopy->Children.push_back(ch);
	}
	return NodeCopy;
}
GenericCFGNode* AndedNode::Copy()
{
	AndedNode * NodeCopy = new AndedNode();
	for(list<GenericCFGNode*>::iterator Iter= Children.begin();Iter!=Children.end();Iter++)
	{
		GenericCFGNode* ch = (*Iter)->Copy();
		NodeCopy->Children.push_back(ch);
	}
	return NodeCopy;
}
GenericCFGNode* TerminalNode::Copy()
{
	TerminalNode*  NodeCopy= new TerminalNode();
	NodeCopy->Attributes = Attributes;
	NodeCopy->IsWeak = IsWeak;
	NodeCopy->NameIndex = NameIndex;
	//NodeCopy->NType = NType;
	NodeCopy->TerminalType = TerminalType;

	return NodeCopy;

}
GenericCFGNode* NonTerminalNode::Copy()
{
	NonTerminalNode* NodeCopy = new NonTerminalNode();
	NodeCopy->Attributes = Attributes;
	NodeCopy->IsWeak = IsWeak;
	NodeCopy->NameIndex = NameIndex;
	//NodeCopy->NType = NType;
	NodeCopy->TerminalType = TerminalType;

	return NodeCopy;
}
GenericCFGNode* SemActionNode::Copy()
{
	SemActionNode* NodeCopy = new SemActionNode();
	NodeCopy->NameIndex = NameIndex;
	NodeCopy->SemAction = SemAction;
	return NodeCopy; 
}
GenericCFGNode* SyncNode::Copy()
{
	return  new SyncNode();
}
void OredNode::Remove()
{
	for(list<GenericCFGNode*>::iterator Iter= Children.begin();Iter!=Children.end();Iter++)
	{
		(*Iter)->Remove();
		delete (*Iter);
	}
	Children.clear();

}
void AndedNode::Remove()
{
	for(list<GenericCFGNode*>::iterator Iter= Children.begin();Iter!=Children.end();Iter++)
	{
		(*Iter)->Remove();
		delete (*Iter);
	}
	Children.clear();

}
void NonTerminalNode::Remove()
{

}
void TerminalNode::Remove()
{

}
void  SyncNode::Remove()
{

}
void SemActionNode::Remove()
{

}
void OredNode::PrintFile(ofstream* of,ParserGenerator* P)
{
	int i=0;
	for(list<GenericCFGNode*>::iterator Iter= Children.begin();Iter!=Children.end();Iter++)
	{
		(*Iter)->PrintFile(of,P);
		i++;
		list<GenericCFGNode*>::iterator CIter = Iter;
		CIter++;
		if(CIter!=Children.end())
		{
			(*of)<<" | ";
			if(i%3==0)
			{
				(*of)<<endl;
				i=0;
			}			
		}
	}
}
void AndedNode::PrintFile(ofstream* of,ParserGenerator* P)
{
	int i=0;
	for(list<GenericCFGNode*>::iterator Iter= Children.begin();Iter!=Children.end();Iter++)
	{
		if(this->ResolverString!="")
		{
			(*of)<<" IF (. "<<ResolverString<<" ) ";
		}
		(*Iter)->PrintFile(of,P);
		i++;
		list<GenericCFGNode*>::iterator CIter = Iter;
		CIter++;
		if(CIter!=Children.end())
		{
			(*of)<<" ";	
		}
	}
}
void NonTerminalNode::PrintFile(ofstream* of,ParserGenerator* P)
{

	(*of)<<P->GetNonTerminalName(NameIndex);
	if(Attributes!="")
	{
		(*of)<<" (. "<<Attributes<<" .) ";
	}
}
void TerminalNode::PrintFile(ofstream* of,ParserGenerator* P)
{
	(*of)<<P->GetTerminalName(NameIndex);
}
void SyncNode::PrintFile(ofstream* of,ParserGenerator* P)
{
	(*of)<<"SYNC";
}
void SemActionNode::PrintFile(ofstream* of,ParserGenerator* P)
{
	(*of)<<"<. "; 
	(*of)<<this->SemAction;
	(*of)<<" .>";
}