#pragma once
#include "stdafx.h"
//#include "ParserGen.h"
#include "globals.h"
#include<fstream>

using namespace std;

namespace RDParserGenerator
{
	class ParserGenerator;
	class OredNode;
	class ClosureNode;
	class OptionNode;
	class AndedNode;
	class SemActionNode;
	class TerminalNode;
	class NonTerminalNode;

	class ICodeGenerator
	{
	public:
		void virtual GenerateCode( ParserGenerator* parser ) = 0;
		void virtual OrGenerator( OredNode* node ) = 0;
		void virtual ClosureGenerator( ClosureNode* node ) = 0;
		void virtual OptionalGenerator( OptionNode* node ) = 0;
		void virtual AndGenerator( AndedNode* node ) = 0;
		void virtual SemActionGenerator( SemActionNode* node ) = 0;
		void virtual TerminalGenerator( TerminalNode* node ) = 0;
		void virtual NonTerminalGenerator( NonTerminalNode* node ) = 0;

	protected:
		ofstream DefinitionFile;
		ParserGenerator* Parser;
	};
}