#pragma once
#include "stdafx.h"
#include "Scanner.h"
#include "Globals.h"
//#include "ProductionRule.h"
//#include "GenericCFGNode.h"
//#include <list>
#include <vector>
//#include <map>

#include "BitSet_Min.h"
#include "stdafx.h"
//#include <fstream> 
using namespace std;

namespace RDParserGenerator
{
	class GenericCFGNode;
	class OredNode;
	class ClosureNode;
	class OptionNode;
	//class BracketNode;
	class AndedNode;
	class SemActionNode;
	class TerminalNode;
	class NonTerminalNode;
	class AnyNode;
	class SyncNode;

	class ProductionRule;
	class location
	{
	public:
		int lin_No;
		int Col_No;
		location(int l,int c);

	};
	class TerminalEntry
	{
	public:
		unsigned int NameIndex;
		BitSet_Min* FirstSet;
		TokenType Type;
		vector<location> locations ;
		bool used;
		TerminalEntry();
		TerminalEntry(unsigned int NI,TokenType T,bool u = false);
	};
	class NonTerminalEntry
	{
	public:
		unsigned int NameIndex;
		BitSet_Min* FirstSet;
		BitSet_Min* FollowSet;
		bool Defined;
		bool reachable;
		ProductionRule* Rule;
		vector<location> locations;
		NonTerminalEntry();
		NonTerminalEntry(unsigned int NI,bool defined = false);

	};
	
	class ParserGenerator
	{
	private:
		void CalculateFirstSetS();
		void CalculateFollowSetS();
		int Braces;
		int Brackets;
		int SquareBrakets;
		tstring filename;
		
		
	public:
		ParserGenerator(string fileName);
		void Parse();
		void OptionsSet();
		void TokensSet();
		void TopOfDeclaration();
		void TopOfDefinition();
		void BottomOfDeclaration();
		void BottomOfDefinition();
		void Productions();
		void Expression(GenericCFGNode** node1,bool reachable);
		void Term(GenericCFGNode** node1,bool reachable);
		void Factor(GenericCFGNode** node1,bool reachable);
		void PrintFirstSet();
		void PrintFollowSets();
		void PrintRules();
		void CheckSemErrors();
		void PrintErrors();
		void ParserGenerator::PrintFile(string filename);
		tstring GetNonTerminalName( unsigned int NameIndex );
		tstring GetTerminalName(unsigned int NameIndex);
		~ParserGenerator();
		
		Scanner* scanner;
		tstring StrNameSpace;
		tstring StrClassName;
		TokenType ParserLanguage;
		//Peace of Codes
		tstring StrDecTop;
		tstring StrDecBottom;
		tstring StrDefTop;
		tstring StrDefBottom;
		//Terminals & Noin Terminals
		map<tstring,TerminalEntry> Terminals;
		//map<unsigned int,TerminalEntry*> TerminalsInverse;
		map<tstring,NonTerminalEntry> NonTerminals;
		//map<unsigned int,NonTerminalEntry*> NonTerminalsInverse;
		//LineErrorEntry lineError; //LineErrorEntry<ColNo,tstriing Error>
		map<int,LineErrorEntry> FileErrors;
		unsigned int nextTerminalIndex, nextNonTerminalIndex;
		//the Grammer
		list<ProductionRule*> Grammer;	
		list<ProductionRule*> New_Grammar;
		//CodeGeneration Additions Begin
		map<unsigned int, tstring> TokensNames;
		//CodeGeneration Additions End
		bool StartSymbolFound;

		bool HasErrors;
		bool ResumeOnError;
		int NumberOfErrors;
		//ofstream Errors_File;
	protected:
		void match(TokenType expected,string ErrorMsg="",bool Resume=true);
		void onError(tstring errorMsg);
		
		Token token,la1,la2;
		void LeftFactor();		
	};
}
