



namespace AMAP
{
	public class Parser
	{
		public Parser( IScanner lexicalAnalyzer )
		{
			scanner = lexicalAnalyzer; 
		} 

		public void program()
		{
			match( _TokenType._start );
			statementpart();
			match( _TokenType._finish );
		}
		public void statementpart()
		{
			compoundstatement();
		}
		public void compoundstatement()
		{
			statementsequence();
		}
		public void statementsequence()
		{
			statement();
			spes();
		}
		public void spes()
		{
			if ( currentToken.TokenType == _TokenType._typeface || currentToken.TokenType == _TokenType._slice || currentToken.TokenType == _TokenType._learn || currentToken.TokenType == _TokenType._get || currentToken.TokenType == _TokenType._recognize )
			{
			statement();
			spes();
			}
		}
		public void statement()
		{
			if ( currentToken.TokenType == _TokenType._typeface )
			{
			match( _TokenType._typeface );
			match( _TokenType._openBracket );
			match( _TokenType._digit );
			match( _TokenType._closeBracket );
			}
			else if ( currentToken.TokenType == _TokenType._slice )
			{
			match( _TokenType._slice );
			match( _TokenType._openBracket );
			match( _TokenType._digit );
			match( _TokenType._digit );
			match( _TokenType._closeBracket );
			}
			else if ( currentToken.TokenType == _TokenType._learn )
			{
			match( _TokenType._learn );
			}
			else if ( currentToken.TokenType == _TokenType._get )
			{
			match( _TokenType._get );
			}
			else if ( currentToken.TokenType == _TokenType._recognize )
			{
			match( _TokenType._recognize );
			}
			else
				SyntaxError(currentToken);
		}

		public void Parse() 
		{
			currentToken = scanner.GetNextToken();
			program();
			if ( currentToken.TokenType != _TokenType._EOF )
				SyntaxError(currentToken);
		}
		protected void match( _TokenType expected )
		{
			if ( currentToken.TokenType == expected )
				currentToken = scanner.GetNextToken();
			else
				ErrorHandler( expected, currentToken );
		}

		protected void ErrorHandler( _TokenType expected, Token found )
		{
			 // Write your own error handling here 
		}

		protected void SyntaxError( Token errorAtToken )
		{
			 // Write your own error handling here 
		}

		Token currentToken;
		IScanner scanner;


	}



	public enum _TokenType
	{
		_EOF, _start, _finish, _typeface, _slice, _learn, _get, _recognize, _digit, _openBracket, _closeBracket
	}
	public interface IScanner
	{
		Token GetNextToken();
	}
	public class Token
	{
		public _TokenType TokenType;
		public string Lexeme;

		public Token(){}
		public Token( _TokenType type, string lexeme)
		{
			this.TokenType = type;
			this.Lexeme = lexeme;
		}
	}

}

