
/*TopOfDeclaration Code*/


namespace system
{
	public class ParserGen
	{
		public ParserGen( IScanner lexicalAnalyzer )
		{
			scanner = lexicalAnalyzer; 
		} 

		public void Start()
		{
			if ( currentToken.TokenType == _TokenType._NameSpace || currentToken.TokenType == _TokenType._ClassName || currentToken.TokenType == _TokenType._Language )
			{
			OptionSet();
			}
			if ( currentToken.TokenType == _TokenType._Tokens )
			{
			TokenSet();
			}
			while ( currentToken.TokenType == _TokenType._TopOfDeclaration || currentToken.TokenType == _TokenType._BottomOfDeclaration || currentToken.TokenType == _TokenType._TopOfDefinition || currentToken.TokenType == _TokenType._BottomOfDefinition )
			{
							if ( currentToken.TokenType == _TokenType._TopOfDeclaration )
			{
			TDec();
			}
			else if ( currentToken.TokenType == _TokenType._TopOfDefinition )
			{
			TDef();
			}
			else if ( currentToken.TokenType == _TokenType._BottomOfDeclaration )
			{
			BDec();
			}
			else if ( currentToken.TokenType == _TokenType._BottomOfDefinition )
			{
			BDef();
			}
			else
				SyntaxError(currentToken);
			}
			MyGrammar();
		}
		public void OptionSet()
		{
			if ( currentToken.TokenType == _TokenType._NameSpace )
			{
			match( _TokenType._NameSpace );
			match( _TokenType._Equal );
			match( _TokenType._String );
			}
			if ( currentToken.TokenType == _TokenType._ClassName )
			{
			match( _TokenType._ClassName );
			match( _TokenType._Equal );
			match( _TokenType._String );
			}
			if ( currentToken.TokenType == _TokenType._Language )
			{
			match( _TokenType._Language );
			match( _TokenType._Equal );
			match( _TokenType._ID );
			}
		}
		public void TokenSet()
		{
			match( _TokenType._Tokens );
			while ( currentToken.TokenType == _TokenType._String || currentToken.TokenType == _TokenType._ID )
			{
							if ( currentToken.TokenType == _TokenType._ID )
			{
			match( _TokenType._ID );
			}
			else if ( currentToken.TokenType == _TokenType._String )
			{
			match( _TokenType._String );
			}
			else
				SyntaxError(currentToken);
			}
		}
		public void TDec()
		{
			match( _TokenType._TopOfDeclaration );
			while ( currentToken.TokenType == _TokenType._ANY )
			{
							match( _TokenType._ANY );
			}
		}
		public void TDef()
		{
			match( _TokenType._TopOfDefinition );
			while ( currentToken.TokenType == _TokenType._ANY )
			{
							match( _TokenType._ANY );
			}
		}
		public void BDec()
		{
			match( _TokenType._BottomOfDeclaration );
			while ( currentToken.TokenType == _TokenType._ANY )
			{
							match( _TokenType._ANY );
			}
		}
		public void BDef()
		{
			match( _TokenType._BottomOfDefinition );
			while ( currentToken.TokenType == _TokenType._ANY )
			{
							match( _TokenType._ANY );
			}
		}
		public void MyGrammar()
		{
			match( _TokenType._Grammar );
			while ( currentToken.TokenType == _TokenType._String || currentToken.TokenType == _TokenType._ID )
			{
							if ( currentToken.TokenType == _TokenType._ID )
			{
			match( _TokenType._ID );
			}
			else if ( currentToken.TokenType == _TokenType._String )
			{
			match( _TokenType._String );
			}
			else
				SyntaxError(currentToken);
			match( _TokenType._Production );
			Expression();
			match( _TokenType._Dot );
			}
		}
		public void Expression( int x,int y )
		{
			Term();
			while ( currentToken.TokenType == _TokenType._Or )
			{
							match( _TokenType._Or );
			Term();
			}
			 string s= ""; 
		}
		public void Term()
		{
			if ( currentToken.TokenType == _TokenType._IF )
			{
			Resolver();
			}
			Factor();
			while ( currentToken.TokenType == _TokenType._OpenBracket || currentToken.TokenType == _TokenType._OpenOption || currentToken.TokenType == _TokenType._OpenClosure || currentToken.TokenType == _TokenType._SYNC || currentToken.TokenType == _TokenType._Symbol || currentToken.TokenType == _TokenType._OpenAction || currentToken.TokenType == _TokenType._ANY )
			{
							Factor();
			}
		}
		public void Factor()
		{
			if ( currentToken.TokenType == _TokenType._Symbol )
			{
			match( _TokenType._Symbol );
			if ( currentToken.TokenType == _TokenType._OpenAttr )
			{
			Attributes();
			}
			}
			else if ( currentToken.TokenType == _TokenType._OpenBracket )
			{
			match( _TokenType._OpenBracket );
			Expression( x,y );
			match( _TokenType._CloseBracket );
			}
			else if ( currentToken.TokenType == _TokenType._OpenOption )
			{
			match( _TokenType._OpenOption );
			Expression( z,u );
			match( _TokenType._CloseOption );
			}
			else if ( currentToken.TokenType == _TokenType._OpenClosure )
			{
			match( _TokenType._OpenClosure );
			Expression( l,m );
			match( _TokenType._CloseClosure );
			}
			else if ( currentToken.TokenType == _TokenType._ANY )
			{
			match( _TokenType._ANY );
			}
			else if ( currentToken.TokenType == _TokenType._SYNC )
			{
			match( _TokenType._SYNC );
			}
			else if ( currentToken.TokenType == _TokenType._OpenAction )
			{
			SemAction();
			}
			else
				SyntaxError(currentToken);
		}
		public void Attributes()
		{
			match( _TokenType._OpenAttr );
			while ( currentToken.TokenType == _TokenType._ANY )
			{
							match( _TokenType._ANY );
			}
			match( _TokenType._CloseAttr );
		}
		public void SemAction()
		{
			match( _TokenType._OpenAction );
			while ( currentToken.TokenType == _TokenType._ANY )
			{
							match( _TokenType._ANY );
			}
			match( _TokenType._CloseAction );
		}
		public void Resolver()
		{
			match( _TokenType._IF );
			match( _TokenType._OpenBracket );
			while ( currentToken.TokenType == _TokenType._ANY )
			{
							match( _TokenType._ANY );
			}
			match( _TokenType._CloseBracket );
		}

		public void Parse() 
		{
			currentToken = scanner.GetNextToken();
			Start();
			if ( currentToken.TokenType != _TokenType._EOF )
				SyntaxError(currentToken);
		}
		protected void match( _TokenType expected )
		{
			if ( currentToken.TokenType == expected )
				currentToken = scanner.GetNextToken();
			else
				ErrorHandler( expected, currentToken );
		}

		protected void ErrorHandler( _TokenType expected, Token found )
		{
			 // Write your own error handling here 
		}

		protected void SyntaxError( Token errorAtToken )
		{
			 // Write your own error handling here 
		}

		Token currentToken;
		IScanner scanner;

/*BottomOfDefinition Code*/

	}


/*TopOfDefinition code*/

	public enum _TokenType
	{
		_EOF, _Char, _String, _Ident, _OpenBracket, _CloseBracket, _OpenOption, _CloseOption, _OpenClosure, _CloseClosure, _Integer, _ANY, _SYNC, _Symbol, _Or, _OpenAttr, _CloseAttr, _OpenAction, _CloseAction, _IF, _Options, _Tokens, _TopOfDeclaration, _BottomOfDeclaration, _TopOfDefinition, _BottomOfDefinition, _Grammar, _NameSpace, _ClassName, _Language, _Equal, _String, _ID, _Production, _Dot, _ANY
	}
	public interface IScanner
	{
		Token GetNextToken();
	}
	public class Token
	{
		public _TokenType TokenType;
		public string Lexeme;

		public Token(){}
		public Token( _TokenType type, string lexeme)
		{
			this.TokenType = type;
			this.Lexeme = lexeme;
		}
	}

}

/*BottomOfDeclaration code*/
