
/*TopOfDeclaration Code*/


package system;

/*TopOfDefinition code*/

public class ParserGen
{

/*BottomOfDefinition Code*/

	public ParserGen( IScanner lexicalAnalyzer )
	{
		scanner = lexicalAnalyzer; 
	}
	public void Start()
	{
		if ( currentToken.TokenType == _Options )
		{
		OptionSet();
		}
		while ( currentToken.TokenType == _Tokens )
		{
					TokenSet();
		}
		while ( currentToken.TokenType == _TopOfDeclaration || currentToken.TokenType == _BottomOfDeclaration || currentToken.TokenType == _TopOfDefinition || currentToken.TokenType == _BottomOfDefinition )
		{
					if ( currentToken.TokenType == _TopOfDeclaration )
		{
		TDec();
		}
		else if ( currentToken.TokenType == _TopOfDefinition )
		{
		TDef();
		}
		else if ( currentToken.TokenType == _BottomOfDeclaration )
		{
		BDec();
		}
		else if ( currentToken.TokenType == _BottomOfDefinition )
		{
		BDef();
		}
		else
			SyntaxError(currentToken);
		}
		MyGrammar();
	}
	public void OptionSet()
	{
		match( _Options );
		if ( currentToken.TokenType == _NameSpace )
		{
		match( _NameSpace );
		match( _Equal );
		match( _String );
		}
		if ( currentToken.TokenType == _ClassName )
		{
		match( _ClassName );
		match( _Equal );
		match( _String );
		}
		if ( currentToken.TokenType == _Language )
		{
		match( _Language );
		match( _Equal );
		match( _ID );
		}
	}
	public void TokenSet()
	{
		match( _Tokens );
		while ( currentToken.TokenType == _String || currentToken.TokenType == _ID )
		{
					if ( currentToken.TokenType == _ID )
		{
		match( _ID );
		}
		else if ( currentToken.TokenType == _String )
		{
		match( _String );
		}
		else
			SyntaxError(currentToken);
		}
	}
	public void TDec()
	{
		match( _TopOfDeclaration );
		while ( currentToken.TokenType == _ANY )
		{
					match( _ANY );
		}
	}
	public void TDef()
	{
		match( _TopOfDefinition );
		while ( currentToken.TokenType == _ANY )
		{
					match( _ANY );
		}
	}
	public void BDec()
	{
		match( _BottomOfDeclaration );
		while ( currentToken.TokenType == _ANY )
		{
					match( _ANY );
		}
	}
	public void BDef()
	{
		match( _BottomOfDefinition );
		while ( currentToken.TokenType == _ANY )
		{
					match( _ANY );
		}
	}
	public void MyGrammar()
	{
		match( _Grammar );
		while ( currentToken.TokenType == _String || currentToken.TokenType == _ID )
		{
					if ( currentToken.TokenType == _ID )
		{
		match( _ID );
		}
		else if ( currentToken.TokenType == _String )
		{
		match( _String );
		}
		else
			SyntaxError(currentToken);
		match( _Production );
		Expression();
		match( _Dot );
		}
	}
	public void Expression( int x,int y )
	{
		Term();
		while ( currentToken.TokenType == _Or )
		{
					match( _Or );
		Term();
		}
		 string s= ""; 	}
	public void Term()
	{
		if ( currentToken.TokenType == _IF )
		{
		Resolver();
		}
		Factor();
		while ( currentToken.TokenType == _OpenBracket || currentToken.TokenType == _OpenOption || currentToken.TokenType == _OpenClosure || currentToken.TokenType == _ANY || currentToken.TokenType == _SYNC || currentToken.TokenType == _Symbol || currentToken.TokenType == _OpenAction )
		{
					Factor();
		}
	}
	public void Factor()
	{
		if ( currentToken.TokenType == _Symbol )
		{
		match( _Symbol );
		if ( currentToken.TokenType == _OpenAttr )
		{
		Attributes();
		}
		}
		else if ( currentToken.TokenType == _OpenBracket )
		{
		match( _OpenBracket );
		Expression( x,y );
		match( _CloseBracket );
		}
		else if ( currentToken.TokenType == _OpenOption )
		{
		match( _OpenOption );
		Expression( z,u );
		match( _CloseOption );
		}
		else if ( currentToken.TokenType == _OpenClosure )
		{
		match( _OpenClosure );
		Expression( l,m );
		match( _CloseClosure );
		}
		else if ( currentToken.TokenType == _ANY )
		{
		match( _ANY );
		}
		else if ( currentToken.TokenType == _SYNC )
		{
		match( _SYNC );
		}
		else if ( currentToken.TokenType == _OpenAction )
		{
		SemAction();
		}
		else
			SyntaxError(currentToken);
	}
	public void Attributes()
	{
		match( _OpenAttr );
		while ( currentToken.TokenType == _ANY )
		{
					match( _ANY );
		}
		match( _CloseAttr );
	}
	public void SemAction()
	{
		match( _OpenAction );
		while ( currentToken.TokenType == _ANY )
		{
					match( _ANY );
		}
		match( _CloseAction );
	}
	public void Resolver()
	{
		match( _IF );
		match( _OpenBracket );
		while ( currentToken.TokenType == _ANY )
		{
					match( _ANY );
		}
		match( _CloseBracket );
		NT();
	}
	public void NT()
	{
		match( _OpenBracket );
		match( _Hello );
		K();
	}
	public void K()
	{
		match( _OpenAction );
		A();
		match( _CloseBracket );
		match( _Hello );
	}
	public void A()
	{
		match( _ANY );
	}

	public void Parse() 
	{
		currentToken = scanner.GetNextToken();
		Start();
		if ( currentToken.TokenType != _EOF )
		SyntaxError(currentToken);
	}
	protected void match( int expected )
	{
		if ( currentToken.TokenType == expected )
			currentToken = scanner.GetNextToken();
		else
			ErrorHandler( expected, currentToken );
	}

	protected void ErrorHandler( int expected, Token found )
	{
		 // Write your own error handling here 
	}

	protected void SyntaxError( Token errorAtToken )
	{
		 // Write your own error handling here 
	}

	protected Token currentToken;
	protected IScanner scanner;
	public final int _EOF = 0;
	public final int _OpenBracket = 1;
	public final int _CloseBracket = 2;
	public final int _OpenOption = 3;
	public final int _CloseOption = 4;
	public final int _OpenClosure = 5;
	public final int _CloseClosure = 6;
	public final int _ANY = 7;
	public final int _SYNC = 8;
	public final int _Symbol = 9;
	public final int _Or = 10;
	public final int _OpenAttr = 11;
	public final int _CloseAttr = 12;
	public final int _OpenAction = 13;
	public final int _CloseAction = 14;
	public final int _IF = 15;
	public final int _Options = 16;
	public final int _Tokens = 17;
	public final int _TopOfDeclaration = 18;
	public final int _BottomOfDeclaration = 19;
	public final int _TopOfDefinition = 20;
	public final int _BottomOfDefinition = 21;
	public final int _Grammar = 22;
	public final int _NameSpace = 23;
	public final int _ClassName = 24;
	public final int _Language = 25;
	public final int _Equal = 26;
	public final int _String = 27;
	public final int _ID = 28;
	public final int _Production = 29;
	public final int _Dot = 30;
	public final int _Hello = 31;

}
interface IScanner
{
	Token GetNextToken();
}
class Token
{
	public int TokenType;
}


/*BottomOfDeclaration code*/
