#pragma once
#ifndef _GenericCFGNode_h
#define _GenericCFGNode_h
#include "Globals.h"
#include "stdafx.h"
#include "BitSet_Min.h"
#include "Scanner.h"
//#include "ICodeGenerator.h" //it includes ParserGen.h
#include "ParserGen.h"
#include <list>
using namespace std;
//using namespace RDParserGenerator;
namespace RDParserGenerator
{
	class ParserGenerator;
	class ICodeGenerator;
class GenericCFGNode
{
public:
	NodeType NType;
	virtual BitSet_Min FirstSet(ParserGenerator* P);
	virtual bool FollowSet(ParserGenerator* P);
	virtual BitSet_Min GetNonTerminals(ParserGenerator* P);
	void virtual Print(ParserGenerator* P)=0;
	virtual list<int>* GetIndeces(ParserGenerator*P,tstring NTName,int* Fn_count);
	tstring virtual check_LL1(ParserGenerator* P)=0;
	virtual bool LeadToTerminal(ParserGenerator* P,list<unsigned int> LHSs)=0;

};
class OredNode:public GenericCFGNode
{
public:
	list<GenericCFGNode*> Children;
	OredNode();
	virtual BitSet_Min FirstSet(ParserGenerator* P);
	virtual bool FollowSet(ParserGenerator* P);
	virtual BitSet_Min GetNonTerminals(ParserGenerator* P);
	tstring virtual check_LL1(ParserGenerator* P);
	void virtual Print(ParserGenerator* P);
	virtual bool LeadToTerminal(ParserGenerator* P,list<unsigned int> LHSs);

};


class ClosureNode:public OredNode
{
public:
	ClosureNode();
	virtual BitSet_Min FirstSet(ParserGenerator* P);
	virtual bool FollowSet(ParserGenerator* P);
	virtual BitSet_Min GetNonTerminals(ParserGenerator* P);
	void virtual Print(ParserGenerator* P);
	tstring virtual check_LL1(ParserGenerator* P);
	//bool LeadToTerminal(ParserGenerator* P,unsigned int LHS);
	virtual bool LeadToTerminal(ParserGenerator* P,list<unsigned int> LHSs);

};

class OptionNode:public OredNode
{
public:
	
	OptionNode();
	virtual BitSet_Min FirstSet(ParserGenerator* P);
	virtual bool FollowSet(ParserGenerator* P);
	virtual BitSet_Min GetNonTerminals(ParserGenerator* P);
	void virtual Print(ParserGenerator* P);
	tstring virtual check_LL1(ParserGenerator* P);
	//bool LeadToTerminal(ParserGenerator* P,unsigned int LHS);
	virtual bool LeadToTerminal(ParserGenerator* P,list<unsigned int> LHSs);
};
/*
class BracketNode:public OredNode
{
public:	
	BracketNode()
	{
		this->NType = _Brackets;
	}
	virtual BitSet_Min FirstSet(ParserGenerator* P)
	{		
		BitSet_Min BS=(*Children.begin())->FirstSet( P);
		return BS;
	}
};*/
class AndedNode:public OredNode
{
public:
	tstring ResolverString;
	AndedNode();
	virtual BitSet_Min FirstSet(ParserGenerator* P);
	virtual bool FollowSet(ParserGenerator* P);
	virtual BitSet_Min GetNonTerminals(ParserGenerator* P);
	void virtual Print(ParserGenerator* P);
	virtual list<int>* GetIndeces(ParserGenerator*P,tstring NTName,int* Fn_count);
	tstring virtual check_LL1(ParserGenerator* P);
	//bool LeadToTerminal(ParserGenerator* P,unsigned int LHS);
	virtual bool LeadToTerminal(ParserGenerator* P,list<unsigned int> LHSs);
};

class SemActionNode:public GenericCFGNode
{
public:
	unsigned int  NameIndex;
	tstring SemAction;
	SemActionNode();
	virtual BitSet_Min FirstSet(ParserGenerator* P);
	virtual BitSet_Min GetNonTerminals(ParserGenerator* P);
	tstring virtual check_LL1(ParserGenerator* P);
	void virtual Print(ParserGenerator* P);
	virtual list<int>* GetIndeces(ParserGenerator*P,tstring NTName,int* Fn_count);
	//bool LeadToTerminal(ParserGenerator* P,unsigned int LHS);
	virtual bool LeadToTerminal(ParserGenerator* P,list<unsigned int> LHSs);
};


class TerminalNode:public GenericCFGNode
{
public:
	unsigned int  NameIndex;
	tstring Attributes;
	RDParserGenerator::TokenType TerminalType;
	bool IsWeak;
	TerminalNode();
	virtual BitSet_Min FirstSet(ParserGenerator* P);
	virtual BitSet_Min GetNonTerminals(ParserGenerator* P);
	void virtual Print(ParserGenerator* P);
	virtual list<int>* GetIndeces(ParserGenerator*P,tstring NTName,int* Fn_count);
	tstring virtual check_LL1(ParserGenerator* P);
	//bool LeadToTerminal(ParserGenerator* P,unsigned int LHS);
	virtual bool LeadToTerminal(ParserGenerator* P,list<unsigned int> LHSs);
};
class NonTerminalNode :public TerminalNode
{
public:
	NonTerminalNode();
	virtual BitSet_Min FirstSet(ParserGenerator* P);
	virtual BitSet_Min GetNonTerminals(ParserGenerator* P);
	void virtual Print(ParserGenerator* P);
	virtual list<int>* GetIndeces(ParserGenerator*P,tstring NTName,int* Fn_count);
	tstring virtual check_LL1(ParserGenerator* P);
	//bool LeadToTerminal(ParserGenerator* P,unsigned int LHS);
	virtual bool LeadToTerminal(ParserGenerator* P,list<unsigned int> LHSs);
};
class AnyNode:public GenericCFGNode//feeha shak
{
public:
	AnyNode();
	virtual BitSet_Min FirstSet(ParserGenerator* P);
	virtual BitSet_Min GetNonTerminals(ParserGenerator* P);
	void virtual Print(ParserGenerator* P);
	tstring virtual check_LL1(ParserGenerator* P);
	//bool LeadToTerminal(ParserGenerator* P,unsigned int LHS);
	virtual bool LeadToTerminal(ParserGenerator* P,list<unsigned int> LHSs);
};
class SyncNode:public GenericCFGNode
{
public:
	SyncNode();
	virtual BitSet_Min FirstSet(ParserGenerator* P);
	virtual BitSet_Min GetNonTerminals(ParserGenerator* P);
	void virtual Print(ParserGenerator* P);
	tstring virtual check_LL1(ParserGenerator* P);
	//bool LeadToTerminal(ParserGenerator* P,unsigned int LHS);
	virtual bool LeadToTerminal(ParserGenerator* P,list<unsigned int> LHSs);

};
}
#endif