#pragma once

#include "stdafx.h"

typedef basic_string< TCHAR >	tstring;
typedef list<tstring> StringList;
typedef basic_ifstream< TCHAR, char_traits< TCHAR > > InputFile;
//typedef list<tstring> stringlist;  
typedef map<int,StringList> LineErrorEntry;

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE 1
#endif



namespace RDParserGenerator
{
	enum TokenType;

	struct Token
	{
	public:
		tstring Lexeme;
		TokenType Type;
		unsigned int LineNo;
		unsigned int ColNo;
	};

	enum TokenType 
	{
		Tokens, Options, NameSpace, ClassName, Language, DeclTop, DeclBottom, //these are the reserved tokens
		DefTop, DefBottom, CPlusPlus, CSharp, Java, Grammar, Weak,Eps,
		Any, Sync, If, BulkOfCode,
		Identifier, String, Character, // these are the rule based tokens
		Production, Or, Dot, Equal, OpenBracket, CloseBracket, OpenSquareBracket, // these are the symbol-based tokens
		CloseSquareBracket, OpenCurly, CloseCurly, Attributes, SemAction, Error, EndOfFile
	};

	enum States
	{
		Start, InIdent, InString, InChar, InProduction, 
		InDot, InOpenBracket, InSemAction, Done, ErrorState, InBulkCode, AttributesState
	};
	enum NodeType {_Anded,_Ored,_Closure,_Brackets,_Optional,_Terminal,_NonTerminal,_AnyNode,_SyncNode,_SemAction};


};