#pragma once
#include "stdafx.h"
#include "Scanner.h"
#include "Globals.h"
//#include "ProductionRule.h"
//#include "GenericCFGNode.h"
#include <list>
#include <map>
#include <vector>

#include "BitSet_Min.h"
#include "stdafx.h"
using namespace std;

namespace RDParserGenerator
{
	class GenericCFGNode;
	class OredNode;
	class ClosureNode;
	class OptionNode;
	//class BracketNode;
	class AndedNode;
	class SemActionNode;
	class TerminalNode;
	class NonTerminalNode;
	class AnyNode;
	class SyncNode;
	
	class ProductionRule;
		class location
	{
	public:
		int lin_No;
		int Col_No;
		location(int l,int c);

	};
	class TerminalEntry
	{
	public:
		unsigned int NameIndex;
		BitSet_Min* FirstSet;
		TokenType Type;
		vector<location> locations ;
		bool used;
		TerminalEntry();
		TerminalEntry(unsigned int NI,TokenType T,bool u = false);
	};
	class NonTerminalEntry
	{
	public:
		unsigned int NameIndex;
		BitSet_Min* FirstSet;
		BitSet_Min* FollowSet;
		bool Defined;
		bool reachable;
		ProductionRule* Rule;
		vector<location> locations;
		NonTerminalEntry();
		NonTerminalEntry(unsigned int NI,bool defined = false);

	};
	class CodeEntry
	{
	public :
			tstring Code;
			tstring FunctionName;
			CodeEntry();
			CodeEntry(tstring C,tstring fn);
	};
	class ParserGenerator
	{
	private:
		void CalculateFirstSetS();
		void CalculateFollowSetS();
		void CheckSemErrors();
		void PrintErrors();
		tstring filename;
	//	int sekoseko;
		int Braces;
		int Brackets;
		int SquareBrakets;
		
	public:
		ParserGenerator(string fileName);
		void Parse();
		void OptionsSet();
		void TokensSet();
		void TopOfDeclaration();
		void TopOfDefinition();
		void BottomOfDeclaration();
		void BottomOfDefinition();
		void Productions();
		void Expression(GenericCFGNode** node1,bool reachable);
		void Term(GenericCFGNode** node1,bool reachable);
		void Factor(GenericCFGNode** node1,bool reachable);
		void PrintFirstSet();
		void PrintFollowSets();
		void PrintRules();
		void GenerateLL1Table();
		void PrintLL1Table();
		tstring GetTerminalName(unsigned int NameIndex);
		tstring GetNonTerminalName( unsigned int NameIndex );
		~ParserGenerator();
		
		Scanner* scanner;
		tstring StrNameSpace;
		tstring StrClassName;
		TokenType ParserLanguage;
		//Peace of Codes
		tstring StrDecTop;
		tstring StrDecBottom;
		tstring StrDefTop;
		tstring StrDefBottom;
		//Terminals & Noin Terminals
		map<tstring,TerminalEntry> Terminals;
		//map<unsigned int,TerminalEntry*> TerminalsInverse;
		map<tstring,NonTerminalEntry> NonTerminals;
		map<unsigned int,CodeEntry> Codes;
		//map<unsigned int,NonTerminalEntry*> NonTerminalsInverse;
		unsigned int nextTerminalIndex, nextNonTerminalIndex,nextCodeIndex;
		//the Grammer
		list<ProductionRule*> Grammer;	
		//GenericCFGNode*** LL1Table;
		list<int>*** LL1Table;//two dimensional Array of list<int>*
		//CodeGeneration Additions Begin
		map<unsigned int, tstring> TokensNames;
		//CodeGeneration Additions End

		map<int,LineErrorEntry> FileErrors;

		bool StartSymbolFound;

		bool HasErrors;
		bool ResumeOnError;
		int NumberOfErrors;

	protected:
		void match(TokenType expected,string ErrorMsg="",bool Resume=true);
		void onError(tstring errorMsg);
		Token token,la1,la2,lasttoken;
		
	};
}
