
/*
TopOfDefinition code
*/

#include "myParser.h"
using namespace system;

/*
BottomOfDefinition Code
*/

template<class IScanner>
void Parser<IScanner>::Parse()
{
	currentToken = scanner.GetNextToken();
	InitializeParser();
	_stack.push( _NonTerminalBase );
	while ( stack.top() != (int)_TokenType._EOF )
	{
		int top = (int)stack.Peek();
		if ( IsTerminal( top ) && top == (int)currentToken.TokenType )
		{
			stack.pop();
			currentToken = scanner.GetNextToken();
		}
		else if ( IsNonTerminal( top ) )
		{
			LL1Entry* entry = LL1Table[top - _NonTerminalBase][(int)currentToken.TokenType - _TerminalBase];
			if ( entry == 0 )
				SyntaxError( currentToken );
			else //generate
			{
				stack.pop();
				for(int i = entry->Length-1; i >= 0; i--)
					stack.push( entry->Production[i] );
			}
		}
		else if ( IsCode( top ) )
		{
			stack.pop();
			(this->*this->voidFunctions[top - _CodeBase])();
		}
	}
	if ( !( stack.top() == (int)_TokenType._EOF && currentToken.TokenType == (int)_TokenType._EOF ) )
		SyntaxError( currentToken );

}
template<class IScanner>
void Parser<IScanner>::InitializeParser()
{
	//Initialize the LL1 table
	LL1Table = new LL1Entry**[5];
	for(int i=0; i < 5; i++)
	{
		LL1Table = new LL1Entry*[6];
	}
	LL1Table[0][0] = 0;
	int temp01[] = {32001, -842150451, 32002, -842150451};
	LL1Table[0][1]->Production = temp01;
	LL1Table[0][1]->Length = 4;
	LL1Table[0][2] = 0;
	LL1Table[0][3] = 0;
	int temp04[] = {32001, -842150451, 32002, -842150451};
	LL1Table[0][4]->Production = temp04;
	LL1Table[0][4]->Length = 4;
	LL1Table[0][5] = 0;
	LL1Table[1][0] = 0;
	int temp11[] = {32003, 32004};
	LL1Table[1][1]->Production = temp11;
	LL1Table[1][1]->Length = 2;
	LL1Table[1][2] = 0;
	LL1Table[1][3] = 0;
	int temp14[] = {32003, 32004};
	LL1Table[1][4]->Production = temp14;
	LL1Table[1][4]->Length = 2;
	LL1Table[1][5] = 0;
	int temp20[] = {};
	LL1Table[2][0]->Production = temp20;
	LL1Table[2][0]->Length = 0;
	LL1Table[2][1] = 0;
	int temp22[] = {2, -842150451, 32001, 32002, -842150451};
	LL1Table[2][2]->Production = temp22;
	LL1Table[2][2]->Length = 5;
	LL1Table[2][3] = 0;
	LL1Table[2][4] = 0;
	int temp25[] = {};
	LL1Table[2][5]->Production = temp25;
	LL1Table[2][5]->Length = 0;
	LL1Table[3][0] = 0;
	int temp31[] = {1};
	LL1Table[3][1]->Production = temp31;
	LL1Table[3][1]->Length = 1;
	LL1Table[3][2] = 0;
	LL1Table[3][3] = 0;
	int temp34[] = {4, 32000, -842150451, 5, -842150451};
	LL1Table[3][4]->Production = temp34;
	LL1Table[3][4]->Length = 5;
	LL1Table[3][5] = 0;
	int temp40[] = {};
	LL1Table[4][0]->Production = temp40;
	LL1Table[4][0]->Length = 0;
	LL1Table[4][1] = 0;
	int temp42[] = {};
	LL1Table[4][2]->Production = temp42;
	LL1Table[4][2]->Length = 0;
	int temp43[] = {3, -842150451, 32003, 32004};
	LL1Table[4][3]->Production = temp43;
	LL1Table[4][3]->Length = 4;
	LL1Table[4][4] = 0;
	int temp45[] = {};
	LL1Table[4][5]->Production = temp45;
	LL1Table[4][5]->Length = 0;

	//Initialize the memeber function pointers
	voidFunctions = new VoidFunction[1];

	voidFunctions[0] = &Parser::exp_0;
}
template<class IScanner>
void Parser<IScanner>::SyntaxError( Token errorAtToken )
{
	 // Write your own error handling here 
}

template<class IScanner>
bool Parser<IScanner>::IsTerminal(int id)
{
	return ( id >= _TerminalBase && id < _NonTerminalBase );
}
template<class IScanner>
bool Parser<IScanner>::IsNonTerminal(int id)
{
	return ( id >= _NonTerminalBase && id < _CodeBase );
}
template<class IScanner>
bool Parser<IScanner>::IsCode(int id)
{
	return ( id >= _CodeBase );
}

		//Grammer embedded code
template<class IScanner>
void Parser<IScanner>::exp_0()
{
	my code 0
}
