#ifndef _Parser
#define _Parser

/*
TopOfDeclaration Code
*/


#include <stack>
namespace system
{
	enum _TokenType
	{
		_EOF, _number, _addop, _mulop, _OpenBracket, _CloseBracket
	};
	struct Token
	{
		int TokenType;
	};
	struct LL1Entry
	{
		int* Production;
		int Length;
	};
	template<class IScanner>
	class Parser
	{
	public:
		Parser( IScanner lexicalAnalyzer ): _TerminalBase(0), _NonTerminalBase(32000), _CodeBase(64000)
		{
			scanner = lexicalAnalyzer; 
		}
		void Parse();

		void InitializeParser();
		void SyntaxError( Token errorAtToken );

	protected:
		bool IsTerminal(int id);
		bool IsNonTerminal(int id);
		bool IsCode(int id);
		Token currentToken;
		IScanner scanner;
		const int _TerminalBase;
		const int _NonTerminalBase;
		const int _CodeBase;
		typedef void (Parser::* VoidFunction)();
		VoidFunction* voidFunctions;
		LL1Entry*** LL1Table;
		std::stack<int> _stack;

		void exp_0();
	};


}

/*
BottomOfDeclaration code
*/

#endif