
/*
TopOfDeclaration Code
*/


package system;
public class Parser
{

/*
TopOfDefinition code
*/

	public Parser( IScanner lexicalAnalyzer )
	{
		scanner = lexicalAnalyzer; 
	}


	public void Parse() 
	{
		currentToken = scanner.GetNextToken();
		InitializeParser();
		stack.push( new Integer( _NonTerminalBase ) );
		while ( ((Integer)stack.peek()).intValue() != _EOF )
		{
			int top = ((Integer)stack.peek()).intValue();
			if ( IsTerminal( top ) && top == (int)currentToken.TokenType )
			{
				stack.pop();
				currentToken = scanner.GetNextToken();
			}
			else if ( IsNonTerminal( top ) )
			{
				int production[] = LL1Table[top - _NonTerminalBase][(int)currentToken.TokenType - _TerminalBase];
				if ( production == null )
					SyntaxError( currentToken );
				else //generate
				{
					stack.pop();
					for(int i = production.length-1; i >= 0; i--)
						stack.push( new Integer( production[i] ) );
				}
			}
			else if ( IsCode( top ) )
			{
				stack.pop();
				callFunctionNumber(top - _CodeBase);
			}
		}
		if ( !( ((Integer)stack.peek()).intValue() == _EOF && currentToken.TokenType == _EOF ) )
			SyntaxError( currentToken );

	}

	void InitializeParser()
	{
		int emptyArr[] = {};
		//Initialize the LL1 table
		LL1Table[0][0] = null;
		int temp01[] = {32001, -842150451, 32002, -842150451};
		LL1Table[0][1] = temp01;
		LL1Table[0][2] = null;
		LL1Table[0][3] = null;
		int temp04[] = {32001, -842150451, 32002, -842150451};
		LL1Table[0][4] = temp04;
		LL1Table[0][5] = null;
		LL1Table[1][0] = null;
		int temp11[] = {32003, 32004};
		LL1Table[1][1] = temp11;
		LL1Table[1][2] = null;
		LL1Table[1][3] = null;
		int temp14[] = {32003, 32004};
		LL1Table[1][4] = temp14;
		LL1Table[1][5] = null;
		int temp20[] = {};
		LL1Table[2][0] = temp20;
		LL1Table[2][1] = null;
		int temp22[] = {2, -842150451, 32001, 32002, -842150451};
		LL1Table[2][2] = temp22;
		LL1Table[2][3] = null;
		LL1Table[2][4] = null;
		int temp25[] = {};
		LL1Table[2][5] = temp25;
		LL1Table[3][0] = null;
		int temp31[] = {1};
		LL1Table[3][1] = temp31;
		LL1Table[3][2] = null;
		LL1Table[3][3] = null;
		int temp34[] = {4, 32000, -842150451, 5, -842150451};
		LL1Table[3][4] = temp34;
		LL1Table[3][5] = null;
		int temp40[] = {};
		LL1Table[4][0] = temp40;
		LL1Table[4][1] = null;
		int temp42[] = {};
		LL1Table[4][2] = temp42;
		int temp43[] = {3, -842150451, 32003, 32004};
		LL1Table[4][3] = temp43;
		LL1Table[4][4] = null;
		int temp45[] = {};
		LL1Table[4][5] = temp45;

	}
	protected void SyntaxError( Token errorAtToken )
	{
		 // Write your own error handling here 
	}

	protected boolean IsTerminal(int id)
	{
		return ( id >= _TerminalBase && id < _NonTerminalBase );
	}
	protected boolean IsNonTerminal(int id)
	{
		return ( id >= _NonTerminalBase && id < _CodeBase );
	}
	protected boolean IsCode(int id)
	{
		return ( id >= _CodeBase );
	}
	Token currentToken;
	IScanner scanner;
	final int _TerminalBase = 0;
	final int _NonTerminalBase = 32000;
	final int _CodeBase = 64000;
	int LL1Table[][][] = new int[5][6][];
	java.util.Stack stack = new java.util.Stack();
	public final int _EOF = 0;
	public final int _number = 1;
	public final int _addop = 2;
	public final int _mulop = 3;
	public final int _OpenBracket = 4;
	public final int _CloseBracket = 5;

	//Grammer embedded code

	protected void exp_0()
	{
		my code 0
	}

	protected void callFunctionNumber( int functionID )
	{
		switch( functionID )
		{
			case 0:
				exp_0();
				break;
		}
	}

/*
BottomOfDefinition Code
*/

}

interface IScanner
{
	Token GetNextToken();
}
class Token
{
	public int TokenType;
}

/*
BottomOfDeclaration code
*/

