
using System.IO;
/*
TopOfDeclaration Code
*/


namespace ArabicLanguageCompiler
{
	public class Parser
	{
		public Parser( IScanner lexicalAnalyzer )
		{
			scanner = lexicalAnalyzer; 
		} 

		public void Program()
		{
				writer = new StreamWriter(new FileStream("Temp.C",FileMode.OpenOrCreate));
	writer.Write( "#include <stdio.h>\r\n" );
	writer.Write( "#include <math.h>\r\n" ); 
    
			while ( currentToken.TokenType == _TokenType._INCLUDE )
			{
							 writer.Write( "#include" );
			match( _TokenType._INCLUDE );
			if ( currentToken.TokenType == _TokenType._STRCON )
			{
			 writer.Write( currentToken.Lexeme ); 
			match( _TokenType._STRCON );
			}
			else if ( currentToken.TokenType == _TokenType._INCCON )
			{
			 writer.Write( currentToken.Lexeme ); 
			match( _TokenType._INCCON );
			}
			else
				SyntaxError(currentToken);
			writer.Write( "\r\n" );
			}
			while ( currentToken.TokenType == _TokenType._INT || currentToken.TokenType == _TokenType._UINT || currentToken.TokenType == _TokenType._REAL || currentToken.TokenType == _TokenType._CHAR || currentToken.TokenType == _TokenType._ID )
			{
							ExtDefinition();
			}
			writer.Close();
		}
		public void ExtDefinition()
		{
			if ( currentToken.TokenType == _TokenType._INT || currentToken.TokenType == _TokenType._UINT || currentToken.TokenType == _TokenType._REAL || currentToken.TokenType == _TokenType._CHAR )
			{
			Type();
			}
			 writer.Write(currentToken.Lexeme);
			match( _TokenType._ID );
			if ( currentToken.TokenType == _TokenType._OpenSquareBracket || currentToken.TokenType == _TokenType._SEMI || currentToken.TokenType == _TokenType._COMMA || currentToken.TokenType == _TokenType._EQUAL )
			{
			VarDeclaration();
			if ( currentToken.TokenType == _TokenType._EQUAL )
			{
			 writer.Write( " = " ); 
			match( _TokenType._EQUAL );
			Initializer();
			}
			while ( currentToken.TokenType == _TokenType._COMMA )
			{
							 writer.Write( ", " ); 
			match( _TokenType._COMMA );
			ExtDeclaration();
			}
			 writer.Write( ";\n" ); 
			match( _TokenType._SEMI );
			}
			else if ( currentToken.TokenType == _TokenType._OpenBracket )
			{
			FunctionDeclaration();
			if ( currentToken.TokenType == _TokenType._SEMI || currentToken.TokenType == _TokenType._COMMA )
			{
			while ( currentToken.TokenType == _TokenType._COMMA )
			{
							 writer.Write( ", " ); 
			match( _TokenType._COMMA );
			ExtDeclaration();
			}
			 writer.Write( ";\n" ); 
			match( _TokenType._SEMI );
			}
			else if ( currentToken.TokenType == _TokenType._INT || currentToken.TokenType == _TokenType._UINT || currentToken.TokenType == _TokenType._REAL || currentToken.TokenType == _TokenType._CHAR || currentToken.TokenType == _TokenType._OpenCurly )
			{
			while ( currentToken.TokenType == _TokenType._INT || currentToken.TokenType == _TokenType._UINT || currentToken.TokenType == _TokenType._REAL || currentToken.TokenType == _TokenType._CHAR )
			{
							Type();
			ExtDeclaration();
			while ( currentToken.TokenType == _TokenType._COMMA )
			{
							 writer.Write( ", " ); 
			match( _TokenType._COMMA );
			ExtDeclaration();
			}
			 writer.Write( ";\n" ); 
			match( _TokenType._SEMI );
			}
			CompoundStatement();
			}
			else
				SyntaxError(currentToken);
			}
			else
				SyntaxError(currentToken);
		}
		public void ExtDeclaration()
		{
			 writer.Write(currentToken.Lexeme);
			match( _TokenType._ID );
			if ( currentToken.TokenType == _TokenType._OpenSquareBracket || currentToken.TokenType == _TokenType._EQUAL )
			{
			VarDeclaration();
			if ( currentToken.TokenType == _TokenType._EQUAL )
			{
			 writer.Write( " = " ); 
			match( _TokenType._EQUAL );
			Initializer();
			}
			}
			else if ( currentToken.TokenType == _TokenType._OpenBracket )
			{
			FunctionDeclaration();
			}
		}
		public void Type()
		{
			if ( currentToken.TokenType == _TokenType._INT )
			{
			 writer.Write( "int " ); 
			match( _TokenType._INT );
			}
			else if ( currentToken.TokenType == _TokenType._UINT )
			{
			 writer.Write( "unsigned int " ); 
			match( _TokenType._UINT );
			}
			else if ( currentToken.TokenType == _TokenType._REAL )
			{
			writer.Write( "float " ); 
			match( _TokenType._REAL );
			}
			else if ( currentToken.TokenType == _TokenType._CHAR )
			{
			 writer.Write( currentToken.Lexeme ); 
			match( _TokenType._CHAR );
			}
			else
				SyntaxError(currentToken);
		}
		public void VarDeclaration()
		{
			if ( currentToken.TokenType == _TokenType._OpenSquareBracket )
			{
			 writer.Write( "[" ); 
			match( _TokenType._OpenSquareBracket );
			if ( currentToken.TokenType == _TokenType._INT || currentToken.TokenType == _TokenType._UINT || currentToken.TokenType == _TokenType._REAL || currentToken.TokenType == _TokenType._CHAR || currentToken.TokenType == _TokenType._OpenBracket || currentToken.TokenType == _TokenType._ID || currentToken.TokenType == _TokenType._FCON || currentToken.TokenType == _TokenType._ICON || currentToken.TokenType == _TokenType._STRCON || currentToken.TokenType == _TokenType._MUL || currentToken.TokenType == _TokenType._MINUS || currentToken.TokenType == _TokenType._AND || currentToken.TokenType == _TokenType._UNOP || currentToken.TokenType == _TokenType._NOT || currentToken.TokenType == _TokenType._INCOP || currentToken.TokenType == _TokenType._DECOP )
			{
			ConstExp();
			}
			 writer.Write( "]" ); 
			match( _TokenType._CloseSquareBracket );
			}
		}
		public void FunctionDeclaration()
		{
			 writer.Write( "(" ); 
			match( _TokenType._OpenBracket );
			if ( currentToken.TokenType == _TokenType._INT || currentToken.TokenType == _TokenType._UINT || currentToken.TokenType == _TokenType._REAL || currentToken.TokenType == _TokenType._CHAR || currentToken.TokenType == _TokenType._ID )
			{
			if ( currentToken.TokenType == _TokenType._INT || currentToken.TokenType == _TokenType._UINT || currentToken.TokenType == _TokenType._REAL || currentToken.TokenType == _TokenType._CHAR )
			{
			Type();
			}
			 writer.Write(currentToken.Lexeme);
			match( _TokenType._ID );
			VarDeclaration();
			while ( currentToken.TokenType == _TokenType._COMMA )
			{
							 writer.Write( ", " ); 
			match( _TokenType._COMMA );
			if ( currentToken.TokenType == _TokenType._INT || currentToken.TokenType == _TokenType._UINT || currentToken.TokenType == _TokenType._REAL || currentToken.TokenType == _TokenType._CHAR )
			{
			Type();
			}
			 writer.Write(currentToken.Lexeme); 
			match( _TokenType._ID );
			VarDeclaration();
			}
			}
			 writer.Write( ")" ); 
			match( _TokenType._CloseBracket );
			if ( currentToken.TokenType == _TokenType._OpenSquareBracket )
			{
			 writer.Write( "[" ); 
			match( _TokenType._OpenSquareBracket );
			if ( currentToken.TokenType == _TokenType._INT || currentToken.TokenType == _TokenType._UINT || currentToken.TokenType == _TokenType._REAL || currentToken.TokenType == _TokenType._CHAR || currentToken.TokenType == _TokenType._OpenBracket || currentToken.TokenType == _TokenType._ID || currentToken.TokenType == _TokenType._FCON || currentToken.TokenType == _TokenType._ICON || currentToken.TokenType == _TokenType._STRCON || currentToken.TokenType == _TokenType._MUL || currentToken.TokenType == _TokenType._MINUS || currentToken.TokenType == _TokenType._AND || currentToken.TokenType == _TokenType._UNOP || currentToken.TokenType == _TokenType._NOT || currentToken.TokenType == _TokenType._INCOP || currentToken.TokenType == _TokenType._DECOP )
			{
			ConstExp();
			}
			 writer.Write( "]" ); 
			match( _TokenType._CloseSquareBracket );
			}
		}
		public void Initializer()
		{
			if ( currentToken.TokenType == _TokenType._INT || currentToken.TokenType == _TokenType._UINT || currentToken.TokenType == _TokenType._REAL || currentToken.TokenType == _TokenType._CHAR || currentToken.TokenType == _TokenType._OpenBracket || currentToken.TokenType == _TokenType._ID || currentToken.TokenType == _TokenType._FCON || currentToken.TokenType == _TokenType._ICON || currentToken.TokenType == _TokenType._STRCON || currentToken.TokenType == _TokenType._MUL || currentToken.TokenType == _TokenType._MINUS || currentToken.TokenType == _TokenType._AND || currentToken.TokenType == _TokenType._UNOP || currentToken.TokenType == _TokenType._NOT || currentToken.TokenType == _TokenType._INCOP || currentToken.TokenType == _TokenType._DECOP )
			{
			Expression();
			}
			else if ( currentToken.TokenType == _TokenType._OpenCurly )
			{
			 writer.Write( "{\n" ); 
			match( _TokenType._OpenCurly );
			while ( currentToken.TokenType == _TokenType._INT || currentToken.TokenType == _TokenType._UINT || currentToken.TokenType == _TokenType._REAL || currentToken.TokenType == _TokenType._CHAR || currentToken.TokenType == _TokenType._OpenBracket || currentToken.TokenType == _TokenType._OpenCurly || currentToken.TokenType == _TokenType._ID || currentToken.TokenType == _TokenType._FCON || currentToken.TokenType == _TokenType._ICON || currentToken.TokenType == _TokenType._STRCON || currentToken.TokenType == _TokenType._MUL || currentToken.TokenType == _TokenType._MINUS || currentToken.TokenType == _TokenType._AND || currentToken.TokenType == _TokenType._UNOP || currentToken.TokenType == _TokenType._NOT || currentToken.TokenType == _TokenType._INCOP || currentToken.TokenType == _TokenType._DECOP )
			{
							Initializer();
			}
			 writer.Write( "}\n" ); 
			match( _TokenType._CloseCurly );
			}
			else
				SyntaxError(currentToken);
		}
		public void CompoundStatement()
		{
			 writer.Write( "{\n" ); 
			match( _TokenType._OpenCurly );
			while ( currentToken.TokenType == _TokenType._INT || currentToken.TokenType == _TokenType._UINT || currentToken.TokenType == _TokenType._REAL || currentToken.TokenType == _TokenType._CHAR || currentToken.TokenType == _TokenType._IF || currentToken.TokenType == _TokenType._OpenBracket || currentToken.TokenType == _TokenType._OpenCurly || currentToken.TokenType == _TokenType._DO || currentToken.TokenType == _TokenType._SWITCH || currentToken.TokenType == _TokenType._CASE || currentToken.TokenType == _TokenType._WHILE || currentToken.TokenType == _TokenType._FOR || currentToken.TokenType == _TokenType._SEMI || currentToken.TokenType == _TokenType._ID || currentToken.TokenType == _TokenType._BREAK || currentToken.TokenType == _TokenType._CONTINUE || currentToken.TokenType == _TokenType._RETURN || currentToken.TokenType == _TokenType._DEFAULT || currentToken.TokenType == _TokenType._FCON || currentToken.TokenType == _TokenType._ICON || currentToken.TokenType == _TokenType._STRCON || currentToken.TokenType == _TokenType._MUL || currentToken.TokenType == _TokenType._MINUS || currentToken.TokenType == _TokenType._AND || currentToken.TokenType == _TokenType._UNOP || currentToken.TokenType == _TokenType._NOT || currentToken.TokenType == _TokenType._INCOP || currentToken.TokenType == _TokenType._DECOP )
			{
							Statement();
			}
			 writer.Write( "}\n" ); 
			match( _TokenType._CloseCurly );
		}
		public void Statement()
		{
			if ( currentToken.TokenType == _TokenType._INT || currentToken.TokenType == _TokenType._UINT || currentToken.TokenType == _TokenType._REAL || currentToken.TokenType == _TokenType._CHAR || currentToken.TokenType == _TokenType._OpenBracket || currentToken.TokenType == _TokenType._ID || currentToken.TokenType == _TokenType._FCON || currentToken.TokenType == _TokenType._ICON || currentToken.TokenType == _TokenType._STRCON || currentToken.TokenType == _TokenType._MUL || currentToken.TokenType == _TokenType._MINUS || currentToken.TokenType == _TokenType._AND || currentToken.TokenType == _TokenType._UNOP || currentToken.TokenType == _TokenType._NOT || currentToken.TokenType == _TokenType._INCOP || currentToken.TokenType == _TokenType._DECOP )
			{
			Expression();
			 writer.Write( ";\n" ); 
			match( _TokenType._SEMI );
			}
			else if ( currentToken.TokenType == _TokenType._OpenCurly )
			{
			CompoundStatement();
			}
			else if ( currentToken.TokenType == _TokenType._RETURN )
			{
			 writer.Write( "return " ); 
			match( _TokenType._RETURN );
			if ( currentToken.TokenType == _TokenType._INT || currentToken.TokenType == _TokenType._UINT || currentToken.TokenType == _TokenType._REAL || currentToken.TokenType == _TokenType._CHAR || currentToken.TokenType == _TokenType._OpenBracket || currentToken.TokenType == _TokenType._ID || currentToken.TokenType == _TokenType._FCON || currentToken.TokenType == _TokenType._ICON || currentToken.TokenType == _TokenType._STRCON || currentToken.TokenType == _TokenType._MUL || currentToken.TokenType == _TokenType._MINUS || currentToken.TokenType == _TokenType._AND || currentToken.TokenType == _TokenType._UNOP || currentToken.TokenType == _TokenType._NOT || currentToken.TokenType == _TokenType._INCOP || currentToken.TokenType == _TokenType._DECOP )
			{
			Expression();
			}
			 writer.Write( ";\n" ); 
			match( _TokenType._SEMI );
			}
			else if ( currentToken.TokenType == _TokenType._SEMI )
			{
			 writer.Write( ";\n" ); 
			match( _TokenType._SEMI );
			}
			else if ( currentToken.TokenType == _TokenType._SWITCH )
			{
			 writer.Write( "switch " ); 
			match( _TokenType._SWITCH );
			 writer.Write( "( " ); 
			match( _TokenType._OpenBracket );
			Expression();
			 writer.Write( " ) " ); 
			match( _TokenType._CloseBracket );
			CompoundStatement();
			}
			else if ( currentToken.TokenType == _TokenType._CASE )
			{
			 writer.Write( " case " ); 
			match( _TokenType._CASE );
			ConstExp();
			 writer.Write( " : " ); 
			match( _TokenType._COLON );
			}
			else if ( currentToken.TokenType == _TokenType._DEFAULT )
			{
			 writer.Write( " default " ); 
			match( _TokenType._DEFAULT );
			 writer.Write( " : " ); 
			match( _TokenType._COLON );
			}
			else if ( currentToken.TokenType == _TokenType._IF )
			{
			 writer.Write( " if " ); 
			match( _TokenType._IF );
			 writer.Write( " ( " ); 
			match( _TokenType._OpenBracket );
			test();
			 writer.Write( " ) " ); 
			match( _TokenType._CloseBracket );
			Statement();
			if ( currentToken.TokenType == _TokenType._ELSE )
			{
			 writer.Write( " else " ); 
			match( _TokenType._ELSE );
			Statement();
			}
			}
			else if ( currentToken.TokenType == _TokenType._WHILE )
			{
			 writer.Write( " while " ); 
			match( _TokenType._WHILE );
			 writer.Write( " ( " ); 
			match( _TokenType._OpenBracket );
			test();
			 writer.Write( " ) " ); 
			match( _TokenType._CloseBracket );
			Statement();
			}
			else if ( currentToken.TokenType == _TokenType._FOR )
			{
			 writer.Write( " for " ); 
			match( _TokenType._FOR );
			 writer.Write( " ( " ); 
			match( _TokenType._OpenBracket );
			if ( currentToken.TokenType == _TokenType._INT || currentToken.TokenType == _TokenType._UINT || currentToken.TokenType == _TokenType._REAL || currentToken.TokenType == _TokenType._CHAR || currentToken.TokenType == _TokenType._OpenBracket || currentToken.TokenType == _TokenType._ID || currentToken.TokenType == _TokenType._FCON || currentToken.TokenType == _TokenType._ICON || currentToken.TokenType == _TokenType._STRCON || currentToken.TokenType == _TokenType._MUL || currentToken.TokenType == _TokenType._MINUS || currentToken.TokenType == _TokenType._AND || currentToken.TokenType == _TokenType._UNOP || currentToken.TokenType == _TokenType._NOT || currentToken.TokenType == _TokenType._INCOP || currentToken.TokenType == _TokenType._DECOP )
			{
			Expression();
			}
			 writer.Write( "; " ); 
			match( _TokenType._SEMI );
			if ( currentToken.TokenType == _TokenType._INT || currentToken.TokenType == _TokenType._UINT || currentToken.TokenType == _TokenType._REAL || currentToken.TokenType == _TokenType._CHAR || currentToken.TokenType == _TokenType._OpenBracket || currentToken.TokenType == _TokenType._ID || currentToken.TokenType == _TokenType._FCON || currentToken.TokenType == _TokenType._ICON || currentToken.TokenType == _TokenType._STRCON || currentToken.TokenType == _TokenType._MUL || currentToken.TokenType == _TokenType._MINUS || currentToken.TokenType == _TokenType._AND || currentToken.TokenType == _TokenType._UNOP || currentToken.TokenType == _TokenType._NOT || currentToken.TokenType == _TokenType._INCOP || currentToken.TokenType == _TokenType._DECOP )
			{
			test();
			}
			 writer.Write( "; " ); 
			match( _TokenType._SEMI );
			if ( currentToken.TokenType == _TokenType._INT || currentToken.TokenType == _TokenType._UINT || currentToken.TokenType == _TokenType._REAL || currentToken.TokenType == _TokenType._CHAR || currentToken.TokenType == _TokenType._OpenBracket || currentToken.TokenType == _TokenType._ID || currentToken.TokenType == _TokenType._FCON || currentToken.TokenType == _TokenType._ICON || currentToken.TokenType == _TokenType._STRCON || currentToken.TokenType == _TokenType._MUL || currentToken.TokenType == _TokenType._MINUS || currentToken.TokenType == _TokenType._AND || currentToken.TokenType == _TokenType._UNOP || currentToken.TokenType == _TokenType._NOT || currentToken.TokenType == _TokenType._INCOP || currentToken.TokenType == _TokenType._DECOP )
			{
			Expression();
			}
			 writer.Write( ") " ); 
			match( _TokenType._CloseBracket );
			Statement();
			}
			else if ( currentToken.TokenType == _TokenType._DO )
			{
			 writer.Write( " do " ); 
			match( _TokenType._DO );
			Statement();
			 writer.Write( " while " ); 
			match( _TokenType._WHILE );
			 writer.Write( " ( " ); 
			match( _TokenType._OpenBracket );
			test();
			 writer.Write( " ) " ); 
			match( _TokenType._CloseBracket );
			}
			else if ( currentToken.TokenType == _TokenType._BREAK )
			{
			 writer.Write( " break " ); 
			match( _TokenType._BREAK );
			 writer.Write( ";\n" ); 
			match( _TokenType._SEMI );
			}
			else if ( currentToken.TokenType == _TokenType._CONTINUE )
			{
			 writer.Write( " continue " ); 
			match( _TokenType._CONTINUE );
			 writer.Write( ";\n" ); 
			match( _TokenType._SEMI );
			}
			else if ( currentToken.TokenType == _TokenType._INT || currentToken.TokenType == _TokenType._UINT || currentToken.TokenType == _TokenType._REAL || currentToken.TokenType == _TokenType._CHAR )
			{
			Type();
			ExtDeclaration();
			while ( currentToken.TokenType == _TokenType._COMMA )
			{
							 writer.Write( ", " ); 
			match( _TokenType._COMMA );
			ExtDeclaration();
			}
			 writer.Write( ";\n" ); 
			match( _TokenType._SEMI );
			}
			else
				SyntaxError(currentToken);
		}
		public void test()
		{
			Expression();
		}
		public void ConstExp()
		{
			Expression();
		}
		public void Expression()
		{
			nonCommaExpr();
			while ( currentToken.TokenType == _TokenType._COMMA )
			{
							 writer.Write( ", " ); 
			match( _TokenType._COMMA );
			nonCommaExpr();
			}
		}
		public void nonCommaExpr()
		{
			orExpr();
			while ( currentToken.TokenType == _TokenType._EQUAL )
			{
							 writer.Write(currentToken.Lexeme);
			match( _TokenType._EQUAL );
			orExpr();
			}
		}
		public void orExpr()
		{
			andExpr();
			while ( currentToken.TokenType == _TokenType._OROR )
			{
							 writer.Write( " || " ); 
			match( _TokenType._OROR );
			andExpr();
			}
		}
		public void andExpr()
		{
			binary();
			while ( currentToken.TokenType == _TokenType._ANDAND )
			{
							 writer.Write( " && " ); 
			match( _TokenType._ANDAND );
			binary();
			}
		}
		public void binary()
		{
			unary();
			while ( currentToken.TokenType == _TokenType._LT || currentToken.TokenType == _TokenType._LTE || currentToken.TokenType == _TokenType._GT || currentToken.TokenType == _TokenType._GTE || currentToken.TokenType == _TokenType._EQUEQU || currentToken.TokenType == _TokenType._NOTEQU || currentToken.TokenType == _TokenType._DIV || currentToken.TokenType == _TokenType._MUL || currentToken.TokenType == _TokenType._MOD || currentToken.TokenType == _TokenType._PLUS || currentToken.TokenType == _TokenType._MINUS || currentToken.TokenType == _TokenType._SHR || currentToken.TokenType == _TokenType._SHL || currentToken.TokenType == _TokenType._AND || currentToken.TokenType == _TokenType._XOR || currentToken.TokenType == _TokenType._OR )
			{
							BinaryOperator();
			unary();
			}
		}
		public void BinaryOperator()
		{
			if ( currentToken.TokenType == _TokenType._LT )
			{
			 writer.Write( " < " ); 
			match( _TokenType._LT );
			}
			else if ( currentToken.TokenType == _TokenType._LTE )
			{
			 writer.Write( " <= " ); 
			match( _TokenType._LTE );
			}
			else if ( currentToken.TokenType == _TokenType._GT )
			{
			 writer.Write( " > " ); 
			match( _TokenType._GT );
			}
			else if ( currentToken.TokenType == _TokenType._GTE )
			{
			 writer.Write( " >= " ); 
			match( _TokenType._GTE );
			}
			else if ( currentToken.TokenType == _TokenType._EQUEQU )
			{
			 writer.Write( " == " ); 
			match( _TokenType._EQUEQU );
			}
			else if ( currentToken.TokenType == _TokenType._NOTEQU )
			{
			 writer.Write( " != " ); 
			match( _TokenType._NOTEQU );
			}
			else if ( currentToken.TokenType == _TokenType._DIV )
			{
			 writer.Write( " / " ); 
			match( _TokenType._DIV );
			}
			else if ( currentToken.TokenType == _TokenType._MUL )
			{
			 writer.Write( " * " ); 
			match( _TokenType._MUL );
			}
			else if ( currentToken.TokenType == _TokenType._MOD )
			{
			 writer.Write( " % " ); 
			match( _TokenType._MOD );
			}
			else if ( currentToken.TokenType == _TokenType._SHR )
			{
			 writer.Write( " >> " ); 
			match( _TokenType._SHR );
			}
			else if ( currentToken.TokenType == _TokenType._SHL )
			{
			 writer.Write( " << " ); 
			match( _TokenType._SHL );
			}
			else if ( currentToken.TokenType == _TokenType._AND )
			{
			 writer.Write( " & " ); 
			match( _TokenType._AND );
			}
			else if ( currentToken.TokenType == _TokenType._XOR )
			{
			 writer.Write( " ^ " ); 
			match( _TokenType._XOR );
			}
			else if ( currentToken.TokenType == _TokenType._OR )
			{
			 writer.Write( " | " ); 
			match( _TokenType._OR );
			}
			else if ( currentToken.TokenType == _TokenType._PLUS )
			{
			 writer.Write( " + " ); 
			match( _TokenType._PLUS );
			}
			else if ( currentToken.TokenType == _TokenType._MINUS )
			{
			 writer.Write( " - " ); 
			match( _TokenType._MINUS );
			}
			else
				SyntaxError(currentToken);
		}
		public void unary()
		{
			if ( currentToken.TokenType == _TokenType._OpenBracket )
			{
			 writer.Write( " ( " ); 
			match( _TokenType._OpenBracket );
			Expression();
			 writer.Write( " ) " ); 
			match( _TokenType._CloseBracket );
			}
			else if ( currentToken.TokenType == _TokenType._FCON )
			{
			 writer.Write( currentToken.Lexeme ); 
			match( _TokenType._FCON );
			}
			else if ( currentToken.TokenType == _TokenType._ICON )
			{
			 writer.Write( currentToken.Lexeme ); 
			match( _TokenType._ICON );
			}
			else if ( currentToken.TokenType == _TokenType._INT || currentToken.TokenType == _TokenType._UINT || currentToken.TokenType == _TokenType._REAL || currentToken.TokenType == _TokenType._CHAR || currentToken.TokenType == _TokenType._ID || currentToken.TokenType == _TokenType._MUL || currentToken.TokenType == _TokenType._AND )
			{
			if ( currentToken.TokenType == _TokenType._INT || currentToken.TokenType == _TokenType._UINT || currentToken.TokenType == _TokenType._REAL || currentToken.TokenType == _TokenType._CHAR || currentToken.TokenType == _TokenType._MUL || currentToken.TokenType == _TokenType._AND )
			{
			if ( currentToken.TokenType == _TokenType._MUL || currentToken.TokenType == _TokenType._AND )
			{
			 writer.Write(currentToken.Lexeme); 
			if ( currentToken.TokenType == _TokenType._AND )
			{
			match( _TokenType._AND );
			}
			else if ( currentToken.TokenType == _TokenType._MUL )
			{
			match( _TokenType._MUL );
			}
			else
				SyntaxError(currentToken);
			}
			else if ( currentToken.TokenType == _TokenType._INT || currentToken.TokenType == _TokenType._UINT || currentToken.TokenType == _TokenType._REAL || currentToken.TokenType == _TokenType._CHAR )
			{
			Type();
			}
			else
				SyntaxError(currentToken);
			}
			 writer.Write(currentToken.Lexeme); 
			match( _TokenType._ID );
			}
			else if ( currentToken.TokenType == _TokenType._STRCON )
			{
			 writer.Write( currentToken.Lexeme ); 
			match( _TokenType._STRCON );
			}
			else if ( currentToken.TokenType == _TokenType._MINUS || currentToken.TokenType == _TokenType._UNOP || currentToken.TokenType == _TokenType._NOT || currentToken.TokenType == _TokenType._INCOP || currentToken.TokenType == _TokenType._DECOP )
			{
			if ( currentToken.TokenType == _TokenType._MINUS )
			{
			 writer.Write( " - " ); 
			match( _TokenType._MINUS );
			}
			else if ( currentToken.TokenType == _TokenType._UNOP )
			{
			 writer.Write( " ~ " ); 
			match( _TokenType._UNOP );
			}
			else if ( currentToken.TokenType == _TokenType._NOT )
			{
			 writer.Write( " ! " ); 
			match( _TokenType._NOT );
			}
			else if ( currentToken.TokenType == _TokenType._INCOP )
			{
			 writer.Write( "++ " ); 
			match( _TokenType._INCOP );
			}
			else if ( currentToken.TokenType == _TokenType._DECOP )
			{
			 writer.Write( "-- " ); 
			match( _TokenType._DECOP );
			}
			else
				SyntaxError(currentToken);
			unary();
			}
			else
				SyntaxError(currentToken);
			if ( currentToken.TokenType == _TokenType._OpenBracket || currentToken.TokenType == _TokenType._OpenSquareBracket || currentToken.TokenType == _TokenType._INCOP || currentToken.TokenType == _TokenType._DECOP )
			{
			if ( currentToken.TokenType == _TokenType._INCOP )
			{
			 writer.Write( "++ " ); 
			match( _TokenType._INCOP );
			}
			else if ( currentToken.TokenType == _TokenType._DECOP )
			{
			 writer.Write( "-- " ); 
			match( _TokenType._DECOP );
			}
			else if ( currentToken.TokenType == _TokenType._OpenSquareBracket )
			{
			 writer.Write( "[" ); 
			match( _TokenType._OpenSquareBracket );
			Expression();
			 writer.Write( "]" ); 
			match( _TokenType._CloseSquareBracket );
			}
			else if ( currentToken.TokenType == _TokenType._OpenBracket )
			{
			 writer.Write( "(" ); 
			match( _TokenType._OpenBracket );
			if ( currentToken.TokenType == _TokenType._INT || currentToken.TokenType == _TokenType._UINT || currentToken.TokenType == _TokenType._REAL || currentToken.TokenType == _TokenType._CHAR || currentToken.TokenType == _TokenType._OpenBracket || currentToken.TokenType == _TokenType._ID || currentToken.TokenType == _TokenType._FCON || currentToken.TokenType == _TokenType._ICON || currentToken.TokenType == _TokenType._STRCON || currentToken.TokenType == _TokenType._MUL || currentToken.TokenType == _TokenType._MINUS || currentToken.TokenType == _TokenType._AND || currentToken.TokenType == _TokenType._UNOP || currentToken.TokenType == _TokenType._NOT || currentToken.TokenType == _TokenType._INCOP || currentToken.TokenType == _TokenType._DECOP )
			{
			Expression();
			}
			 writer.Write( ")" ); 
			match( _TokenType._CloseBracket );
			}
			else
				SyntaxError(currentToken);
			}
		}

		public void Parse() 
		{
			currentToken = scanner.GetNextToken();
			Program();
			if ( currentToken.TokenType != _TokenType._EOF )
				SyntaxError(currentToken);
		}
		protected void match( _TokenType expected )
		{
			if ( currentToken.TokenType == expected )
				currentToken = scanner.GetNextToken();
			else
				ErrorHandler( expected, currentToken );
		}

		protected void ErrorHandler( _TokenType expected, Token found )
		{
			 // Write your own error handling here 
		}

		protected void SyntaxError( Token errorAtToken )
		{
			 // Write your own error handling here 
		}

		Token currentToken;
		IScanner scanner;

		public System.IO.StreamWriter writer;
		/*System.Collections.Hashtable table = new System.Collections.Hashtable();
		int counter = 0;
		string GetNextIdent(string arabic)
		{
			if ( table.Contains(arabic) )
				return table[arabic].ToString();
			string newVar = "Var" + counter.ToString();
			table.Add( arabic, newVar );
			counter++;
			return newVar;
		}*/
/*
BottomOfDefinition Code
*/

	}


/*
TopOfDefinition code
*/

	public enum _TokenType
	{
		_EOF, _Error, _INT, _UINT, _REAL, _CHAR, _IF, _ELSE, _OpenBracket, _CloseBracket, _OpenCurly, _CloseCurly, _OpenSquareBracket, _CloseSquareBracket, _DO, _SWITCH, _CASE, _WHILE, _FOR, _SEMI, _ID, _BREAK, _CONTINUE, _RETURN, _COLON, _DEFAULT, _COMMA, _OROR, _ANDAND, _FCON, _ICON, _STRCON, _INCLUDE, _INCCON, _EQUAL, _LT, _LTE, _GT, _GTE, _EQUEQU, _NOTEQU, _DIV, _MUL, _MOD, _PLUS, _MINUS, _SHR, _SHL, _AND, _XOR, _OR, _UNOP, _NOT, _INCOP, _DECOP
	}
	public interface IScanner
	{
		Token GetNextToken();
	}
	public class Token
	{
		public _TokenType TokenType;
		public string Lexeme;

		public Token(){}
		public Token( _TokenType type, string lexeme)
		{
			this.TokenType = type;
			this.Lexeme = lexeme;
		}
	}

}

/*
BottomOfDeclaration code
*/
