using System;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace IDE.Forms.CCW
{
    public enum OutputType
    {
        Text,
        Image
    }

    partial class Output : Form
    {
        private Crownwood.DotNetMagic.Controls.ToolControl mainToolBar;
        private Crownwood.DotNetMagic.Controls.Command.ButtonCommand btnSave;
        private Crownwood.DotNetMagic.Controls.Command.ButtonCommand btnCopy;
        private Crownwood.DotNetMagic.Controls.Command.ButtonCommand btnClear;
        private Crownwood.DotNetMagic.Controls.Command.SeparatorCommand separatorCommand;

        private OutputType WindowType;
        public RichTextBox textOutput;
		private PictureBox imageOutput;


		public void SetOutputText(string text)
		{
			textOutput.Text = text;
		}

        public Output(OutputType type)
        {
            InitializeComponent();
            WindowType = type;

            if (type == OutputType.Text)
                imageOutput.Visible = false;
        }

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.IContainer components = null;

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		/// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
		protected override void Dispose(bool disposing)
		{
			if (disposing && (components != null))
			{
				components.Dispose();
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.mainToolBar = new Crownwood.DotNetMagic.Controls.ToolControl();
            this.btnSave = new Crownwood.DotNetMagic.Controls.Command.ButtonCommand();
            this.separatorCommand = new Crownwood.DotNetMagic.Controls.Command.SeparatorCommand();
            this.btnCopy = new Crownwood.DotNetMagic.Controls.Command.ButtonCommand();
            this.btnClear = new Crownwood.DotNetMagic.Controls.Command.ButtonCommand();
            this.textOutput = new System.Windows.Forms.RichTextBox();
            this.imageOutput = new System.Windows.Forms.PictureBox();
            ((System.ComponentModel.ISupportInitialize)(this.mainToolBar)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.imageOutput)).BeginInit();
            this.SuspendLayout();
            // 
            // mainToolBar
            // 
            this.mainToolBar.Commands.AddRange(new Crownwood.DotNetMagic.Controls.Command.CommandBase[] {
            this.btnSave,
            this.separatorCommand,
            this.btnCopy,
            this.btnClear,
            this.separatorCommand});
            this.mainToolBar.EqualButtonHorz = true;
            this.mainToolBar.ImageAndText = Crownwood.DotNetMagic.Controls.Command.ImageAndText.ImageOnly;
            this.mainToolBar.Location = new System.Drawing.Point(0, 0);
            this.mainToolBar.Name = "mainToolBar";
            this.mainToolBar.Size = new System.Drawing.Size(292, 26);
            this.mainToolBar.TabIndex = 9;
            // 
            // btnSave
            // 
            this.btnSave.Image = global::IDE.Properties.Resources.save;
            this.btnSave.Tag = null;
            this.btnSave.Text = "Save";
            this.btnSave.Tooltip = "Save Output Window Contents";
            // 
            // separatorCommand
            // 
            this.separatorCommand.Tag = null;
            // 
            // btnCopy
            // 
            this.btnCopy.Image = global::IDE.Properties.Resources.copy;
            this.btnCopy.Tag = null;
            this.btnCopy.Text = "Copy";
            this.btnCopy.Tooltip = "Copy Output Window Contents to the Clipboard";
            this.btnCopy.Click += new System.EventHandler(this.btnCopy_Click);
            // 
            // btnClear
            // 
            this.btnClear.Image = global::IDE.Properties.Resources.DeleteHS;
            this.btnClear.Tag = null;
            this.btnClear.Text = "Clear";
            this.btnClear.Tooltip = "Clear Output Window";
            this.btnClear.Click += new System.EventHandler(this.btnClear_Click);
            // 
            // textOutput
            // 
            this.textOutput.BackColor = System.Drawing.SystemColors.Window;
            this.textOutput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.textOutput.Font = new System.Drawing.Font("Courier New", 12F);
            this.textOutput.Location = new System.Drawing.Point(0, 26);
            this.textOutput.Name = "textOutput";
            this.textOutput.ReadOnly = true;
            this.textOutput.Size = new System.Drawing.Size(292, 163);
            this.textOutput.TabIndex = 10;
            this.textOutput.Text = "";
            // 
            // imageOutput
            // 
            this.imageOutput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.imageOutput.ErrorImage = null;
            this.imageOutput.Location = new System.Drawing.Point(0, 26);
            this.imageOutput.Name = "imageOutput";
            this.imageOutput.Size = new System.Drawing.Size(292, 163);
            this.imageOutput.TabIndex = 11;
            this.imageOutput.TabStop = false;
            // 
            // Output
            // 
            this.ClientSize = new System.Drawing.Size(292, 189);
            this.Controls.Add(this.imageOutput);
            this.Controls.Add(this.textOutput);
            this.Controls.Add(this.mainToolBar);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
            this.Name = "Output";
            this.Text = "Output";
            ((System.ComponentModel.ISupportInitialize)(this.mainToolBar)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.imageOutput)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		private void btnCopy_Click(object sender, EventArgs e)
		{
			textOutput.Copy();
		}

		private void btnClear_Click(object sender, EventArgs e)
		{
			textOutput.Clear();
		}

    }
}